import { TooltipModule as TooltipModule$1 } from 'ngx-bootstrap';
import { moveItemInArray, DragDropModule } from '@angular/cdk/drag-drop';
import { TooltipModule } from 'ngx-bootstrap/tooltip';
import { BsDropdownModule } from 'ngx-bootstrap/dropdown';
import { CKEditorModule } from '@ckeditor/ckeditor5-angular';
import { FormsModule, FormBuilder, FormControl, FormArray, ReactiveFormsModule } from '@angular/forms';
import { map, debounceTime as debounceTime$1, distinctUntilChanged as distinctUntilChanged$1 } from 'rxjs/operators';
import { debounceTime, distinctUntilChanged, map as map$1 } from 'rxjs/internal/operators';
import * as ClassicEditor from '@ckeditor/ckeditor5-build-classic';
import { BehaviorSubject, fromEvent, Subject } from 'rxjs';
import { NavigationEnd, NavigationError, NavigationStart, Router, RouterModule } from '@angular/router';
import { BrowserAnimationsModule } from '@angular/platform-browser/animations';
import { CommonModule } from '@angular/common';
import { Injectable, Component, ComponentFactoryResolver, Input, ViewChild, NgModule, Directive, ViewContainerRef, Pipe, Output, EventEmitter, defineInjectable, inject } from '@angular/core';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgSurvey {
    /**
     * @param {?=} id
     * @param {?=} name
     * @param {?=} description
     * @param {?=} summary
     * @param {?=} isLoading
     */
    constructor(id, name, description, summary, isLoading) {
        this.id = id;
        this.name = name;
        this.description = description;
        this.summary = summary;
        this.isLoading = isLoading;
        this.id = id ? id : UUID$$1();
        this.name = name ? name : '';
        this.description = description ? description : '';
        this.summary = summary ? summary : '';
        this.isLoading = isLoading ? isLoading : false;
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class PageFlow {
    /**
     * @param {?=} nextPage
     * @param {?=} label
     * @param {?=} pageId
     */
    constructor(nextPage, label, pageId) {
        this.nextPage = nextPage;
        this.label = label;
        this.pageId = pageId;
        this.nextPage = nextPage ? nextPage : true;
        this.label = label ? label : 'pageFlow.goToNextPage';
        this.pageId = pageId ? pageId : '';
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class Page {
    /**
     * @param {?} id
     * @param {?} surveyId
     * @param {?=} orderNo
     * @param {?=} pageFlow
     * @param {?=} name
     * @param {?=} description
     */
    constructor(id, surveyId, orderNo, pageFlow, name, description) {
        this.id = id;
        this.surveyId = surveyId;
        this.orderNo = orderNo;
        this.pageFlow = pageFlow;
        this.name = name;
        this.description = description;
        this.orderNo = orderNo ? orderNo : 1;
        this.pageFlow = pageFlow ? pageFlow : new PageFlow();
        this.name = name ? name : '';
        this.description = description ? description : '';
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class Question {
    /**
     * @param {?=} id
     * @param {?=} text
     * @param {?=} answer
     * @param {?=} type
     * @param {?=} required
     * @param {?=} pageFlowModifier
     * @param {?=} elementId
     * @param {?=} min
     * @param {?=} max
     */
    constructor(id, text, answer, type, required, pageFlowModifier, elementId, min, max) {
        this.id = id;
        this.text = text;
        this.answer = answer;
        this.type = type;
        this.required = required;
        this.pageFlowModifier = pageFlowModifier;
        this.elementId = elementId;
        this.min = min;
        this.max = max;
        this.id = id ? id : UUID$$1();
        this.text = text ? text : '';
        this.answer = answer ? answer : '';
        this.type = type ? type : '';
        this.required = required ? required : false;
        this.pageFlowModifier = pageFlowModifier ? pageFlowModifier : false;
        this.elementId = elementId ? elementId : '';
        this.min = min ? min : null;
        this.max = max ? max : null;
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class Elements {
    /**
     * @param {?} pageId
     * @param {?=} id
     * @param {?=} orderNo
     * @param {?=} type
     * @param {?=} question
     * @param {?=} paragraph
     * @param {?=} isSaved
     * @param {?=} showPageFlowToggle
     */
    constructor(pageId, id, orderNo, type, question, paragraph, isSaved, showPageFlowToggle) {
        this.pageId = pageId;
        this.id = id;
        this.orderNo = orderNo;
        this.type = type;
        this.question = question;
        this.paragraph = paragraph;
        this.isSaved = isSaved;
        this.showPageFlowToggle = showPageFlowToggle;
        /** @type {?} */
        const uuid = UUID$$1();
        /** @type {?} */
        const newQuestion = new Question();
        newQuestion.elementId = uuid;
        this.id = id ? id : uuid;
        this.pageId = pageId ? pageId : '';
        this.orderNo = orderNo ? orderNo : 1;
        this.type = type ? type : 'question';
        this.question = question ? question : newQuestion;
        this.paragraph = paragraph ? paragraph : null;
        this.isSaved = isSaved ? isSaved : false;
        this.showPageFlowToggle = showPageFlowToggle ? showPageFlowToggle : true;
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class OptionAnswers {
    /**
     * @param {?} elementId
     * @param {?=} id
     * @param {?=} orderNo
     * @param {?=} value
     * @param {?=} pageFlow
     * @param {?=} isSaved
     */
    constructor(elementId, id, orderNo, value, pageFlow, isSaved) {
        this.elementId = elementId;
        this.id = id;
        this.orderNo = orderNo;
        this.value = value;
        this.pageFlow = pageFlow;
        this.isSaved = isSaved;
        this.id = id ? id : UUID$$1();
        this.elementId = elementId ? elementId : '';
        this.orderNo = orderNo ? orderNo : 1;
        this.value = value ? value : '';
        this.pageFlow = pageFlow ? pageFlow : new PageFlow();
        this.isSaved = isSaved ? isSaved : false;
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class Paragraph {
    /**
     * @param {?=} id
     * @param {?=} html
     * @param {?=} elementId
     */
    constructor(id, html, elementId) {
        this.id = id;
        this.html = html;
        this.elementId = elementId;
        this.id = id ? id : UUID$$1();
        this.html = html ? html : '';
        this.elementId = elementId ? elementId : '';
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class BuilderOptionsModel {
    /**
     * @param {?=} importSurvey
     * @param {?=} surveyButtons
     * @param {?=} importPage
     * @param {?=} pageButtons
     * @param {?=} importElement
     * @param {?=} elementButtons
     */
    constructor(importSurvey, surveyButtons, importPage, pageButtons, importElement, elementButtons) {
        this.importSurvey = importSurvey;
        this.surveyButtons = surveyButtons;
        this.importPage = importPage;
        this.pageButtons = pageButtons;
        this.importElement = importElement;
        this.elementButtons = elementButtons;
        this.importSurvey = importSurvey ? importSurvey : null;
        this.surveyButtons = surveyButtons ? surveyButtons : null;
        this.importPage = importPage ? importPage : null;
        this.pageButtons = pageButtons ? pageButtons : null;
        this.importElement = importElement ? importElement : null;
        this.elementButtons = elementButtons ? elementButtons : null;
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
const getLastValueInMap$$1 = map$$1 => Array.from(map$$1)[map$$1.size - 1][1];
/** @type {?} */
const arrayToMap$$1 = (array) => array.reduce((map$$1, arrayEl) => map$$1.set(arrayEl[0], arrayEl[1]), new Map());
/** @type {?} */
const moveItemInMap$$1 = (map$$1, index, item) => {
    /** @type {?} */
    let array = Array.from(map$$1);
    if (index > array.length - 1) {
        array.push([item.id, item]);
    }
    else {
        array = array.reduce((newArray, el, idx) => {
            if (idx === index) {
                newArray.push([item.id, item]);
                newArray.push(el);
            }
            else {
                newArray.push(el);
            }
            return newArray;
        }, []);
    }
    return arrayToMap$$1(array);
};
/** @type {?} */
const dragItemInArray$$1 = (map$$1, startIndex, endIndex) => {
    /** @type {?} */
    const array = Array.from(map$$1);
    moveItemInArray(array, startIndex, endIndex);
    return arrayToMap$$1(array);
};
/** @type {?} */
const updateElementPositionInMap$$1 = (map$$1) => Array.from(map$$1).reduce((acc, el) => el[1].orderNo = acc + 1, 0);
/** @type {?} */
const resetNgSurveyState$$1 = () => {
    // Init Survey
    /** @type {?} */
    const angularSurvey = new NgSurvey();
    // Init Pages
    /** @type {?} */
    const pageId = UUID$$1();
    /** @type {?} */
    const page = new Page(pageId, angularSurvey.id);
    /** @type {?} */
    const pageMap = new Map().set(page.id, page);
    // Init Elements
    /** @type {?} */
    const element = new Elements(page.id);
    /** @type {?} */
    const elementMap = new Map().set(element.id, element);
    /** @type {?} */
    const elementsMap = new Map().set(page.id, elementMap);
    // Init Option Answers
    /** @type {?} */
    const optionAnswerMap = new Map();
    /** @type {?} */
    const optionAnswersMap = new Map().set(element.id, optionAnswerMap);
    return {
        survey: angularSurvey,
        pages: pageMap,
        elements: elementsMap,
        optionAnswers: optionAnswersMap,
        builderOptions: new BuilderOptionsModel(),
    };
};
/**
 * @param {?} obj
 * @return {?}
 */
function isNil$$1(obj) {
    return obj === undefined || obj === null;
}
/** @type {?} */
const UUID$$1 = () => {
    if (typeof (window) !== 'undefined'
        && typeof (window.crypto) !== 'undefined'
        && typeof (window.crypto.getRandomValues) !== 'undefined') {
        // If we have a cryptographically secure PRNG, use that
        // http://stackoverflow.com/questions/6906916/collisions-when-generating-uuids-in-javascript
        /** @type {?} */
        const buf = new Uint16Array(8);
        window.crypto.getRandomValues(buf);
        return (pad4$$1(buf[0]) + pad4$$1(buf[1])
            + '-' + pad4$$1(buf[2])
            + '-' + pad4$$1(buf[3])
            + '-' + pad4$$1(buf[4])
            + '-' + pad4$$1(buf[5])
            + pad4$$1(buf[6])
            + pad4$$1(buf[7]));
    }
    else {
        // Otherwise, just use Math.random
        // https://stackoverflow.com/questions/105034/create-guid-uuid-in-javascript
        // https://stackoverflow.com/questions/11605068/why-does-jshint-argue-against-bitwise-operators-how-should-i-express-this-code
        return random4$$1() + random4$$1() + '-' + random4$$1() + '-' + random4$$1() + '-' +
            random4$$1() + '-' + random4$$1() + random4$$1() + random4$$1();
    }
};
/** @type {?} */
const pad4$$1 = (num) => {
    /** @type {?} */
    let ret = num.toString(16);
    while (ret.length < 4) {
        ret = '0' + ret;
    }
    return ret;
};
/** @type {?} */
const random4$$1 = () => {
    return Math.floor((1 + Math.random()) * 0x10000)
        .toString(16)
        .substring(1);
};
/** @type {?} */
const arrayTag = '[object Array]';
/** @type {?} */
const objectTag = '[object Object]';
/** @type {?} */
const mapTag = '[object Map]';
/** @type {?} */
const dateTag = '[object Date]';
/** @type {?} */
const deepCopy$$1 = (value) => {
    /** @type {?} */
    let output;
    /** @type {?} */
    let v;
    /** @type {?} */
    const tag = getTag(value);
    if (tag === arrayTag || tag === objectTag) {
        output = Array.isArray(value) ? [] : {};
        for (const key of Object.keys(value)) {
            v = value[key];
            output[key] = (typeof v === 'object') ? deepCopy$$1(v) : v;
        }
    }
    else if (tag === mapTag) {
        output = new Map();
        value.forEach((subValue, key) => {
            output.set(key, deepCopy$$1(subValue));
        });
        return output;
    }
    else if (tag === dateTag) {
        return new Date(value.getTime());
    }
    return output;
};
/**
 * @param {?} value
 * @return {?}
 */
function getTag(value) {
    if (value == null) {
        return value === undefined ? '[object Undefined]' : '[object Null]';
    }
    return toString.call(value);
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
const appInitialState = resetNgSurveyState$$1();

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgSurveyStore {
    constructor() {
        this.dataStore = appInitialState;
        this._ngSurveyState = (/** @type {?} */ (new BehaviorSubject(this.dataStore)));
        this.ngSurveyState = this._ngSurveyState.asObservable();
        this._survey = (/** @type {?} */ (new BehaviorSubject(this.dataStore.survey)));
        this.survey = this._survey.asObservable();
        this._pages = (/** @type {?} */ (new BehaviorSubject(this.dataStore.pages)));
        this.pages = this._pages.asObservable();
        this._elements = (/** @type {?} */ (new BehaviorSubject(this.dataStore.elements)));
        this.elements = this._elements.asObservable();
        this._optionAnswers = (/** @type {?} */ (new BehaviorSubject(this.dataStore.optionAnswers)));
        this.optionAnswers = this._optionAnswers.asObservable();
        this._builderOptions = (/** @type {?} */ (new BehaviorSubject(this.dataStore.builderOptions)));
        this.builderOptions = this._builderOptions.asObservable();
    }
    /**
     * @param {?} payload
     * @return {?}
     */
    updateNgSurveyState(payload) {
        /** @type {?} */
        const newState = Object.assign({}, deepCopy$$1(this.dataStore), payload);
        this.dataStore = newState;
        this._ngSurveyState.next(newState);
    }
    /**
     * @param {?} survey
     * @return {?}
     */
    updateSurvey(survey) {
        this.dataStore.survey = survey;
        this._survey.next(survey);
        this.updateNgSurveyState(survey);
    }
    /**
     * @param {?} pages
     * @return {?}
     */
    updatePages(pages) {
        this.dataStore.pages = pages;
        this._pages.next(pages);
        this.updateNgSurveyState(pages);
    }
    /**
     * @param {?} elements
     * @return {?}
     */
    updateElements(elements) {
        this.dataStore.elements = elements;
        this._elements.next(elements);
        this.updateNgSurveyState(elements);
    }
    /**
     * @param {?} optionAnswers
     * @return {?}
     */
    updateOptionAnswers(optionAnswers) {
        this.dataStore.optionAnswers = optionAnswers;
        this._optionAnswers.next(optionAnswers);
        this.updateNgSurveyState(optionAnswers);
    }
    /**
     * @param {?} builderOptions
     * @return {?}
     */
    updateBuilderOptions(builderOptions) {
        this.dataStore.builderOptions = builderOptions;
        this._builderOptions.next(builderOptions);
        this.updateNgSurveyState(builderOptions);
    }
}
NgSurveyStore.decorators = [
    { type: Injectable }
];
/** @nocollapse */
NgSurveyStore.ctorParameters = () => [];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgSurveysService {
    /**
     * @param {?} _ngSurveyStore
     */
    constructor(_ngSurveyStore) {
        this._ngSurveyStore = _ngSurveyStore;
    }
    /**
     * Listen to the latest state changes in the stream.
     * @return {?} This method returns changes
     * that occur to all of the survey state.
     */
    getNgSurveyState() {
        return this._ngSurveyStore.ngSurveyState;
    }
    /**
     * Listen to the latest survey state changes in the stream.
     * @return {?} This method returns changes
     * that occur to the survey state.
     */
    getSurveyChanges() {
        return this._ngSurveyStore.survey;
    }
    /**
     * Listen to the latest pages state changes in the stream.
     * @return {?} This method returns changes
     * that occur to the pages state.
     */
    getPagesChanges() {
        return this._ngSurveyStore.pages;
    }
    /**
     * Listen to the latest element state changes in the stream.
     * @return {?} This method returns changes
     * that occur to the elements state.
     */
    getElementsChanges() {
        return this._ngSurveyStore.elements;
    }
    /**
     * Listen to the latest element state changes of a page in the stream.
     * @param {?} pageId to retrieve elements of a specific page
     * @return {?} This method returns changes
     * that occur to the elements state filtered by pageId.
     */
    getElementsByPageIdChanges(pageId) {
        return this._ngSurveyStore.elements.pipe(map(res => {
            return res.get(pageId);
        }));
    }
    /**
     * Listen to the latest option answers state changes in the stream.
     * @return {?} This method returns changes
     * that occur to the option answers state.
     */
    getOptionAnswersChanges() {
        return this._ngSurveyStore.optionAnswers;
    }
    /**
     * Listen to the latest option answers state changes of an element in the stream.
     * @param {?} elementId to retrieve option answers of a specific element
     * @return {?} This method returns changes
     * that occur to the option answers state filtered by elementId.
     */
    getOptionAnswersByElementIdChanges(elementId) {
        return this._ngSurveyStore.optionAnswers.pipe(map(res => {
            return res.get(elementId);
        }));
    }
}
NgSurveysService.decorators = [
    { type: Injectable, args: [{ providedIn: 'root' },] }
];
/** @nocollapse */
NgSurveysService.ctorParameters = () => [
    { type: NgSurveyStore }
];
/** @nocollapse */ NgSurveysService.ngInjectableDef = defineInjectable({ factory: function NgSurveysService_Factory() { return new NgSurveysService(inject(NgSurveyStore)); }, token: NgSurveysService, providedIn: "root" });

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @enum {string} */
const SurveyActionTypes = {
    SURVEY_NAME_CHANGED_ACTION: '[Angular Surveys] Survey title change',
    SURVEY_DESCRIPTION_CHANGED_ACTION: '[Angular Surveys] Survey description change',
    SURVEY_SUMMARY_CHANGED_ACTION: '[Angular Surveys] Survey summary change',
    RESET_SURVEY_STATE_ACTION: '[Angular Surveys] Reset survey state',
    HANDLE_SURVEY_LOADING: '[Angular Surveys] Handle is survey loading',
    IMPORT_SURVEY_STATE_ACTION: '[Angular Surveys] Import survey state',
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @enum {string} */
const PagesActionTypes = {
    ADD_PAGE_ACTION: '[Angular Page] Add survey page',
    INSERT_PAGE_ACTION: '[Angular Page] Insert survey page',
    MOVE_PAGE_UP_ACTION: '[Angular Page] Move survey page up',
    MOVE_PAGE_DOWN_ACTION: '[Angular Page] Move survey page down',
    REMOVE_PAGE_ACTION: '[Angular Page] Remove survey page',
    UPDATE_PAGE_NAME_ACTION: '[Angular Page] Update survey page name',
    UPDATE_PAGE_DESCRIPTION_ACTION: '[Angular Page] Update survey page description',
    UPDATE_PAGE_PAGE_FLOW_ACTION: '[Angular Page] Update survey page page flow',
    RESET_PAGE_STATE: '[Angular Page] Reset page state',
    IMPORT_PAGE_STATE: '[Angular Page] Import page state',
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @param {?} pages
 * @param {?} surveyId
 * @param {?} pageId
 * @return {?}
 */
function createNextPage(pages, surveyId, pageId) {
    /** @type {?} */
    const newPage = new Page(pageId, surveyId);
    if (pages.size >= 1) {
        /** @type {?} */
        const lastPage = getLastValueInMap$$1(pages);
        newPage.orderNo = lastPage.orderNo + 1;
    }
    pages.set(newPage.id, newPage);
    return new Map(pages);
}
/**
 * @param {?} pages
 * @param {?} previousPageId
 * @param {?} surveyId
 * @param {?} pageId
 * @return {?}
 */
function insertPage(pages, previousPageId, surveyId, pageId) {
    /** @type {?} */
    const newPage = new Page(pageId, surveyId);
    /** @type {?} */
    const pagesMap = new Map();
    pages.forEach((value, key) => {
        if (key === previousPageId) {
            pagesMap.set(key, value);
            pagesMap.set(newPage.id, newPage);
        }
        else {
            pagesMap.set(key, value);
        }
    });
    updateElementPositionInMap$$1(pagesMap);
    return new Map(pagesMap);
}
/**
 * @param {?} pages
 * @param {?} pageId
 * @return {?}
 */
function movePageUp(pages, pageId) {
    /** @type {?} */
    const currentPage = pages.get(pageId);
    /** @type {?} */
    const index = currentPage.orderNo - 2;
    pages.delete(pageId);
    /** @type {?} */
    const pagesMap = moveItemInMap$$1(pages, index, currentPage);
    updateElementPositionInMap$$1(pagesMap);
    return new Map(pagesMap);
}
/**
 * @param {?} pages
 * @param {?} pageId
 * @return {?}
 */
function movePageDown(pages, pageId) {
    /** @type {?} */
    const currentPage = pages.get(pageId);
    /** @type {?} */
    const index = currentPage.orderNo;
    pages.delete(pageId);
    /** @type {?} */
    const pagesMap = moveItemInMap$$1(pages, index, currentPage);
    updateElementPositionInMap$$1(pagesMap);
    return new Map(pagesMap);
}
/**
 * @param {?} pages
 * @param {?} pageId
 * @return {?}
 */
function removePage(pages, pageId) {
    pages.delete(pageId);
    updateElementPositionInMap$$1(pages);
    return new Map(pages);
}
/**
 * @param {?} pages
 * @param {?} pageId
 * @param {?} name
 * @return {?}
 */
function updatePageName(pages, pageId, name) {
    /** @type {?} */
    const currentPage = pages.get(pageId);
    currentPage.name = name;
    return new Map(pages);
}
/**
 * @param {?} pages
 * @param {?} pageId
 * @param {?} description
 * @return {?}
 */
function updatePageDescription(pages, pageId, description) {
    /** @type {?} */
    const currentPage = pages.get(pageId);
    currentPage.description = description;
    return new Map(pages);
}
/**
 * @param {?} pages
 * @param {?} pageId
 * @param {?} pageFlow
 * @return {?}
 */
function updatePagePageFlow(pages, pageId, pageFlow) {
    /** @type {?} */
    const currentPage = pages.get(pageId);
    currentPage.pageFlow = pageFlow;
    return new Map(pages);
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @enum {string} */
const ElementsActionTypes = {
    ADD_ELEMENT_ACTION: '[Angular Element] Add survey question element',
    REMOVE_ELEMENT_ACTION: '[Angular Element] Remove survey question element',
    REMOVE_ELEMENT_MAP_ACTION: '[Angular Element] Remove element map',
    MOVE_ELEMENT_UP_ACTION: '[Angular Element] Move survey question element up',
    MOVE_ELEMENT_DOWN_ACTION: '[Angular Element] Move survey question element down',
    DRAG_ELEMENT_ACTION: '[Angular Element] Drag survey question element',
    QUESTION_ADD_TEXT_ACTION: '[Angular Question] Add question text',
    QUESTION_ADD_TYPE_ACTION: '[Angular Question] Add question type',
    QUESTION_UPDATE_MIN_ACTION: '[Angular Question] Update question max value',
    QUESTION_UPDATE_MAX_ACTION: '[Angular Question] Update question min value',
    QUESTION_REMOVE_VALUES_ACTION: '[Angular Question] Remove question values',
    QUESTION_UPDATE_PAGE_FLOW_MODIFIER_ACTION: '[Angular Question] UPDATE question page flow modifier',
    TOGGLE_IS_ACTIVE_ELEMENT_ACTION: '[Angular Element] Toggle isActive element',
    QUESTION_UPDATE_ANSWER_ACTION: '[Angular Question] Update question answer value',
    PARAGRAPH_UPDATE_HTML_ACTION: '[Angular Paragraph] Update paragraph HTML value',
    RESET_ELEMENTS_STATE: '[Angular Element] Reset elements state',
    IMPORT_ELEMENTS_STATE: '[Angular Element] Import elements state',
    IMPORT_ELEMENT: '[Angular Element] Import element',
    CLONE_ELEMENT_ACTION: '[Angular Element] Clone element',
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @param {?} pageId
 * @param {?} elements
 * @param {?} type
 * @return {?}
 */
function createNextElement(pageId, elements, type) {
    /** @type {?} */
    let newElement = new Elements(pageId);
    newElement.type = type;
    if (newElement.type === 'paragraph') {
        newElement = addParagraphType(newElement);
    }
    handleElementShowPageFlowToggle(elements, newElement);
    elements.set(newElement.id, newElement);
    updateElementPositionInMap$$1(elements);
    return new Map(elements);
}
/**
 * @param {?} pageId
 * @param {?} type
 * @return {?}
 */
function createNewElementMap(pageId, type) {
    /** @type {?} */
    let newElement = new Elements(pageId);
    newElement.type = type;
    if (newElement.type === 'paragraph') {
        newElement = addParagraphType(newElement);
    }
    /** @type {?} */
    const newElementMap = new Map().set(newElement.id, newElement);
    return new Map(newElementMap);
}
/**
 * @param {?} elementId
 * @param {?} elements
 * @return {?}
 */
function removeElement(elementId, elements) {
    elements.delete(elementId);
    updateElementPositionInMap$$1(elements);
    handleElementsShowPageFlowToggle(elements);
    return new Map(elements);
}
/**
 * @param {?} elementId
 * @param {?} elements
 * @return {?}
 */
function moveElementUp(elementId, elements) {
    /** @type {?} */
    const currentElement = elements.get(elementId);
    /** @type {?} */
    const index = currentElement.orderNo - 2;
    elements.delete(elementId);
    /** @type {?} */
    const newElementsMap = moveItemInMap$$1(elements, index, currentElement);
    updateElementPositionInMap$$1(newElementsMap);
    return new Map(newElementsMap);
}
/**
 * @param {?} elementId
 * @param {?} elements
 * @return {?}
 */
function moveElementDown(elementId, elements) {
    /** @type {?} */
    const currentElement = elements.get(elementId);
    /** @type {?} */
    const index = currentElement.orderNo;
    elements.delete(elementId);
    /** @type {?} */
    const newElementsMap = moveItemInMap$$1(elements, index, currentElement);
    updateElementPositionInMap$$1(newElementsMap);
    return new Map(newElementsMap);
}
/**
 * @param {?} startIndex
 * @param {?} endIndex
 * @param {?} elements
 * @return {?}
 */
function dragElement(startIndex, endIndex, elements) {
    /** @type {?} */
    const newElementsMap = dragItemInArray$$1(elements, startIndex, endIndex);
    updateElementPositionInMap$$1(newElementsMap);
    return new Map(newElementsMap);
}
/**
 * @param {?} elementId
 * @param {?} text
 * @param {?} elements
 * @return {?}
 */
function addQuestionText(elementId, text, elements) {
    /** @type {?} */
    const currentQuestion = elements.get(elementId).question;
    currentQuestion.text = text;
    return new Map(elements);
}
/**
 * @param {?} elementId
 * @param {?} type
 * @param {?} elements
 * @return {?}
 */
function addQuestionType(elementId, type, elements) {
    /** @type {?} */
    const currentQuestion = elements.get(elementId).question;
    currentQuestion.type = type;
    return new Map(elements);
}
/**
 * @param {?} elementId
 * @param {?} min
 * @param {?} elements
 * @return {?}
 */
function updateQuestionMin(elementId, min, elements) {
    /** @type {?} */
    const currentQuestion = elements.get(elementId).question;
    currentQuestion.min = min;
    return new Map(elements);
}
/**
 * @param {?} elementId
 * @param {?} max
 * @param {?} elements
 * @return {?}
 */
function updateQuestionMax(elementId, max, elements) {
    /** @type {?} */
    const currentQuestion = elements.get(elementId).question;
    currentQuestion.max = max;
    return new Map(elements);
}
/**
 * @param {?} elementId
 * @param {?} elements
 * @return {?}
 */
function removeQuestionValues(elementId, elements) {
    /** @type {?} */
    const currentElement = elements.get(elementId);
    if (currentElement) {
        /** @type {?} */
        const currentQuestion = currentElement.question;
        currentQuestion.min = null;
        currentQuestion.max = null;
        currentQuestion.answer = '';
        currentQuestion.text = '';
        currentElement.question = currentQuestion;
    }
    return new Map(elements);
}
/**
 * @param {?} elementId
 * @param {?} pageFlowModifier
 * @param {?} elements
 * @return {?}
 */
function updateQuestionPageFlowModifier(elementId, pageFlowModifier, elements) {
    /** @type {?} */
    const currentQuestion = elements.get(elementId).question;
    currentQuestion.pageFlowModifier = pageFlowModifier;
    updateShowPageFlowToggle(elements, elementId);
    return new Map(elements);
}
/**
 * @param {?} elementId
 * @param {?} isSaved
 * @param {?} elements
 * @return {?}
 */
function toggleElementIsSaved(elementId, isSaved, elements) {
    /** @type {?} */
    const element = elements.get(elementId);
    element.isSaved = isSaved;
    return new Map(elements);
}
/**
 * @param {?} elementId
 * @param {?} answer
 * @param {?} elements
 * @return {?}
 */
function updateQuestionAnswer(elementId, answer, elements) {
    /** @type {?} */
    const currentQuestion = elements.get(elementId).question;
    currentQuestion.answer = answer;
    return new Map(elements);
}
/**
 * @param {?} elementId
 * @param {?} html
 * @param {?} elements
 * @return {?}
 */
function updateParagraphHTML(elementId, html, elements) {
    /** @type {?} */
    const currentParagraph = elements.get(elementId).paragraph;
    currentParagraph.html = html;
    return new Map(elements);
}
/**
 * @param {?} element
 * @param {?} pageId
 * @param {?} elements
 * @param {?} currentElement
 * @return {?}
 */
function importElement(element, pageId, elements, currentElement) {
    elements.delete(currentElement.id);
    element.pageId = pageId;
    elements.set(element.id, element);
    updateElementPositionInMap$$1(elements);
    handleElementsShowPageFlowToggle(elements);
    return new Map(elements);
}
/**
 * @param {?} elementId
 * @param {?} elements
 * @return {?}
 */
function cloneElement(elementId, elements) {
    /** @type {?} */
    const currentElement = elements.get(elementId);
    /** @type {?} */
    const clonedElement = deepCopy$$1(currentElement);
    /** @type {?} */
    const index = currentElement.orderNo;
    /** @type {?} */
    const clonedElementId = UUID$$1();
    clonedElement.id = clonedElementId;
    updateElementTypeWithNewElementId(clonedElement, clonedElementId);
    /** @type {?} */
    const newElementsMap = insertElement(elements, clonedElement, index);
    updateElementPositionInMap$$1(newElementsMap);
    return new Map(newElementsMap);
}
/** @type {?} */
const updateShowPageFlowToggle = (elements, elementId) => elements.forEach((value, key) => value.showPageFlowToggle = key === elementId);
/** @type {?} */
const handleElementShowPageFlowToggle = (elements, newElement) => newElement.showPageFlowToggle = Array.from(elements).reduce((show, el) => show && el[1].showPageFlowToggle, true);
/** @type {?} */
const handleElementsShowPageFlowToggle = (elements) => {
    /** @type {?} */
    const changeElementsShowPageFlowToggle = Array.from(elements).reduce((show, el) => show && !el[1].showPageFlowToggle, true);
    if (changeElementsShowPageFlowToggle) {
        elements.forEach((value) => value.showPageFlowToggle = true);
    }
};
/** @type {?} */
const addParagraphType = (element) => {
    /** @type {?} */
    const paragraph = new Paragraph();
    paragraph.elementId = element.id;
    element.paragraph = paragraph;
    element.question = null;
    return element;
};
/** @type {?} */
const insertElement = (elements, element, index) => {
    /** @type {?} */
    const elementsArray = Array.from(elements);
    elementsArray.splice(index, 0, [element.id, element]);
    return arrayToMap$$1(elementsArray);
};
/** @type {?} */
const updateElementTypeWithNewElementId = (element, newElementId) => {
    for (const key in element) {
        if (key === 'elementId') {
            element[key] = newElementId;
        }
        else if (typeof element[key] === 'object') {
            updateElementTypeWithNewElementId(element[key], newElementId);
        }
    }
    return element;
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @enum {string} */
const OptionAnswersActionTypes = {
    ADD_OPTION_ANSWERS_ACTION: '[Angular Option Answers] Add question option answer',
    REMOVE_OPTION_ANSWERS_ACTION: '[Angular Option Answers] Remove question option answer',
    REMOVE_OPTION_ANSWERS_MAP_ACTION: '[Angular Option Answers] Remove question option answer map',
    REMOVE_OPTION_ANSWERS_MAPS_ACTION: '[Angular Option Answers] Remove question option answer maps',
    ADD_OPTION_ANSWERS_VALUE_ACTION: '[Angular Option Answers] Add question option answer value',
    UPDATE_OPTION_ANSWERS_PAGE_FLOW: '[Angular Option Answers] Update question option page flow',
    DRAG_OPTION_ANSWERS_ACTION: '[Angular Option Answers] Drag question options',
    TOGGLE_IS_ACTIVE_OPTION_ANSWERS_ACTION: '[Angular Option Answers] Toggle isActive question options',
    RESET_OPTION_ANSWERS_STATE: '[Angular Option Answers] Reset option answers state',
    IMPORT_OPTION_ANSWERS_STATE: '[Angular Option Answers] Import option answers state',
    IMPORT_OPTION_ANSWERS: '[Angular Option Answers] Import option answers',
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @param {?} elementId
 * @param {?} optionAnswers
 * @return {?}
 */
function addOptionAnswer(elementId, optionAnswers) {
    /** @type {?} */
    const newOptionAnswers = new OptionAnswers(elementId);
    optionAnswers.set(newOptionAnswers.id, newOptionAnswers);
    updateElementPositionInMap$$1(optionAnswers);
    return new Map(optionAnswers);
}
/**
 * @param {?} elementId
 * @return {?}
 */
function createNewOptionAnswersMap(elementId) {
    /** @type {?} */
    const newOptionAnswers = new OptionAnswers(elementId);
    /** @type {?} */
    const newOptionAnswersMap = new Map().set(newOptionAnswers.id, newOptionAnswers);
    return new Map(newOptionAnswersMap);
}
/**
 * @param {?} optionAnswersId
 * @param {?} optionAnswers
 * @return {?}
 */
function removeOptionAnswer(optionAnswersId, optionAnswers) {
    optionAnswers.delete(optionAnswersId);
    updateElementPositionInMap$$1(optionAnswers);
    return new Map(optionAnswers);
}
/**
 * @param {?} optionAnswersId
 * @param {?} value
 * @param {?} optionAnswers
 * @return {?}
 */
function addOptionAnswerValue(optionAnswersId, value, optionAnswers) {
    /** @type {?} */
    const currentOptionAnswer = optionAnswers.get(optionAnswersId);
    currentOptionAnswer.value = value;
    return new Map(optionAnswers);
}
/**
 * @param {?} optionAnswersId
 * @param {?} pageFlow
 * @param {?} optionAnswers
 * @return {?}
 */
function updateOptionAnswerPageFlow(optionAnswersId, pageFlow, optionAnswers) {
    /** @type {?} */
    const currentOptionAnswer = optionAnswers.get(optionAnswersId);
    currentOptionAnswer.pageFlow = pageFlow;
    return new Map(optionAnswers);
}
/**
 * @param {?} startIndex
 * @param {?} endIndex
 * @param {?} optionAnswers
 * @return {?}
 */
function dragOptionAnswer(startIndex, endIndex, optionAnswers) {
    /** @type {?} */
    const newOptionAnswersMap = dragItemInArray$1(optionAnswers, startIndex, endIndex);
    updateElementPositionInMap$$1(newOptionAnswersMap);
    return new Map(newOptionAnswersMap);
}
/**
 * @param {?} isSaved
 * @param {?} optionAnswers
 * @return {?}
 */
function toggleIsActiveOptionAnswerValue(isSaved, optionAnswers) {
    optionAnswers.forEach(value => {
        value.isSaved = isSaved;
    });
    return new Map(optionAnswers);
}
/** @type {?} */
const dragItemInArray$1 = (map$$1, startIndex, endIndex) => {
    /** @type {?} */
    const array = Array.from(map$$1);
    moveItemInArray(array, startIndex, endIndex);
    return arrayToMap$$1(array);
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class OptionAnswersReducer {
    /**
     * @param {?} _ngSurveyStore
     */
    constructor(_ngSurveyStore) {
        this._ngSurveyStore = _ngSurveyStore;
    }
    /**
     * @param {?} action
     * @return {?}
     */
    optionAnswersReducer(action) {
        /** @type {?} */
        const state = this._ngSurveyStore.dataStore.optionAnswers;
        switch (action.type) {
            case OptionAnswersActionTypes.ADD_OPTION_ANSWERS_ACTION: {
                const { elementId } = action.payload;
                /** @type {?} */
                const prevOptionAnswers = state.get(elementId);
                /** @type {?} */
                let newOptionAnswers;
                if (!prevOptionAnswers) {
                    newOptionAnswers = createNewOptionAnswersMap(elementId);
                }
                else {
                    newOptionAnswers = addOptionAnswer(elementId, prevOptionAnswers);
                }
                state.set(elementId, newOptionAnswers);
                this._ngSurveyStore.updateOptionAnswers(state);
                break;
            }
            case OptionAnswersActionTypes.REMOVE_OPTION_ANSWERS_ACTION: {
                const { elementId, optionAnswerId } = action.payload;
                /** @type {?} */
                const prevOptionAnswers = state.get(elementId);
                /** @type {?} */
                const newOptionAnswers = removeOptionAnswer(optionAnswerId, prevOptionAnswers);
                state.set(elementId, newOptionAnswers);
                this._ngSurveyStore.updateOptionAnswers(state);
                break;
            }
            case OptionAnswersActionTypes.REMOVE_OPTION_ANSWERS_MAP_ACTION: {
                const { elementId } = action.payload;
                state.delete(elementId);
                this._ngSurveyStore.updateOptionAnswers(state);
                break;
            }
            case OptionAnswersActionTypes.REMOVE_OPTION_ANSWERS_MAPS_ACTION: {
                const { elementIds } = action.payload;
                elementIds.forEach(id => state.delete(id));
                this._ngSurveyStore.updateOptionAnswers(state);
                break;
            }
            case OptionAnswersActionTypes.ADD_OPTION_ANSWERS_VALUE_ACTION: {
                const { elementId, optionAnswerId, value } = action.payload;
                /** @type {?} */
                const prevOptionAnswers = state.get(elementId);
                /** @type {?} */
                const newOptionAnswers = addOptionAnswerValue(optionAnswerId, value, prevOptionAnswers);
                state.set(elementId, newOptionAnswers);
                this._ngSurveyStore.updateOptionAnswers(state);
                break;
            }
            case OptionAnswersActionTypes.UPDATE_OPTION_ANSWERS_PAGE_FLOW: {
                const { elementId, optionAnswerId, pageFlow } = action.payload;
                /** @type {?} */
                const prevOptionAnswers = state.get(elementId);
                /** @type {?} */
                const newOptionAnswers = updateOptionAnswerPageFlow(optionAnswerId, pageFlow, prevOptionAnswers);
                state.set(elementId, newOptionAnswers);
                this._ngSurveyStore.updateOptionAnswers(state);
                break;
            }
            case OptionAnswersActionTypes.DRAG_OPTION_ANSWERS_ACTION: {
                const { elementId, startIndex, endIndex } = action.payload;
                /** @type {?} */
                const prevOptionAnswers = state.get(elementId);
                /** @type {?} */
                const newOptionAnswers = dragOptionAnswer(startIndex, endIndex, prevOptionAnswers);
                state.set(elementId, newOptionAnswers);
                this._ngSurveyStore.updateOptionAnswers(state);
                break;
            }
            case OptionAnswersActionTypes.TOGGLE_IS_ACTIVE_OPTION_ANSWERS_ACTION: {
                const { elementId, isSaved } = action.payload;
                /** @type {?} */
                const prevOptionAnswers = state.get(elementId);
                if (prevOptionAnswers) {
                    /** @type {?} */
                    const newOptionAnswers = toggleIsActiveOptionAnswerValue(isSaved, prevOptionAnswers);
                    state.set(elementId, newOptionAnswers);
                }
                this._ngSurveyStore.updateOptionAnswers(state);
                break;
            }
            case OptionAnswersActionTypes.RESET_OPTION_ANSWERS_STATE: {
                const { ngSurveyState } = action.payload;
                this._ngSurveyStore.updateOptionAnswers(ngSurveyState.optionAnswers);
                break;
            }
            case OptionAnswersActionTypes.IMPORT_OPTION_ANSWERS_STATE: {
                const { ngSurveyState } = action.payload;
                this._ngSurveyStore.updateOptionAnswers(ngSurveyState.optionAnswers);
                break;
            }
            case OptionAnswersActionTypes.IMPORT_OPTION_ANSWERS: {
                const { newOptionAnswers, elementId } = action.payload;
                state.set(elementId, newOptionAnswers);
                this._ngSurveyStore.updateOptionAnswers(state);
                break;
            }
            default: {
                return state;
            }
        }
    }
}
OptionAnswersReducer.decorators = [
    { type: Injectable }
];
/** @nocollapse */
OptionAnswersReducer.ctorParameters = () => [
    { type: NgSurveyStore }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class ElementsReducer {
    /**
     * @param {?} _ngSurveyStore
     * @param {?} _optionAnswersReducer
     */
    constructor(_ngSurveyStore, _optionAnswersReducer) {
        this._ngSurveyStore = _ngSurveyStore;
        this._optionAnswersReducer = _optionAnswersReducer;
    }
    /**
     * @param {?} action
     * @return {?}
     */
    elementsReducer(action) {
        /** @type {?} */
        const state = this._ngSurveyStore.dataStore.elements;
        switch (action.type) {
            case ElementsActionTypes.ADD_ELEMENT_ACTION: {
                const { pageId, type } = action.payload;
                /** @type {?} */
                const prevElements = state.get(pageId);
                /** @type {?} */
                let newElements;
                if (!prevElements) {
                    newElements = createNewElementMap(pageId, type);
                }
                else {
                    newElements = createNextElement(pageId, prevElements, type);
                }
                state.set(pageId, newElements);
                this._ngSurveyStore.updateElements(state);
                break;
            }
            case ElementsActionTypes.REMOVE_ELEMENT_ACTION: {
                const { pageId, elementId } = action.payload;
                /** @type {?} */
                const prevElements = state.get(pageId);
                /** @type {?} */
                const newElements = removeElement(elementId, prevElements);
                state.set(pageId, newElements);
                this._ngSurveyStore.updateElements(state);
                // Effect
                this._optionAnswersReducer.optionAnswersReducer({
                    type: OptionAnswersActionTypes.REMOVE_OPTION_ANSWERS_MAP_ACTION,
                    payload: { elementId }
                });
                break;
            }
            case ElementsActionTypes.REMOVE_ELEMENT_MAP_ACTION: {
                const { pageId, elementIds } = action.payload;
                state.delete(pageId);
                this._ngSurveyStore.updateElements(state);
                // Effect
                this._optionAnswersReducer.optionAnswersReducer({
                    type: OptionAnswersActionTypes.REMOVE_OPTION_ANSWERS_MAPS_ACTION,
                    payload: { elementIds }
                });
                break;
            }
            case ElementsActionTypes.MOVE_ELEMENT_UP_ACTION: {
                const { pageId, elementId } = action.payload;
                /** @type {?} */
                const prevElements = state.get(pageId);
                /** @type {?} */
                const newElements = moveElementUp(elementId, prevElements);
                state.set(pageId, newElements);
                this._ngSurveyStore.updateElements(state);
                break;
            }
            case ElementsActionTypes.MOVE_ELEMENT_DOWN_ACTION: {
                const { pageId, elementId } = action.payload;
                /** @type {?} */
                const prevElements = state.get(pageId);
                /** @type {?} */
                const newElements = moveElementDown(elementId, prevElements);
                state.set(pageId, newElements);
                this._ngSurveyStore.updateElements(state);
                break;
            }
            case ElementsActionTypes.DRAG_ELEMENT_ACTION: {
                const { pageId, startIndex, endIndex } = action.payload;
                /** @type {?} */
                const prevElements = state.get(pageId);
                /** @type {?} */
                const newElements = dragElement(startIndex, endIndex, prevElements);
                state.set(pageId, newElements);
                this._ngSurveyStore.updateElements(state);
                break;
            }
            case ElementsActionTypes.QUESTION_ADD_TEXT_ACTION: {
                const { pageId, elementId, text } = action.payload;
                /** @type {?} */
                const prevElements = state.get(pageId);
                /** @type {?} */
                const newElements = addQuestionText(elementId, text, prevElements);
                state.set(pageId, newElements);
                this._ngSurveyStore.updateElements(state);
                break;
            }
            case ElementsActionTypes.QUESTION_ADD_TYPE_ACTION: {
                const { pageId, elementId, type } = action.payload;
                /** @type {?} */
                const prevElements = state.get(pageId);
                /** @type {?} */
                const newElements = addQuestionType(elementId, type, prevElements);
                state.set(pageId, newElements);
                this._ngSurveyStore.updateElements(state);
                // Effects
                if (type === 'radio' || type === 'checkboxes' || type === 'select') {
                    this._optionAnswersReducer.optionAnswersReducer({
                        type: OptionAnswersActionTypes.ADD_OPTION_ANSWERS_ACTION,
                        payload: { elementId }
                    });
                }
                break;
            }
            case ElementsActionTypes.QUESTION_UPDATE_MIN_ACTION: {
                const { pageId, elementId, min } = action.payload;
                /** @type {?} */
                const prevElements = state.get(pageId);
                /** @type {?} */
                const newElements = updateQuestionMin(elementId, min, prevElements);
                state.set(pageId, newElements);
                this._ngSurveyStore.updateElements(state);
                break;
            }
            case ElementsActionTypes.QUESTION_UPDATE_MAX_ACTION: {
                const { pageId, elementId, max } = action.payload;
                /** @type {?} */
                const prevElements = state.get(pageId);
                /** @type {?} */
                const newElements = updateQuestionMax(elementId, max, prevElements);
                state.set(pageId, newElements);
                this._ngSurveyStore.updateElements(state);
                break;
            }
            case ElementsActionTypes.QUESTION_REMOVE_VALUES_ACTION: {
                const { pageId, elementId } = action.payload;
                /** @type {?} */
                const prevElements = state.get(pageId);
                /** @type {?} */
                const newElements = removeQuestionValues(elementId, prevElements);
                state.set(pageId, newElements);
                this._ngSurveyStore.updateElements(state);
                break;
            }
            case ElementsActionTypes.QUESTION_UPDATE_PAGE_FLOW_MODIFIER_ACTION: {
                const { pageId, elementId, pageFlowModifier } = action.payload;
                /** @type {?} */
                const prevElements = state.get(pageId);
                /** @type {?} */
                const newElements = updateQuestionPageFlowModifier(elementId, pageFlowModifier, prevElements);
                state.set(pageId, newElements);
                this._ngSurveyStore.updateElements(state);
                break;
            }
            case ElementsActionTypes.TOGGLE_IS_ACTIVE_ELEMENT_ACTION: {
                const { pageId, elementId, isSaved } = action.payload;
                /** @type {?} */
                const prevElements = state.get(pageId);
                /** @type {?} */
                const newElements = toggleElementIsSaved(elementId, isSaved, prevElements);
                state.set(pageId, newElements);
                this._ngSurveyStore.updateElements(state);
                // Effect
                this._optionAnswersReducer.optionAnswersReducer({
                    type: OptionAnswersActionTypes.TOGGLE_IS_ACTIVE_OPTION_ANSWERS_ACTION,
                    payload: { elementId, isSaved }
                });
                break;
            }
            case ElementsActionTypes.QUESTION_UPDATE_ANSWER_ACTION: {
                const { pageId, elementId, answer, pageFlowModifier, pageFlow } = action.payload;
                /** @type {?} */
                const prevElements = state.get(pageId);
                /** @type {?} */
                const newElements = updateQuestionAnswer(elementId, answer, prevElements);
                state.set(pageId, newElements);
                this._ngSurveyStore.updateElements(state);
                break;
            }
            case ElementsActionTypes.PARAGRAPH_UPDATE_HTML_ACTION: {
                const { pageId, elementId, html } = action.payload;
                /** @type {?} */
                const prevElements = state.get(pageId);
                /** @type {?} */
                const newElements = updateParagraphHTML(elementId, html, prevElements);
                state.set(pageId, newElements);
                this._ngSurveyStore.updateElements(state);
                break;
            }
            case ElementsActionTypes.RESET_ELEMENTS_STATE: {
                const { ngSurveyState } = action.payload;
                this._ngSurveyStore.updateElements(ngSurveyState.elements);
                break;
            }
            case ElementsActionTypes.IMPORT_ELEMENTS_STATE: {
                const { ngSurveyState } = action.payload;
                this._ngSurveyStore.updateElements(ngSurveyState.elements);
                break;
            }
            case ElementsActionTypes.IMPORT_ELEMENT: {
                const { element, pageId, currentElement, newOptionAnswers, elementId, optionAnswers } = action.payload;
                /** @type {?} */
                const prevElements = state.get(pageId);
                /** @type {?} */
                const newElements = importElement(element, pageId, prevElements, currentElement);
                state.set(pageId, newElements);
                this._ngSurveyStore.updateElements(state);
                // Effect
                if (!isNil$$1(optionAnswers)) {
                    this._optionAnswersReducer.optionAnswersReducer({
                        type: OptionAnswersActionTypes.IMPORT_OPTION_ANSWERS,
                        payload: { newOptionAnswers, elementId }
                    });
                }
                break;
            }
            case ElementsActionTypes.CLONE_ELEMENT_ACTION: {
                const { pageId, elementId } = action.payload;
                /** @type {?} */
                const prevElements = state.get(pageId);
                /** @type {?} */
                const newElements = cloneElement(elementId, prevElements);
                state.set(pageId, newElements);
                this._ngSurveyStore.updateElements(state);
                break;
            }
            default: {
                return state;
            }
        }
    }
}
ElementsReducer.decorators = [
    { type: Injectable }
];
/** @nocollapse */
ElementsReducer.ctorParameters = () => [
    { type: NgSurveyStore },
    { type: OptionAnswersReducer }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class PagesReducer {
    /**
     * @param {?} _ngSurveyStore
     * @param {?} _elementsReducer
     */
    constructor(_ngSurveyStore, _elementsReducer) {
        this._ngSurveyStore = _ngSurveyStore;
        this._elementsReducer = _elementsReducer;
    }
    /**
     * @param {?} action
     * @return {?}
     */
    pagesReducer(action) {
        /** @type {?} */
        const state = this._ngSurveyStore.dataStore.pages;
        switch (action.type) {
            case PagesActionTypes.ADD_PAGE_ACTION: {
                const { surveyId, pageId } = action.payload;
                /** @type {?} */
                const prevPages = state;
                /** @type {?} */
                const pages = createNextPage(prevPages, surveyId, pageId);
                /** @type {?} */
                const newState = deepCopy$$1(pages);
                this._ngSurveyStore.updatePages(newState);
                // Effects
                this._elementsReducer.elementsReducer({
                    type: ElementsActionTypes.ADD_ELEMENT_ACTION,
                    payload: { pageId: pageId, type: 'question' }
                });
                break;
            }
            case PagesActionTypes.INSERT_PAGE_ACTION: {
                const { previousPageId, surveyId, pageId } = action.payload;
                /** @type {?} */
                const pages = insertPage(state, previousPageId, surveyId, pageId);
                /** @type {?} */
                const newState = deepCopy$$1(pages);
                this._ngSurveyStore.updatePages(newState);
                // Effects
                this._elementsReducer.elementsReducer({
                    type: ElementsActionTypes.ADD_ELEMENT_ACTION,
                    payload: { pageId: pageId, type: 'question' }
                });
                break;
            }
            case PagesActionTypes.MOVE_PAGE_UP_ACTION: {
                const { pageId } = action.payload;
                /** @type {?} */
                const pages = movePageUp(state, pageId);
                /** @type {?} */
                const newState = deepCopy$$1(pages);
                this._ngSurveyStore.updatePages(newState);
                break;
            }
            case PagesActionTypes.MOVE_PAGE_DOWN_ACTION: {
                const { pageId } = action.payload;
                /** @type {?} */
                const pages = movePageDown(state, pageId);
                /** @type {?} */
                const newState = deepCopy$$1(pages);
                this._ngSurveyStore.updatePages(newState);
                break;
            }
            case PagesActionTypes.REMOVE_PAGE_ACTION: {
                const { pageId, elementIds } = action.payload;
                /** @type {?} */
                const pages = removePage(state, pageId);
                /** @type {?} */
                const newState = deepCopy$$1(pages);
                this._ngSurveyStore.updatePages(newState);
                // Effects
                this._elementsReducer.elementsReducer({
                    type: ElementsActionTypes.REMOVE_ELEMENT_MAP_ACTION,
                    payload: { pageId, elementIds }
                });
                break;
            }
            case PagesActionTypes.UPDATE_PAGE_NAME_ACTION: {
                const { pageId, name } = action.payload;
                /** @type {?} */
                const pages = updatePageName(state, pageId, name);
                /** @type {?} */
                const newState = deepCopy$$1(pages);
                this._ngSurveyStore.updatePages(newState);
                break;
            }
            case PagesActionTypes.UPDATE_PAGE_DESCRIPTION_ACTION: {
                const { pageId, description } = action.payload;
                /** @type {?} */
                const pages = updatePageDescription(state, pageId, description);
                /** @type {?} */
                const newState = deepCopy$$1(pages);
                this._ngSurveyStore.updatePages(newState);
                break;
            }
            case PagesActionTypes.UPDATE_PAGE_PAGE_FLOW_ACTION: {
                const { pageId, pageFlow } = action.payload;
                /** @type {?} */
                const pages = updatePagePageFlow(state, pageId, pageFlow);
                /** @type {?} */
                const newState = deepCopy$$1(pages);
                this._ngSurveyStore.updatePages(newState);
                break;
            }
            case PagesActionTypes.RESET_PAGE_STATE: {
                const { ngSurveyState } = action.payload;
                this._ngSurveyStore.updatePages(Object.assign(ngSurveyState.pages));
                break;
            }
            case PagesActionTypes.IMPORT_PAGE_STATE: {
                const { ngSurveyState } = action.payload;
                this._ngSurveyStore.updatePages(Object.assign(ngSurveyState.pages));
                break;
            }
            default: {
                return state;
            }
        }
    }
}
PagesReducer.decorators = [
    { type: Injectable }
];
/** @nocollapse */
PagesReducer.ctorParameters = () => [
    { type: NgSurveyStore },
    { type: ElementsReducer }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class SurveyReducer {
    /**
     * @param {?} _ngSurveyStore
     * @param {?} _pagesReducer
     * @param {?} _elementsReducer
     * @param {?} _optionAnswersReducer
     */
    constructor(_ngSurveyStore, _pagesReducer, _elementsReducer, _optionAnswersReducer) {
        this._ngSurveyStore = _ngSurveyStore;
        this._pagesReducer = _pagesReducer;
        this._elementsReducer = _elementsReducer;
        this._optionAnswersReducer = _optionAnswersReducer;
    }
    /**
     * @param {?} action
     * @return {?}
     */
    surveyReducer(action) {
        /** @type {?} */
        const state = this._ngSurveyStore.dataStore.survey;
        switch (action.type) {
            case SurveyActionTypes.SURVEY_NAME_CHANGED_ACTION: {
                /** @type {?} */
                const newState = Object.assign(deepCopy$$1(state), Object.assign({}, action.payload));
                this._ngSurveyStore.updateSurvey(newState);
                break;
            }
            case SurveyActionTypes.SURVEY_DESCRIPTION_CHANGED_ACTION: {
                /** @type {?} */
                const newState = Object.assign(deepCopy$$1(state), Object.assign({}, action.payload));
                this._ngSurveyStore.updateSurvey(newState);
                break;
            }
            case SurveyActionTypes.SURVEY_SUMMARY_CHANGED_ACTION: {
                /** @type {?} */
                const newState = Object.assign(deepCopy$$1(state), Object.assign({}, action.payload));
                this._ngSurveyStore.updateSurvey(newState);
                break;
            }
            case SurveyActionTypes.RESET_SURVEY_STATE_ACTION: {
                const { ngSurveyState } = action.payload;
                this._ngSurveyStore.updateSurvey(ngSurveyState.survey);
                // Effects
                this._pagesReducer.pagesReducer({
                    type: PagesActionTypes.RESET_PAGE_STATE,
                    payload: { ngSurveyState },
                });
                this._elementsReducer.elementsReducer({
                    type: ElementsActionTypes.RESET_ELEMENTS_STATE,
                    payload: { ngSurveyState },
                });
                this._optionAnswersReducer.optionAnswersReducer({
                    type: OptionAnswersActionTypes.RESET_OPTION_ANSWERS_STATE,
                    payload: { ngSurveyState },
                });
                setTimeout(() => {
                    this.surveyReducer({
                        type: SurveyActionTypes.HANDLE_SURVEY_LOADING,
                        payload: { isLoading: false }
                    });
                }, 1000);
                break;
            }
            case SurveyActionTypes.HANDLE_SURVEY_LOADING: {
                /** @type {?} */
                const newState = Object.assign(deepCopy$$1(state), Object.assign({}, action.payload));
                this._ngSurveyStore.updateSurvey(newState);
                break;
            }
            case SurveyActionTypes.IMPORT_SURVEY_STATE_ACTION: {
                const { ngSurveyState } = action.payload;
                this._ngSurveyStore.updateSurvey(ngSurveyState.survey);
                // Effects
                this._pagesReducer.pagesReducer({
                    type: PagesActionTypes.IMPORT_PAGE_STATE,
                    payload: { ngSurveyState },
                });
                this._elementsReducer.elementsReducer({
                    type: ElementsActionTypes.IMPORT_ELEMENTS_STATE,
                    payload: { ngSurveyState },
                });
                this._optionAnswersReducer.optionAnswersReducer({
                    type: OptionAnswersActionTypes.IMPORT_OPTION_ANSWERS_STATE,
                    payload: { ngSurveyState },
                });
                this.surveyReducer({
                    type: SurveyActionTypes.HANDLE_SURVEY_LOADING,
                    payload: { isLoading: false }
                });
                break;
            }
            default: {
                return this._ngSurveyStore.survey;
            }
        }
    }
}
SurveyReducer.decorators = [
    { type: Injectable }
];
/** @nocollapse */
SurveyReducer.ctorParameters = () => [
    { type: NgSurveyStore },
    { type: PagesReducer },
    { type: ElementsReducer },
    { type: OptionAnswersReducer }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @enum {string} */
const BuilderOptionsActionTypes = {
    UPDATE_BUILDER_OPTIONS_ACTION: '[Builder Options] Update builder options',
    RESET_BUILDER_OPTIONS_ACTION: '[Builder Options] Reset builder options',
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class BuilderOptionsReducer {
    /**
     * @param {?} _ngSurveyStore
     */
    constructor(_ngSurveyStore) {
        this._ngSurveyStore = _ngSurveyStore;
    }
    /**
     * @param {?} action
     * @return {?}
     */
    builderOptionsReducer(action) {
        /** @type {?} */
        const state = this._ngSurveyStore.dataStore.builderOptions;
        switch (action.type) {
            case BuilderOptionsActionTypes.UPDATE_BUILDER_OPTIONS_ACTION: {
                /** @type {?} */
                const newState = Object.assign(deepCopy$$1(state), Object.assign({}, action.payload.builderOptions));
                this._ngSurveyStore.updateBuilderOptions(newState);
                break;
            }
            case BuilderOptionsActionTypes.RESET_BUILDER_OPTIONS_ACTION: {
                /** @type {?} */
                const newState = Object.assign(deepCopy$$1(state), Object.assign({}, action.payload.builderOptions));
                this._ngSurveyStore.updateBuilderOptions(newState);
                break;
            }
            default: {
                return state;
            }
        }
    }
}
BuilderOptionsReducer.decorators = [
    { type: Injectable }
];
/** @nocollapse */
BuilderOptionsReducer.ctorParameters = () => [
    { type: NgSurveyStore }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgBuilderViewerComponent {
    /**
     * @param {?} _ngSurveyStore
     * @param {?} _surveyReducer
     * @param {?} _pagesReducer
     * @param {?} _builderOptionsReducer
     */
    constructor(_ngSurveyStore, _surveyReducer, _pagesReducer, _builderOptionsReducer) {
        this._ngSurveyStore = _ngSurveyStore;
        this._surveyReducer = _surveyReducer;
        this._pagesReducer = _pagesReducer;
        this._builderOptionsReducer = _builderOptionsReducer;
        this.isLoading = false;
        this.surveySub = this._ngSurveyStore.survey.subscribe(res => {
            this.survey = res;
        });
        this.ngSurveyStateSub = this._ngSurveyStore.ngSurveyState.subscribe(res => {
            this.ngSurveyState = res;
        });
        this.pagesSub = this._ngSurveyStore.pages.subscribe(pagesRes => {
            this.pages = pagesRes;
        });
    }
    /**
     * @param {?} value
     * @return {?}
     */
    set options(value) {
        this._options = value;
        this.handleBuilderOptionsChange(this._options);
    }
    /**
     * @return {?}
     */
    get options() {
        return this._options;
    }
    /**
     * @return {?}
     */
    ngOnInit() {
    }
    /**
     * @return {?}
     */
    ngOnDestroy() {
        this.surveySub.unsubscribe();
        this.pagesSub.unsubscribe();
        this.ngSurveyStateSub.unsubscribe();
    }
    /**
     * @param {?} builderOptions
     * @return {?}
     */
    handleBuilderOptionsChange(builderOptions) {
        this._builderOptionsReducer.builderOptionsReducer({
            type: BuilderOptionsActionTypes.UPDATE_BUILDER_OPTIONS_ACTION,
            payload: { builderOptions }
        });
    }
    /**
     * @return {?}
     */
    addPage() {
        /** @type {?} */
        const pageId = UUID$$1();
        this._pagesReducer.pagesReducer({
            type: PagesActionTypes.ADD_PAGE_ACTION,
            payload: { surveyId: this.survey.id, pageId },
        });
    }
    /**
     * @return {?}
     */
    reset() {
        /** @type {?} */
        const ngSurveyState = resetNgSurveyState$$1();
        ngSurveyState.survey.isLoading = true;
        this._surveyReducer.surveyReducer({
            type: SurveyActionTypes.RESET_SURVEY_STATE_ACTION,
            payload: { ngSurveyState },
        });
    }
    /**
     * @param {?} cb
     * @return {?}
     */
    importSurvey(cb) {
        cb().subscribe(ngSurveyState => {
            ngSurveyState.survey.isLoading = true;
            this._surveyReducer.surveyReducer({
                type: SurveyActionTypes.IMPORT_SURVEY_STATE_ACTION,
                payload: { ngSurveyState },
            });
        });
    }
    /**
     * @param {?} index
     * @param {?} item
     * @return {?}
     */
    trackElement(index, item) {
        return item ? item.key : null;
    }
}
NgBuilderViewerComponent.decorators = [
    { type: Component, args: [{
                selector: 'ngs-builder-viewer',
                template: "<div *ngIf=\"survey.isLoading\">\n  <ngs-loader [isInherit]=\"true\"></ngs-loader>\n</div>\n\n<div *ngIf=\"!survey.isLoading\">\n  <div class=\"mb-3 d-flex flex-md-row flex-column justify-content-start\">\n    <span>\n      <button class=\"btn btn-primary mb-md-0 mb-3\" tooltip=\"Reset Survey\" (click)=\"reset()\"><i class=\"fas fa-trash-alt\"></i> Reset Survey</button>\n    </span>\n    <span>\n      <button\n        *ngIf=\"!!options?.importSurvey\"\n        class=\"btn btn-primary ml-md-3 mb-md-0 mb-3\"\n        [tooltip]=\"!!options.importSurvey?.title ? options.importSurvey?.title : 'Import Survey'\"\n        (click)=\"importSurvey(options.importSurvey.callback)\"\n      >\n      <i [class]=\"!!options.importSurvey?.icon ? options.importSurvey?.icon : 'fas fa-file-import'\"></i> Import Survey\n    </button>\n    </span>\n    <span *ngIf=\"!!options?.surveyButtons && options?.surveyButtons.length > 0\">\n      <button *ngFor=\"let button of options?.surveyButtons\" class=\"btn btn-primary ml-md-3\" [tooltip]=\"button?.title\" (click)=\"button?.callback(ngSurveyState)\">\n        <i *ngIf=\"button.icon\" [class]=\"button?.icon\"></i> {{button?.text}}\n      </button>\n    </span>\n  </div>\n  <div class=\"card\">\n    <div class=\"card-header\">\n      Survey Template Info\n    </div>\n    <div class=\"card-body\">\n      <ngs-survey-template-form\n        [survey]=\"survey\"\n      ></ngs-survey-template-form>\n\n      <!-- Page Builder Container -->\n      <div *ngFor=\"let item of pages | mapValues; trackBy: trackElement\">\n        <ngs-page-builder-container\n                [surveyId]=\"survey.id\"\n                [page]=\"item?.value\"\n                [pages]=\"pages\"\n        ></ngs-page-builder-container>\n      </div>\n      <!-- #/Page Builder Container -->\n    </div>\n  </div>\n\n  <!-- Survey Summary -->\n  <ngs-summary-container></ngs-summary-container>\n  <!-- Survey Summary -->\n\n  <div class=\"mt-5\">\n    <div class=\"d-flex flex-row justify-content-between align-items-end\">\n\n      <!-- TODO add pagination-->\n      <!--<nav aria-label=\"Page navigation example\">-->\n        <!--<ul class=\"pagination mb-0\">-->\n          <!--<li class=\"page-item\">-->\n            <!--<a class=\"page-link\" href=\"#\" aria-label=\"Previous\">-->\n              <!--<span aria-hidden=\"true\">&laquo;</span>-->\n              <!--<span class=\"sr-only\">Previous</span>-->\n            <!--</a>-->\n          <!--</li>-->\n          <!--<li class=\"page-item\"><a class=\"page-link\" href=\"#\">1</a></li>-->\n          <!--<li class=\"page-item\"><a class=\"page-link\" href=\"#\">2</a></li>-->\n          <!--<li class=\"page-item\"><a class=\"page-link\" href=\"#\">3</a></li>-->\n          <!--<li class=\"page-item\">-->\n            <!--<a class=\"page-link\" href=\"#\" aria-label=\"Next\">-->\n              <!--<span aria-hidden=\"true\">&raquo;</span>-->\n              <!--<span class=\"sr-only\">Next</span>-->\n            <!--</a>-->\n          <!--</li>-->\n        <!--</ul>-->\n      <!--</nav>-->\n\n      <!--<select class=\"custom-select custom-select-lg mb-0 w-auto\">-->\n        <!--<option value=\"1\" selected>10</option>-->\n        <!--<option value=\"2\">25</option>-->\n        <!--<option value=\"3\">50</option>-->\n      <!--</select>-->\n\n      <button type=\"button\" class=\"btn btn-outline-primary\" (click)=\"addPage()\">Add Page</button>\n    </div>\n  </div>\n</div>\n",
                styles: [".card-body{border-left:1px solid rgba(0,0,0,.125)}"]
            }] }
];
/** @nocollapse */
NgBuilderViewerComponent.ctorParameters = () => [
    { type: NgSurveyStore },
    { type: SurveyReducer },
    { type: PagesReducer },
    { type: BuilderOptionsReducer }
];
NgBuilderViewerComponent.propDecorators = {
    options: [{ type: Input }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class MapValuesPipe {
    /**
     * @param {?} value
     * @param {?=} args
     * @return {?}
     */
    transform(value, args) {
        /** @type {?} */
        const returnArray = [];
        /** @type {?} */
        const isTrue = !!value && (value instanceof Array || value instanceof Map);
        if (isTrue) {
            value.forEach((entryValue, entryKey) => {
                returnArray.push({
                    key: entryKey,
                    value: entryValue
                });
            });
        }
        return returnArray;
    }
}
MapValuesPipe.decorators = [
    { type: Pipe, args: [{
                name: 'mapValues',
                pure: true
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class PageSelectComponent {
    /**
     * @param {?} _ngSurveyStore
     * @param {?} _pagesReducer
     * @param {?} _optionAnswersReducer
     */
    constructor(_ngSurveyStore, _pagesReducer, _optionAnswersReducer) {
        this._ngSurveyStore = _ngSurveyStore;
        this._pagesReducer = _pagesReducer;
        this._optionAnswersReducer = _optionAnswersReducer;
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        this.pagesSub = this._ngSurveyStore.pages.subscribe(res => this.pages = res);
    }
    /**
     * @return {?}
     */
    ngOnDestroy() {
        this.pagesSub.unsubscribe();
    }
    /**
     * @param {?} value
     * @return {?}
     */
    handlePageNavNext(value) {
        console.log('value: ', value);
        if (this.isPage) {
            /** @type {?} */
            const pageFlow = new PageFlow();
            if (value === '') {
                pageFlow.nextPage = true;
                pageFlow.label = 'pageFlow.goToNextPage';
            }
            else {
                pageFlow.nextPage = false;
                pageFlow.label = 'pageFlow.goToPage';
                pageFlow.pageId = value;
            }
            this._pagesReducer.pagesReducer({
                type: PagesActionTypes.UPDATE_PAGE_PAGE_FLOW_ACTION,
                payload: {
                    pageId: this.pageId,
                    pageFlow,
                },
            });
        }
        else {
            /** @type {?} */
            const pageFlow = new PageFlow();
            if (value === '') {
                pageFlow.nextPage = true;
                pageFlow.label = 'pageFlow.goToNextPage';
            }
            else {
                pageFlow.nextPage = false;
                pageFlow.label = 'pageFlow.goToPage';
                pageFlow.pageId = value;
            }
            this._optionAnswersReducer.optionAnswersReducer({
                type: OptionAnswersActionTypes.UPDATE_OPTION_ANSWERS_PAGE_FLOW,
                payload: {
                    elementId: this.elementId,
                    optionAnswerId: this.optionAnswerId,
                    pageFlow
                }
            });
        }
    }
    /**
     * @param {?} index
     * @param {?} item
     * @return {?}
     */
    trackElement(index, item) {
        return item ? item.key : null;
    }
}
PageSelectComponent.decorators = [
    { type: Component, args: [{
                selector: 'ngs-page-select',
                template: "<!-- Navigate to page selection -->\n<!-- TODO *ngIf=\"!optionAnswer?.isSaved && element.question.pageFlowModifier\"-->\n<div *ngIf=\"isPage || (!isPage && !isOptionAnswerSaved && questionPageFlowModifier)\" class=\"ml-md-3 ml-0 mt-md-0 mt-3 form-group mb-0\">\n  <select\n    id=\"pageNavNext\"\n    name=\"pageNavNext\"\n    class=\"form-control\"\n    [(ngModel)]=\"pageFlow.pageId\"\n    (ngModelChange)=\"handlePageNavNext($event)\">\n    <option value=\"\" selected>Continue to next page</option>\n    <option\n      *ngFor=\"let item of pages | mapValues; trackBy: trackElement\"\n      [value]=\"item.value.id\"\n      [disabled]=\"item.value.id === pageId\"\n    >\n      <span id=\"page-orderNo\" *ngIf=\"item.value.orderNo\">Go to page {{item.value.orderNo}}</span>\n      <span id=\"page-title\" *ngIf=\"item.value.title\">| {{item.value.title}}</span>\n    </option>\n  </select>\n</div>\n<!-- #/Navigate to page selection -->\n",
                styles: [""]
            }] }
];
/** @nocollapse */
PageSelectComponent.ctorParameters = () => [
    { type: NgSurveyStore },
    { type: PagesReducer },
    { type: OptionAnswersReducer }
];
PageSelectComponent.propDecorators = {
    isPage: [{ type: Input }],
    surveyId: [{ type: Input }],
    pageId: [{ type: Input }],
    pageFlow: [{ type: Input }],
    elementId: [{ type: Input }],
    optionAnswerId: [{ type: Input }],
    isOptionAnswerSaved: [{ type: Input }],
    questionPageFlowModifier: [{ type: Input }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class LoaderComponent {
    constructor() {
        this.isInherit = false;
    }
    /**
     * @return {?}
     */
    ngOnInit() {
    }
}
LoaderComponent.decorators = [
    { type: Component, args: [{
                selector: 'ngs-loader',
                template: "<div class=\"container-loader\" [ngClass]=\"isInherit ? 'container-loader-inherit' : 'container-loader'\">\n  <div class=\"ball ball-one\"></div>\n  <div class=\"ball ball-two\"></div>\n  <div class=\"ball ball-three\"></div>\n  <div class=\"ball ball-four\"></div>\n  <div class=\"shadow shadow-one\"></div>\n  <div class=\"shadow shadow-two\"></div>\n  <div class=\"shadow shadow-three\"></div>\n  <div class=\"shadow shadow-four\"></div>\n</div>\n",
                styles: [".container-loader{position:absolute;height:50px;width:135px;top:0;right:0;bottom:0;left:0;margin:auto;text-align:center}.container-loader-inherit{position:inherit;height:75px;width:135px;top:0;right:0;bottom:0;left:0;margin:auto;text-align:center;padding-top:35px}div div.ball{width:20px;position:relative;display:inline-block;margin:5px;height:20px;border-radius:50%;z-index:999}.ball-one{background-color:#ffce64;-webkit-animation:.5s infinite alternate jump;animation:.5s infinite alternate jump}.ball-two{background-color:#4bb3ef;-webkit-animation:.5s .15s infinite alternate jump;animation:.5s .15s infinite alternate jump}.ball-three{background-color:#63dd79;-webkit-animation:.5s .25s infinite alternate jump;animation:.5s .25s infinite alternate jump}.ball-four{background-color:#fd6c6c;-webkit-animation:.5s .35s infinite alternate jump;animation:.5s .35s infinite alternate jump}.shadow{position:relative;opacity:.1;bottom:20px;width:20px;height:5px;border-radius:50%;background-color:#262626;display:inline-block;margin:5px}.shadow-one{-webkit-animation:.5s infinite alternate shrink;animation:.5s infinite alternate shrink}.shadow-two{-webkit-animation:.5s .15s infinite alternate shrink;animation:.5s .15s infinite alternate shrink}.shadow-three{-webkit-animation:.5s .25s infinite alternate shrink;animation:.5s .25s infinite alternate shrink}.shadow-four{-webkit-animation:.5s .35s infinite alternate shrink;animation:.5s .35s infinite alternate shrink}@-webkit-keyframes jump{0%{-webkit-transform:scaleY(.8);transform:scaleY(.8)}100%{-webkit-transform:translateY(-40px);transform:translateY(-40px)}}@keyframes jump{0%{-webkit-transform:scaleY(.8);transform:scaleY(.8)}100%{-webkit-transform:translateY(-40px);transform:translateY(-40px)}}@-webkit-keyframes shrink{100%{-webkit-transform:scaleX(.5);transform:scaleX(.5);opacity:.01}}@keyframes shrink{100%{-webkit-transform:scaleX(.5);transform:scaleX(.5);opacity:.01}}"]
            }] }
];
/** @nocollapse */
LoaderComponent.ctorParameters = () => [];
LoaderComponent.propDecorators = {
    isInherit: [{ type: Input }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class SharedCommonModule {
}
SharedCommonModule.decorators = [
    { type: NgModule, args: [{
                imports: [
                    CommonModule,
                    FormsModule,
                ],
                declarations: [
                    MapValuesPipe,
                    PageSelectComponent,
                    LoaderComponent,
                ],
                exports: [
                    MapValuesPipe,
                    PageSelectComponent,
                    LoaderComponent,
                ],
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class ShortTextComponent {
    /**
     * @param {?} _elementsReducer
     */
    constructor(_elementsReducer) {
        this._elementsReducer = _elementsReducer;
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        this.isView = this.data.isView;
        if (this.isView) {
            setTimeout(() => {
                this.onShortTextChange();
            }, 300);
        }
    }
    /**
     * @return {?}
     */
    ngOnDestroy() {
        if (this.isView) {
            this.shortTextInputSub.unsubscribe();
        }
    }
    /**
     * @return {?}
     */
    onShortTextChange() {
        /** @type {?} */
        const $shortTextInput = document.getElementById(`short-text-input-${this.data.element.id}`);
        this.shortTextInputSub = fromEvent($shortTextInput, 'input').pipe(map((event) => event.target.value), distinctUntilChanged(), debounceTime(1000)).subscribe(answer => {
            this._elementsReducer.elementsReducer({
                type: ElementsActionTypes.QUESTION_UPDATE_ANSWER_ACTION,
                payload: {
                    pageId: this.data.element.pageId,
                    elementId: this.data.element.id,
                    answer,
                    pageFlowModifier: this.data.element.question.pageFlowModifier,
                    pageFlow: this.data.element.pageFlow,
                }
            });
        });
    }
}
ShortTextComponent.decorators = [
    { type: Component, args: [{
                selector: 'ngs-short-text',
                template: "<h4>{{data.title}}</h4>\n<form>\n  <div class=\"form-group\">\n    <input\n      type=\"text\"\n      [id]=\"'short-text-input-' + data.element.id\"\n      class=\"form-control\"\n      id=\"short-text-question\"\n      placeholder=\"Short answer text\"\n      name=\"shortText\"\n      [ngModel]=\"data?.element.question.answer\"\n      [disabled]=\"!isView\">\n  </div>\n</form>\n",
                styles: [""]
            }] }
];
/** @nocollapse */
ShortTextComponent.ctorParameters = () => [
    { type: ElementsReducer }
];
ShortTextComponent.propDecorators = {
    data: [{ type: Input }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class LongTextComponent {
    /**
     * @param {?} _elementsReducer
     */
    constructor(_elementsReducer) {
        this._elementsReducer = _elementsReducer;
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        this.isView = this.data.isView;
        if (this.isView) {
            setTimeout(() => {
                this.onLongTextChange();
            }, 300);
        }
    }
    /**
     * @return {?}
     */
    ngOnDestroy() {
        if (this.isView) {
            this.longTextInputSub.unsubscribe();
        }
    }
    /**
     * @return {?}
     */
    onLongTextChange() {
        /** @type {?} */
        const $longTextInput = document.getElementById(`long-text-input-${this.data.element.id}`);
        this.longTextInputSub = fromEvent($longTextInput, 'input').pipe(map((event) => event.target.value), distinctUntilChanged(), debounceTime(1000)).subscribe(answer => {
            this._elementsReducer.elementsReducer({
                type: ElementsActionTypes.QUESTION_UPDATE_ANSWER_ACTION,
                payload: {
                    pageId: this.data.element.pageId,
                    elementId: this.data.element.id,
                    answer,
                    pageFlowModifier: this.data.element.question.pageFlowModifier,
                    pageFlow: this.data.element.pageFlow,
                }
            });
        });
    }
}
LongTextComponent.decorators = [
    { type: Component, args: [{
                selector: 'ngs-long-text',
                template: "<h4>{{data.title}}</h4>\n<form>\n  <div class=\"form-group\">\n    <input\n      type=\"text\"\n      [id]=\"'long-text-input-' + data.element.id\"\n      class=\"form-control\"\n      placeholder=\"Long answer text\"\n      name=\"longText\"\n      [ngModel]=\"data?.element.question.answer\"\n      [disabled]=\"!isView\"\n    >\n  </div>\n</form>\n",
                styles: [""]
            }] }
];
/** @nocollapse */
LongTextComponent.ctorParameters = () => [
    { type: ElementsReducer }
];
LongTextComponent.propDecorators = {
    data: [{ type: Input }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class QuestionBuilderDirective {
    /**
     * @param {?} viewContainerRef
     */
    constructor(viewContainerRef) {
        this.viewContainerRef = viewContainerRef;
    }
}
QuestionBuilderDirective.decorators = [
    { type: Directive, args: [{
                selector: '[sbQuestionBuilder]'
            },] }
];
/** @nocollapse */
QuestionBuilderDirective.ctorParameters = () => [
    { type: ViewContainerRef }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class QuestionItemComponent {
    /**
     * @param {?} component
     * @param {?=} data
     */
    constructor(component, data) {
        this.component = component;
        this.data = data;
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class DateComponent {
    /**
     * @param {?} _elementsReducer
     */
    constructor(_elementsReducer) {
        this._elementsReducer = _elementsReducer;
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        this.isView = this.data.isView;
        if (this.isView) {
            setTimeout(() => {
                this.onDateChange();
            }, 300);
        }
    }
    /**
     * @return {?}
     */
    ngOnDestroy() {
        if (this.isView) {
            this.dateTextInputSub.unsubscribe();
        }
    }
    /**
     * @return {?}
     */
    onDateChange() {
        /** @type {?} */
        const $dateInput = document.getElementById(`date-input-${this.data.element.id}`);
        this.dateTextInputSub = fromEvent($dateInput, 'input').pipe(map((event) => event.target.value), distinctUntilChanged(), debounceTime(1000)).subscribe(answer => {
            this._elementsReducer.elementsReducer({
                type: ElementsActionTypes.QUESTION_UPDATE_ANSWER_ACTION,
                payload: {
                    pageId: this.data.element.pageId,
                    elementId: this.data.element.id,
                    answer,
                    pageFlowModifier: this.data.element.question.pageFlowModifier,
                    pageFlow: this.data.element.pageFlow,
                }
            });
        });
    }
}
DateComponent.decorators = [
    { type: Component, args: [{
                selector: 'ngs-date',
                template: "<h4>{{data.title}}</h4>\n<form>\n  <div class=\"form-group\">\n    <input\n      type=\"date\"\n      [id]=\"'date-input-' + data.element.id\"\n      name=\"date\"\n      class=\"form-control\"\n      [ngModel]=\"data?.element.question.answer\"\n      [disabled]=\"!isView\">\n  </div>\n</form>\n",
                styles: [""]
            }] }
];
/** @nocollapse */
DateComponent.ctorParameters = () => [
    { type: ElementsReducer }
];
DateComponent.propDecorators = {
    data: [{ type: Input }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class RangeComponent {
    /**
     * @param {?} _elementsReducer
     */
    constructor(_elementsReducer) {
        this._elementsReducer = _elementsReducer;
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        this.element = this.data.element;
        this.pageId = this.data.element.pageId;
        this.isView = this.data.isView;
        if (!this.isView) {
            setTimeout(() => {
                this.onMinChange();
                this.onMaxChange();
            }, 300);
        }
        else {
            setTimeout(() => {
                this.onRangeChange();
            }, 300);
        }
    }
    /**
     * @return {?}
     */
    ngOnDestroy() {
        if (this.isView) {
            this.rangeInputSub.unsubscribe();
        }
    }
    /**
     * @return {?}
     */
    onMinChange() {
        /** @type {?} */
        const $min = document.getElementById(`min-range-${this.element.id}`);
        this.minSub = fromEvent($min, 'input').pipe(map$1((event) => event.target.value), distinctUntilChanged(), debounceTime(1000)).subscribe(min => this._elementsReducer.elementsReducer({
            type: ElementsActionTypes.QUESTION_UPDATE_MIN_ACTION,
            payload: {
                pageId: this.pageId,
                elementId: this.element.id,
                min
            }
        }));
    }
    /**
     * @return {?}
     */
    onMaxChange() {
        /** @type {?} */
        const $max = document.getElementById(`max-range-${this.element.id}`);
        this.maxSub = fromEvent($max, 'input').pipe(map$1((event) => event.target.value), distinctUntilChanged(), debounceTime(1000)).subscribe(max => this._elementsReducer.elementsReducer({
            type: ElementsActionTypes.QUESTION_UPDATE_MAX_ACTION,
            payload: {
                pageId: this.pageId,
                elementId: this.element.id,
                max
            }
        }));
    }
    /**
     * @return {?}
     */
    onRangeChange() {
        /** @type {?} */
        const $rangeInput = document.getElementById(`range-input-${this.element.id}`);
        this.rangeInputSub = fromEvent($rangeInput, 'input').pipe(map$1((event) => event.target.value), distinctUntilChanged(), debounceTime(1000)).subscribe(answer => {
            this._elementsReducer.elementsReducer({
                type: ElementsActionTypes.QUESTION_UPDATE_ANSWER_ACTION,
                payload: {
                    pageId: this.element.pageId,
                    elementId: this.element.id,
                    answer,
                    pageFlowModifier: this.data.element.question.pageFlowModifier,
                    pageFlow: this.data.element.pageFlow,
                }
            });
        });
    }
}
RangeComponent.decorators = [
    { type: Component, args: [{
                selector: 'ngs-range',
                template: "<div *ngIf=\"!isView\" class=\"row mt-5\">\n  <h4>{{data.title}}</h4>\n  <div class=\"col-8 offset-2\">\n    <form class=\"form-inline\">\n      <div class=\"form-group mb-2\">\n        <label class=\"mr-3 text-2x\">Range from </label>\n        <input type=\"number\" name=\"min\" class=\"form-control\" [id]=\"'min-range-' + element.id\" [ngModel]=\"element.question.min\" placeholder=\"Min Value\">\n      </div>\n      <div class=\"form-group mx-sm-3 mb-2\">\n        <label class=\"mr-3 text-2x\">to</label>\n        <input type=\"number\" name=\"max\" class=\"form-control\" [id]=\"'max-range-' + element.id\" [ngModel]=\"element.question.max\" placeholder=\"Max Value\">\n      </div>\n    </form>\n\n    <!-- Range Input -->\n    <div class=\"form-group mt-5\">\n      <input type=\"range\" class=\"form-control-range\" id=\"formControlRange\" disabled>\n    </div>\n    <!-- #/Range Input -->\n\n  </div>\n</div>\n\n<!-- Range Input -->\n<div class=\"form-group\" *ngIf=\"isView\">\n  <label [for]=\"'range' + element.id\"><h2>{{element.question.text}}</h2></label>\n  <span class=\"d-flex flex-row justify-content-between\">\n    <input\n      type=\"range\"\n      [id]=\"'range-input-' + element.id\"\n      class=\"custom-range\"\n      name=\"range-input\"\n      [(ngModel)]=\"data?.element.question.answer\"\n      [min]=\"element?.question.min\"\n      [max]=\"element?.question.max\"\n    >\n    <h1 class=\"ml-5\">{{data?.element.question.answer}}</h1>\n  </span>\n</div>\n<!-- #/Range Input -->\n",
                styles: [""]
            }] }
];
/** @nocollapse */
RangeComponent.ctorParameters = () => [
    { type: ElementsReducer }
];
RangeComponent.propDecorators = {
    data: [{ type: Input }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class RadioCheckboxSelectComponent {
    /**
     * @param {?} _ngSurveyStore
     * @param {?} _elementsReducer
     * @param {?} _optionAnswersReducer
     */
    constructor(_ngSurveyStore, _elementsReducer, _optionAnswersReducer) {
        this._ngSurveyStore = _ngSurveyStore;
        this._elementsReducer = _elementsReducer;
        this._optionAnswersReducer = _optionAnswersReducer;
        this.isPageNavChecked = false;
        this.isSaved = false;
        this.isNewOption = false;
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        this.pageId = this.data.element.pageId;
        this.surveyId = this.data.surveyId;
        this.elementSub = this._ngSurveyStore.elements.subscribe(res => {
            if (res && this.pageId) {
                /** @type {?} */
                const elements = res.get(this.pageId);
                if (elements) {
                    this.element = elements.get(this.data.element.id);
                }
            }
        });
        this.optionAnswersSub = this._ngSurveyStore.optionAnswers.subscribe(res => {
            this.optionAnswers = res.get(this.data.element.id);
            if (this.optionAnswers) {
                this.optionAnswersSize = this.optionAnswers.size;
            }
        });
        setTimeout(() => {
            this.onSaveQuestionClick();
        }, 300);
    }
    /**
     * @return {?}
     */
    ngOnDestroy() {
        this.elementSub.unsubscribe();
        this.optionAnswersSub.unsubscribe();
    }
    /**
     * @param {?} e
     * @return {?}
     */
    togglePageNavChecked(e) {
        this.isPageNavChecked = e.target.checked;
        this._elementsReducer.elementsReducer({
            type: ElementsActionTypes.QUESTION_UPDATE_PAGE_FLOW_MODIFIER_ACTION,
            payload: {
                pageId: this.pageId,
                elementId: this.element.id,
                pageFlowModifier: this.isPageNavChecked
            }
        });
    }
    /**
     * @return {?}
     */
    addOptionInput() {
        if (!this.element.isSaved) {
            this._optionAnswersReducer.optionAnswersReducer({
                type: OptionAnswersActionTypes.ADD_OPTION_ANSWERS_ACTION,
                payload: {
                    elementId: this.element.id
                }
            });
            this.isNewOption = true;
        }
    }
    /**
     * @param {?} event
     * @return {?}
     */
    drop(event) {
        this._optionAnswersReducer.optionAnswersReducer({
            type: OptionAnswersActionTypes.DRAG_OPTION_ANSWERS_ACTION,
            payload: {
                elementId: this.element.id,
                startIndex: event.previousIndex,
                endIndex: event.currentIndex,
            }
        });
    }
    /**
     * @return {?}
     */
    onSaveQuestionClick() {
        /** @type {?} */
        const $saveQuestionButton = document.getElementById(`save-question-button-${this.element.id}`);
        if ($saveQuestionButton) {
            fromEvent($saveQuestionButton, 'click').pipe(map(event => event)).subscribe(res => {
                if (res) {
                    this.isSaved = true;
                    this.onEditQuestionClick();
                }
            });
        }
    }
    /**
     * @return {?}
     */
    onEditQuestionClick() {
        /** @type {?} */
        const $editQuestionButton = document.getElementById(`edit-question-button-${this.element.id}`);
        fromEvent($editQuestionButton, 'click').pipe(map(event => event)).subscribe(res => {
            if (res) {
                this.isSaved = false;
                this.onSaveQuestionClick();
            }
        });
    }
    /**
     * @param {?} index
     * @param {?} item
     * @return {?}
     */
    trackElement(index, item) {
        return item ? item.key : null;
    }
}
RadioCheckboxSelectComponent.decorators = [
    { type: Component, args: [{
                selector: 'ngs-radio-checkbox-select',
                template: "<div class=\"card\">\n  <div class=\"card-body\">\n    <h4>{{data.title}}</h4>\n\n    <div class=\"row\">\n      <div class=\"col-md-9 offset-md-2 col-12\">\n        <form>\n          <div class=\"form-group form-check\" *ngIf=\"element?.showPageFlowToggle && (data.type === 'radio' || data.type === 'select')\">\n            <input\n              id=\"pageNavCheckbox\"\n              type=\"checkbox\"\n              name=\"isPageNavChecked\"\n              class=\"form-check-input\"\n              [disabled]=\"element?.isSaved\"\n              [(ngModel)]=\"element?.question.pageFlowModifier\"\n              (change)=\"togglePageNavChecked($event)\"\n            >\n            <label class=\"form-check-label\" for=\"pageNavCheckbox\">Go to page based on answer</label>\n          </div>\n          <div cdkDropList [cdkDropListData]=\"optionAnswers\" [cdkDropListDisabled]=\"element?.isSaved\" #optionAnswers%=\"cdkDropList\" (cdkDropListDropped)=\"drop($event)\">\n            <div *ngFor=\"let item of optionAnswers | mapValues; trackBy: trackElement\" cdkDrag>\n              <!-- Drag and Drop Background Place Holder -->\n              <div class=\"drag-drop-placeholder-question-option\" *cdkDragPlaceholder></div>\n              <!-- #/Drag and Drop Background Place Holder -->\n                <div class=\"d-flex flex-md-row flex-column align-items-md-center align-items-start option-min-height mb-md-0 mb-3\">\n                  <!-- Move Option Button -->\n                  <span *ngIf=\"!element?.isSaved\" class=\"mr-3 mb-3\">\n                    <button type=\"button\" class=\"btn btn-outline-secondary\" tooltip=\"Drag and Drop Option\" cdkDragHandle>\n                      <i class=\"fas fa-arrows-alt\"></i>\n                    </button>\n                  </span>\n                  <!-- #/Move Option Button -->\n\n                  <!-- Option Template -->\n                  <ngs-option-template\n                    class=\"w-100\"\n                    [optionAnswersSize]=\"optionAnswersSize\"\n                    [optionAnswer]=\"item.value\"\n                    [element]=\"element\"\n                    [isPageNavChecked]=\"isPageNavChecked\"\n                    [surveyId]=\"surveyId\"\n                    [isNewOption]=\"isNewOption\"\n                  ></ngs-option-template>\n                  <!-- #/Option Template -->\n                </div>\n            </div>\n          </div>\n          <!-- Add Option Input -->\n          <span *ngIf=\"!element?.isSaved\" (click)=\"addOptionInput()\">\n            <div class=\"row\">\n              <div class=\"col-md-5 col-12\">\n                <input\n                  class=\"form-control ml-md-5 ml-0\"\n                  name=\"radioTemplate\"\n                  type=\"text\"\n                  placeholder=\"Click to add options\"\n                  disabled\n                >\n              </div>\n            </div>\n          </span>\n          <!-- #/Add Option Input -->\n        </form>\n      </div>\n    </div>\n  </div>\n</div>\n",
                styles: [".cdk-drop-list-dragging .cdk-drag{transition:transform 250ms cubic-bezier(0,0,.2,1);transition:transform 250ms cubic-bezier(0,0,.2,1),-webkit-transform 250ms cubic-bezier(0,0,.2,1)}.cdk-drag-animating{transition:transform .3s cubic-bezier(0,0,.2,1);transition:transform .3s cubic-bezier(0,0,.2,1),-webkit-transform .3s cubic-bezier(0,0,.2,1)}.cdk-drag-preview{box-sizing:border-box;border-radius:4px;box-shadow:0 5px 5px -3px rgba(0,0,0,.2),0 8px 10px 1px rgba(0,0,0,.14),0 3px 14px 2px rgba(0,0,0,.12)}.drag-drop-placeholder-question{background:rgba(0,0,0,.03);border:1px solid rgba(0,0,0,.125);border-radius:10px;min-height:400px;transition:transform 250ms cubic-bezier(0,0,.2,1);transition:transform 250ms cubic-bezier(0,0,.2,1),-webkit-transform 250ms cubic-bezier(0,0,.2,1)}.option-min-height{min-height:65px}.drag-drop-placeholder-question-option{background:rgba(0,0,0,.03);border:1px solid rgba(0,0,0,.125);border-radius:10px;min-height:65px;transition:transform 250ms cubic-bezier(0,0,.2,1);transition:transform 250ms cubic-bezier(0,0,.2,1),-webkit-transform 250ms cubic-bezier(0,0,.2,1)}"]
            }] }
];
/** @nocollapse */
RadioCheckboxSelectComponent.ctorParameters = () => [
    { type: NgSurveyStore },
    { type: ElementsReducer },
    { type: OptionAnswersReducer }
];
RadioCheckboxSelectComponent.propDecorators = {
    data: [{ type: Input }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class SelectComponent {
    /**
     * @param {?} _ngSurveyStore
     * @param {?} _elementsReducer
     */
    constructor(_ngSurveyStore, _elementsReducer) {
        this._ngSurveyStore = _ngSurveyStore;
        this._elementsReducer = _elementsReducer;
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        this.optionAnswersSub = this._ngSurveyStore.optionAnswers.subscribe(res => {
            this.optionAnswers = res.get(this.data.element.id);
        });
    }
    /**
     * @return {?}
     */
    ngOnDestroy() {
        this.optionAnswersSub.unsubscribe();
    }
    /**
     * @param {?} answer
     * @param {?} pageFlow
     * @return {?}
     */
    handleSelect(answer, pageFlow) {
        this._elementsReducer.elementsReducer({
            type: ElementsActionTypes.QUESTION_UPDATE_ANSWER_ACTION,
            payload: {
                pageId: this.data.element.pageId,
                elementId: this.data.element.id,
                answer,
                pageFlowModifier: this.data.element.question.pageFlowModifier,
                pageFlow,
            }
        });
    }
    /**
     * @param {?} index
     * @param {?} item
     * @return {?}
     */
    trackElement(index, item) {
        return item ? item.key : null;
    }
}
SelectComponent.decorators = [
    { type: Component, args: [{
                selector: 'ngs-select',
                template: "<form>\n  <div *ngIf=\"optionAnswers.size > 0\" class=\"form-group\">\n    <label for=\"select\">Example select</label>\n    <select\n      class=\"form-control\" id=\"select\"\n      name=\"select\"\n      [(ngModel)]=\"data?.element.question.answer\"\n      (ngModelChange)=\"handleSelect($event, item?.value.pageFlow)\"\n    >\n      <option disabled selected [value]=\"''\">Select</option>\n      <option\n        *ngFor=\"let item of optionAnswers | mapValues; trackBy:trackElement\"\n        [value]=\"item?.value.value\">\n        {{item?.value.value}}\n      </option>\n    </select>\n  </div>\n</form>\n",
                styles: [""]
            }] }
];
/** @nocollapse */
SelectComponent.ctorParameters = () => [
    { type: NgSurveyStore },
    { type: ElementsReducer }
];
SelectComponent.propDecorators = {
    data: [{ type: Input }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class CheckboxComponent {
    /**
     * @param {?} _ngSurveyStore
     * @param {?} _elementsReducer
     * @param {?} formBuilder
     */
    constructor(_ngSurveyStore, _elementsReducer, formBuilder) {
        this._ngSurveyStore = _ngSurveyStore;
        this._elementsReducer = _elementsReducer;
        this.formBuilder = formBuilder;
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        this.optionAnswersSub = this._ngSurveyStore.optionAnswers.subscribe(res => {
            this.optionAnswers = res.get(this.data.element.id);
        });
        /** @type {?} */
        const answer = this.data.element.question.answer;
        /** @type {?} */
        const controls = Array.from(this.optionAnswers).map(c => {
            if (answer.indexOf(c[1].value) >= 0) {
                return new FormControl(true);
            }
            else {
                return new FormControl(false);
            }
        });
        this.form = this.formBuilder.group({
            optionAnswers: new FormArray(controls, this.minSelectedCheckboxes(1))
        });
    }
    /**
     * @return {?}
     */
    ngOnDestroy() {
        this.optionAnswersSub.unsubscribe();
    }
    /**
     * @private
     * @param {?=} min
     * @return {?}
     */
    minSelectedCheckboxes(min = 1) {
        /** @type {?} */
        const validator = (formArray) => {
            /** @type {?} */
            const totalSelected = formArray.controls
                .map(control => control.value)
                .reduce((prev, next) => next ? prev + next : prev, 0);
            return totalSelected >= min ? null : { required: true };
        };
        return validator;
    }
    /**
     * @param {?} pageFlow
     * @return {?}
     */
    handleChange(pageFlow) {
        /** @type {?} */
        const selectedOrderIds = this.form.value.optionAnswers
            .map((v, i) => v ? Array.from(this.optionAnswers)[i][1].value : null)
            .filter(v => v !== null);
        /** @type {?} */
        const answer = selectedOrderIds.toString();
        this._elementsReducer.elementsReducer({
            type: ElementsActionTypes.QUESTION_UPDATE_ANSWER_ACTION,
            payload: {
                pageId: this.data.element.pageId,
                elementId: this.data.element.id,
                answer,
                pageFlowModifier: this.data.element.question.pageFlowModifier,
                pageFlow,
            }
        });
    }
    /**
     * @param {?} index
     * @param {?} item
     * @return {?}
     */
    trackElement(index, item) {
        return item ? item.key : null;
    }
}
CheckboxComponent.decorators = [
    { type: Component, args: [{
                selector: 'ngs-checkbox',
                template: "<h4>{{data.title}}</h4>\n\n<form [formGroup]=\"form\">\n  <label\n    class=\"container\"\n    formArrayName=\"optionAnswers\"\n    *ngFor=\"let item of optionAnswers | mapValues; trackBy: trackElement; let i = index\">\n    <span>{{item?.value.value}}</span>\n    <input type=\"checkbox\" [formControlName]=\"i\" (change)=\"handleChange(item?.value.pageFlow)\">\n    <span class=\"checkmark\"></span>\n  </label>\n\n  <div *ngIf=\"!form.valid\" class=\"text-red\">At least one checkbox must be selected</div>\n  <br>\n</form>\n\n",
                styles: [".container{display:block;position:relative;padding-left:35px;margin-bottom:12px;cursor:pointer;font-size:22px;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none}.container input{position:absolute;opacity:0;cursor:pointer;height:0;width:0}.checkmark{position:absolute;bottom:0;left:0;height:25px;width:25px;background-color:#eee}.container:hover input~.checkmark{background-color:#ccc}.container input:checked~.checkmark{background-color:#2196f3}.checkmark:after{content:\"\";position:absolute;display:none}.container input:checked~.checkmark:after{display:block}.container .checkmark:after{left:9px;top:5px;width:5px;height:10px;border:solid #fff;border-width:0 3px 3px 0;-webkit-transform:rotate(45deg);transform:rotate(45deg)}"]
            }] }
];
/** @nocollapse */
CheckboxComponent.ctorParameters = () => [
    { type: NgSurveyStore },
    { type: ElementsReducer },
    { type: FormBuilder }
];
CheckboxComponent.propDecorators = {
    data: [{ type: Input }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class RadioComponent {
    /**
     * @param {?} _ngSurveyStore
     * @param {?} _elementsReducer
     */
    constructor(_ngSurveyStore, _elementsReducer) {
        this._ngSurveyStore = _ngSurveyStore;
        this._elementsReducer = _elementsReducer;
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        this.optionAnswersSub = this._ngSurveyStore.optionAnswers.subscribe(res => {
            this.optionAnswers = res.get(this.data.element.id);
        });
    }
    /**
     * @return {?}
     */
    ngOnDestroy() {
        this.optionAnswersSub.unsubscribe();
    }
    /**
     * @param {?} answer
     * @param {?} pageFlow
     * @return {?}
     */
    handleChange(answer, pageFlow) {
        this._elementsReducer.elementsReducer({
            type: ElementsActionTypes.QUESTION_UPDATE_ANSWER_ACTION,
            payload: {
                pageId: this.data.element.pageId,
                elementId: this.data.element.id,
                answer,
                pageFlowModifier: this.data.element.question.pageFlowModifier,
                pageFlow,
            }
        });
    }
    /**
     * @param {?} index
     * @param {?} item
     * @return {?}
     */
    trackElement(index, item) {
        return item ? item.key : null;
    }
}
RadioComponent.decorators = [
    { type: Component, args: [{
                selector: 'ngs-radio',
                template: "<h4>{{data.title}}</h4>\n<div class=\"custom-control custom-radio\" *ngFor=\"let item of optionAnswers | mapValues; trackBy: trackElement;\">\n  <input\n    type=\"radio\"\n    [id]=\"'radio' + item?.key\"\n    name=\"customRadio\"\n    class=\"custom-control-input\"\n    [value]=\"item?.value.value\"\n    [(ngModel)]=\"data?.element.question.answer\"\n    (ngModelChange)=\"handleChange($event, item?.value.pageFlow)\"\n  >\n  <label class=\"custom-control-label\" [for]=\"'radio' + item?.key\">{{item?.value.value}}</label>\n</div>\n",
                styles: [""]
            }] }
];
/** @nocollapse */
RadioComponent.ctorParameters = () => [
    { type: NgSurveyStore },
    { type: ElementsReducer }
];
RadioComponent.propDecorators = {
    data: [{ type: Input }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class QuestionBuilderService {
    constructor() { }
    /**
     * @param {?} type
     * @param {?} element
     * @param {?} surveyId
     * @param {?} isView
     * @return {?}
     */
    getElementTypeComponent(type, element, surveyId, isView) {
        /** @type {?} */
        let title = '';
        /** @type {?} */
        let component;
        if (type === 'shortText') {
            component = ShortTextComponent;
            title = isView ? element.question.text : 'Short Text Question Template';
        }
        else if (type === 'longText') {
            component = LongTextComponent;
            title = isView ? element.question.text : 'Long Text Question Template';
        }
        else if (type === 'radio') {
            component = isView ? RadioComponent : RadioCheckboxSelectComponent;
            title = isView ? element.question.text : 'Radio Question Template';
        }
        else if (type === 'checkboxes') {
            component = isView ? CheckboxComponent : RadioCheckboxSelectComponent;
            title = isView ? element.question.text : 'Checkbox Question Template';
        }
        else if (type === 'select') {
            component = isView ? SelectComponent : RadioCheckboxSelectComponent;
            title = isView ? element.question.text : 'Select Question Template';
        }
        else if (type === 'date') {
            component = DateComponent;
            title = isView ? element.question.text : 'Date Question Template';
        }
        else if (type === 'range') {
            component = RangeComponent;
            title = isView ? element.question.text : 'Range Question Template';
        }
        return new QuestionItemComponent(component, {
            title,
            type,
            element,
            surveyId,
            isView,
        });
    }
}
QuestionBuilderService.decorators = [
    { type: Injectable }
];
/** @nocollapse */
QuestionBuilderService.ctorParameters = () => [];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class QuestionBuilderComponent {
    /**
     * @param {?} componentFactoryResolver
     * @param {?} questionBuilder$
     */
    constructor(componentFactoryResolver, questionBuilder$) {
        this.componentFactoryResolver = componentFactoryResolver;
        this.questionBuilder$ = questionBuilder$;
        this.hasQuestion = false;
        // initialize a private variable _questions as a BehaviorSubject
        this._questionType = new BehaviorSubject(null);
    }
    // change questions to use getter and setter
    /**
     * @param {?} value
     * @return {?}
     */
    set questionType(value) {
        // set the latest value for _questions BehaviorSubject
        this._questionType.next(value);
    }
    /**
     * @return {?}
     */
    get questionType() {
        // get the latest value from _questions BehaviorSubject
        return this._questionType.getValue();
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        this._questionType.subscribe((payload) => {
            if (!!payload) {
                this.hasQuestion = true;
                setTimeout(() => {
                    this.question = this.questionBuilder$.getElementTypeComponent(payload, this.element, this.surveyId, this.isView);
                    this.loadComponent();
                }, 300);
            }
            else {
                this.hasQuestion = false;
            }
        });
    }
    /**
     * @return {?}
     */
    loadComponent() {
        /** @type {?} */
        const questionItem = this.question;
        /** @type {?} */
        const componentFactory = this.componentFactoryResolver.resolveComponentFactory(questionItem.component);
        /** @type {?} */
        const viewContainerRef = this.questionBuilderHost.viewContainerRef;
        viewContainerRef.clear();
        /** @type {?} */
        const componentRef = viewContainerRef.createComponent(componentFactory);
        if (!!questionItem.data) {
            ((/** @type {?} */ (componentRef.instance))).data = questionItem.data;
        }
    }
}
QuestionBuilderComponent.decorators = [
    { type: Component, args: [{
                selector: 'ngs-question-builder-component',
                template: `
    <div *ngIf="hasQuestion">
      <ng-template sbQuestionBuilder></ng-template>
    </div>
  `
            }] }
];
/** @nocollapse */
QuestionBuilderComponent.ctorParameters = () => [
    { type: ComponentFactoryResolver },
    { type: QuestionBuilderService }
];
QuestionBuilderComponent.propDecorators = {
    element: [{ type: Input }],
    surveyId: [{ type: Input }],
    isView: [{ type: Input }],
    questionType: [{ type: Input }],
    questionBuilderHost: [{ type: ViewChild, args: [QuestionBuilderDirective,] }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class OptionTemplateComponent {
    /**
     * @param {?} _ngSurveyStore
     * @param {?} _optionAnswersReducer
     */
    constructor(_ngSurveyStore, _optionAnswersReducer) {
        this._ngSurveyStore = _ngSurveyStore;
        this._optionAnswersReducer = _optionAnswersReducer;
        this.isOptionActive = true;
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        setTimeout(() => {
            this.pagesSub = this._ngSurveyStore.pages.subscribe(res => this.pages = res);
            if (this.isNewOption) {
                /** @type {?} */
                const $optionTemplateInput = document.getElementById(`optionTemplateInput-${this.optionAnswer.id}`);
                $optionTemplateInput.focus();
                this.isNewOption = false;
            }
            this.onOptionsValueChange();
        }, 300);
    }
    /**
     * @return {?}
     */
    ngOnDestroy() {
        if (this.pagesSub) {
            this.pagesSub.unsubscribe();
        }
    }
    /**
     * @param {?} e
     * @return {?}
     */
    onFocus(e) {
        if (e.returnValue && this.optionAnswer.orderNo === this.optionAnswersSize) {
            this.isOptionActive = e.returnValue;
        }
    }
    /**
     * @return {?}
     */
    removeOptionAnswer() {
        this._optionAnswersReducer.optionAnswersReducer({
            type: OptionAnswersActionTypes.REMOVE_OPTION_ANSWERS_ACTION,
            payload: {
                elementId: this.element.id,
                optionAnswerId: this.optionAnswer.id
            }
        });
    }
    /**
     * @return {?}
     */
    onOptionsValueChange() {
        /** @type {?} */
        const $optionTemplateInput = document.getElementById(`optionTemplateInput-${this.optionAnswer.id}`);
        /** @type {?} */
        const optionTemplateInput$ = fromEvent($optionTemplateInput, 'input').pipe(map((event) => event.target.value), distinctUntilChanged$1(), debounceTime$1(1000));
        optionTemplateInput$.subscribe(value => {
            this._optionAnswersReducer.optionAnswersReducer({
                type: OptionAnswersActionTypes.ADD_OPTION_ANSWERS_VALUE_ACTION,
                payload: {
                    elementId: this.element.id,
                    optionAnswerId: this.optionAnswer.id,
                    value
                }
            });
        });
    }
    /**
     * @param {?} index
     * @param {?} item
     * @return {?}
     */
    trackElement(index, item) {
        return item ? item.key : null;
    }
}
OptionTemplateComponent.decorators = [
    { type: Component, args: [{
                selector: 'ngs-option-template',
                template: "<div class=\"form-group d-flex flex-md-row flex-column align-items-md-center align-items-start\">\n  <!-- Option Type Icon -->\n  <div class=\"d-md-block d-none\">\n    <label *ngIf=\"element.question.type === 'radio'\" [for]=\"'optionTemplateInput-' + optionAnswer.id\" class=\"mr-3 mb-0\"><i class=\"fas fa-dot-circle\"></i></label>\n    <label *ngIf=\"element.question.type === 'checkboxes'\" [for]=\"'optionTemplateInput-' + optionAnswer.id\" class=\"mr-3 mb-0\"><i class=\"fas fa-check-square\"></i></label>\n    <label *ngIf=\"element.question.type === 'select'\" [for]=\"'optionTemplateInput-' + optionAnswer.id\" class=\"mr-3 mb-0\"><i class=\"fas fa-chevron-circle-down\"></i></label>\n  </div>\n  <!-- #/Option Type Icon -->\n\n  <div class=\"d-flex flex-row\">\n    <!-- Option Input -->\n    <input\n      [id]=\"'optionTemplateInput-' + optionAnswer.id\"\n      class=\"form-control w-100\"\n      name=\"radioTemplate\"\n      type=\"text\"\n      placeholder=\"Click to add options\"\n      (focus)=\"onFocus($event)\"\n      [ngModel]=\"optionAnswer.value\"\n      [disabled]=\"optionAnswer?.isSaved\"\n    >\n    <!-- #/Option Input -->\n\n    <!-- Remove Option Button -->\n    <span *ngIf=\"!optionAnswer?.isSaved\" class=\"ml-3 mb-0\">\n      <button type=\"button\" class=\"btn btn-outline-primary\" tooltip=\"Remove Option\" (click)=\"removeOptionAnswer()\">\n        <i class=\"fas fa-times\"></i>\n      </button>\n    </span>\n    <!-- #/Remove Option Button -->\n  </div>\n\n  <!-- Navigate to page selection -->\n  <ngs-page-select\n    [isPage]=\"false\"\n    [surveyId]=\"surveyId\"\n    [elementId]=\"element?.id\"\n    [pageId]=\"element?.pageId\"\n    [pageFlow]=\"optionAnswer.pageFlow\"\n    [isOptionAnswerSaved]=\"optionAnswer?.isSaved\"\n    [optionAnswerId]=\"optionAnswer?.id\"\n    [questionPageFlowModifier]=\"element.question.pageFlowModifier\"\n  ></ngs-page-select>\n  <!-- #/Navigate to page selection -->\n</div>\n",
                styles: [""]
            }] }
];
/** @nocollapse */
OptionTemplateComponent.ctorParameters = () => [
    { type: NgSurveyStore },
    { type: OptionAnswersReducer }
];
OptionTemplateComponent.propDecorators = {
    optionAnswersSize: [{ type: Input }],
    optionAnswer: [{ type: Input }],
    element: [{ type: Input }],
    isPageNavChecked: [{ type: Input }],
    surveyId: [{ type: Input }],
    isNewOption: [{ type: Input }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class PageBuilderContainerComponent {
    /**
     * @param {?} _ngSurveyStore
     * @param {?} _pagesReducer
     * @param {?} _elementsReducer
     */
    constructor(_ngSurveyStore, _pagesReducer, _elementsReducer) {
        this._ngSurveyStore = _ngSurveyStore;
        this._pagesReducer = _pagesReducer;
        this._elementsReducer = _elementsReducer;
        this.isSavedMap = new Map();
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        this.pageSizeSub = this._ngSurveyStore.pages.subscribe(res => {
            this.pageSize = res.size;
        });
        this.elementsSub = this._ngSurveyStore.elements.subscribe(res => {
            this.elements = res.get(this.page.id);
            if (res) {
                this.elementsSize = res.size;
                this.setSavedMap();
            }
        });
    }
    /**
     * @param {?} changes
     * @return {?}
     */
    ngOnChanges(changes) {
    }
    /**
     * @return {?}
     */
    ngOnDestroy() {
        this.elementsSub.unsubscribe();
        this.pageSizeSub.unsubscribe();
    }
    /**
     * @param {?} pageId
     * @return {?}
     */
    removePage(pageId) {
        /** @type {?} */
        const elementIds = this.elements ? Array.from(this.elements).reduce((array, el) => [...array, el[0]], []) : null;
        this._pagesReducer.pagesReducer({
            type: PagesActionTypes.REMOVE_PAGE_ACTION,
            payload: { pageId, elementIds },
        });
    }
    /**
     * @param {?} previousPageId
     * @return {?}
     */
    insertPage(previousPageId) {
        /** @type {?} */
        const pageId = UUID$$1();
        this._pagesReducer.pagesReducer({
            type: PagesActionTypes.INSERT_PAGE_ACTION,
            payload: { previousPageId, surveyId: this.surveyId, pageId },
        });
    }
    /**
     * @param {?} pageId
     * @return {?}
     */
    movePageDown(pageId) {
        this._pagesReducer.pagesReducer({
            type: PagesActionTypes.MOVE_PAGE_DOWN_ACTION,
            payload: { pageId },
        });
    }
    /**
     * @param {?} pageId
     * @return {?}
     */
    movePageUp(pageId) {
        this._pagesReducer.pagesReducer({
            type: PagesActionTypes.MOVE_PAGE_UP_ACTION,
            payload: { pageId },
        });
    }
    /**
     * @param {?} pageId
     * @return {?}
     */
    addElement(pageId) {
        this._elementsReducer.elementsReducer({
            type: ElementsActionTypes.ADD_ELEMENT_ACTION,
            payload: { pageId, type: 'question' },
        });
    }
    /**
     * @param {?} pageId
     * @return {?}
     */
    addParagraph(pageId) {
        this._elementsReducer.elementsReducer({
            type: ElementsActionTypes.ADD_ELEMENT_ACTION,
            payload: { pageId, type: 'paragraph' },
        });
    }
    /**
     * @param {?} pageId
     * @return {?}
     */
    onEditPageClick(pageId) {
        this.isEditPage = true;
        setTimeout(() => {
            this.editPageName(pageId);
            this.editPageDescription(pageId);
        }, 300);
    }
    /**
     * @param {?} pageId
     * @return {?}
     */
    editPageName(pageId) {
        /** @type {?} */
        const $pageNameInput = document.getElementById(`page-name-input-${pageId}`);
        fromEvent($pageNameInput, 'input').pipe(map((event) => event.target.value), distinctUntilChanged(), debounceTime(1000)).subscribe(name => {
            this._pagesReducer.pagesReducer({
                type: PagesActionTypes.UPDATE_PAGE_NAME_ACTION,
                payload: { pageId, name },
            });
        });
    }
    /**
     * @param {?} pageId
     * @return {?}
     */
    editPageDescription(pageId) {
        /** @type {?} */
        const $pageDescriptionInput = document.getElementById(`page-description-input-${pageId}`);
        fromEvent($pageDescriptionInput, 'input').pipe(map((event) => event.target.value), distinctUntilChanged(), debounceTime(1000)).subscribe(description => {
            this._pagesReducer.pagesReducer({
                type: PagesActionTypes.UPDATE_PAGE_DESCRIPTION_ACTION,
                payload: { pageId, description },
            });
        });
    }
    /**
     * @param {?} event
     * @param {?} pageId
     * @return {?}
     */
    drop(event, pageId) {
        this._elementsReducer.elementsReducer({
            type: ElementsActionTypes.DRAG_ELEMENT_ACTION,
            payload: {
                pageId,
                startIndex: event.previousIndex,
                endIndex: event.currentIndex,
            },
        });
    }
    /**
     * @param {?} __0
     * @return {?}
     */
    handleIsSavedEvent({ key, isSaved }) {
        this.isSavedMap.set(key, isSaved);
    }
    /**
     * @private
     * @return {?}
     */
    setSavedMap() {
        if (this.elements) {
            this.elements.forEach((value, key) => {
                if (value.isSaved) {
                    this.isSavedMap.set(key, true);
                }
                else {
                    this.isSavedMap.set(key, false);
                }
            });
        }
    }
    /**
     * @param {?} index
     * @param {?} item
     * @return {?}
     */
    trackElement(index, item) {
        return item ? item.key : null;
    }
}
PageBuilderContainerComponent.decorators = [
    { type: Component, args: [{
                selector: 'ngs-page-builder-container',
                template: "<div *ngIf=\"surveyId\">\n  <div class=\"card mt-5\">\n    <!-- Card Header -->\n    <div class=\"card-header d-flex flex-md-row flex-column w-100\">\n      <div class=\"mr-auto w-md-50 w-100 mb-md-0 mb-3\">\n        <span>Page {{page?.orderNo}} of {{pageSize}}</span>\n      </div>\n      <div class=\"btn-group\" role=\"group\">\n        <button *ngIf=\"!isEditPage\" type=\"button\" class=\"btn btn-outline-primary\" tooltip=\"Edit page name and description\" (click)=\"onEditPageClick(page?.id)\">\n          <i class=\"fas fa-pencil-alt\"></i>\n        </button>\n        <button *ngIf=\"isEditPage\" type=\"button\" class=\"btn btn-outline-primary\" tooltip=\"Save page name and description\" (click)=\"isEditPage = false\">\n          <i class=\"fas fa-save\"></i>\n        </button>\n        <button type=\"button\" class=\"btn btn-outline-primary\" tooltip=\"Move Down\" (click)=\"movePageDown(page?.id)\" [disabled]=\"page?.orderNo === pageSize\">\n          <i class=\"fas fa-chevron-down\"></i>\n        </button>\n        <button type=\"button\" class=\"btn btn-outline-primary\" tooltip=\"Move Up\" (click)=\"movePageUp(page?.id)\" [disabled]=\"page?.orderNo === 1\">\n          <i class=\"fas fa-chevron-up\"></i>\n        </button>\n        <button type=\"button\" class=\"btn btn-outline-primary\" tooltip=\"Remove Page\" (click)=\"removePage(page?.id)\">\n          <i class=\"fas fa-trash-alt\"></i>\n        </button>\n      </div>\n    </div>\n    <!-- #/Card Header -->\n\n    <!-- Card Body -->\n    <div class=\"card-body bg-white\">\n      <!-- Edit Page Name and Description Form -->\n      <form *ngIf=\"isEditPage\" class=\"mb-5 mt-2\">\n        <div class=\"form-group\">\n          <label [for]=\"'page-name-input-' + page?.id\">Edit Page Name</label>\n          <input\n            [id]=\"'page-name-input-' + page?.id\"\n            name=\"page-name-input\"\n            type=\"text\"\n            class=\"form-control w-100\"\n            placeholder=\"Enter page name\"\n            [ngModel]=\"page?.name\"\n          >\n        </div>\n        <div class=\"form-group\">\n          <label [for]=\"'page-description-input-' + page?.id\">Edit Page Description</label>\n          <input\n            [id]=\"'page-description-input-' + page?.id\"\n            name=\"page-description-input\"\n            type=\"text\"\n            class=\"form-control w-100\"\n            placeholder=\"Enter page description\"\n            [ngModel]=\"page?.description\"\n          >\n        </div>\n      </form>\n      <!-- #/Edit Page Name and Description Form -->\n\n      <!-- Page Name and Description -->\n      <div *ngIf=\"!isEditPage && (page?.name || page?.description)\" class=\"d-flex flex-column mb-3 mt-2\">\n        <div *ngIf=\"page?.name\">\n          <label>Page Name</label>\n          <h4>{{page?.name}}</h4>\n        </div>\n        <div *ngIf=\"page?.description\">\n          <label>Page Description</label>\n          <h4>{{page?.description}}</h4>\n        </div>\n      </div>\n      <!-- #/Page Name and Description -->\n\n      <!-- Question Builder Container -->\n      <div cdkDropList [cdkDropListData]=\"elements\" #pageElements=\"cdkDropList\" (cdkDropListDropped)=\"drop($event, page?.id)\">\n        <div *ngFor=\"let item of elements | mapValues; trackBy: trackElement\" class=\"mb-4\" cdkDrag>\n          <!-- Drag and Drop Background Place Holder -->\n          <div class=\"drag-drop-placeholder-question\" *cdkDragPlaceholder></div>\n          <!-- #/Drag and Drop Background Place Holder -->\n          <div\n            id=\"question-builder-container\"\n            class=\"d-flex flex-row align-content-start pt-md-4 pb-md-4 pr-md-3 pl-md-3 pt-3 pb-3 pr-2 pl-2\"\n            [ngClass]=\"!isSavedMap.get(item.key) ? 'z-depth-1' : ''\">\n            <!-- Move Option Button -->\n            <span class=\"mr-3 mb-3\">\n              <button [ngClass]=\"isSavedMap.get(item.key) || elements.size === 1 ? 'd-none' : ''\" type=\"button\" class=\"btn btn-outline-secondary\" tooltip=\"Drag and Drop Question\" cdkDragHandle>\n                <i class=\"fas fa-arrows-alt\"></i>\n              </button>\n            </span>\n            <!-- #/Move Option Button -->\n\n            <!-- Question Builder Container -->\n            <div class=\"w-100\">\n              <ngs-question-builder-container\n                [element]=\"item?.value\"\n                [elementsSize]=\"elementsSize\"\n                [pageId]=\"page?.id\"\n                [surveyId]=\"surveyId\"\n                (isSavedEvent)=\"handleIsSavedEvent($event)\"\n              ></ngs-question-builder-container>\n            </div>\n            <!-- #/Question Builder Container -->\n\n            <!-- Paragraph Builder Container -->\n          </div>\n        </div>\n      </div>\n      <!-- #/Question Builder Container -->\n    </div>\n    <!-- #/Card Body -->\n\n    <!-- Card Footer -->\n    <div class=\"card-footer d-flex flex-md-row flex-column w-100 mt-1\">\n      <div class=\"mr-auto\">\n        <div class=\"btn-group\" dropdown>\n          <button type=\"button\" class=\"btn btn-outline-primary\" (click)=\"addElement(page?.id)\">Add Element</button>\n          <button id=\"button-split\" type=\"button\" dropdownToggle class=\"btn btn-outline-primary dropdown-toggle dropdown-toggle-split\" aria-controls=\"dropdown-split\">\n            <span class=\"caret\"></span>\n            <span class=\"sr-only\">Split button!</span>\n          </button>\n          <ul id=\"dropdown-split\" *dropdownMenu class=\"dropdown-menu\"\n              role=\"menu\" aria-labelledby=\"button-split\">\n            <li role=\"menuitem\"><a class=\"dropdown-item\" (click)=\"addElement(page?.id)\">Question</a></li>\n            <li role=\"menuitem\"><a class=\"dropdown-item\" (click)=\"addParagraph(page?.id)\">Paragraph</a></li>\n          </ul>\n        </div>\n      </div>\n      <div class=\"d-flex flex-md-row flex-column\" *ngIf=\"pageSize > 1\">\n        <!-- Navigate to page selection -->\n        <ngs-page-select\n          [isPage]=\"true\"\n          [surveyId]=\"surveyId\"\n          [pageId]=\"page?.id\"\n          [pageFlow]=\"page.pageFlow\"\n        ></ngs-page-select>\n        <!-- #/Navigate to page selection -->\n\n        <!-- Insert Page -->\n        <button type=\"button\" class=\"btn btn-outline-primary ml-md-4 ml-0 mt-3\" tooltip=\"Insert Page\" (click)=\"insertPage(page?.id)\">\n          <i class=\"fas fa-plus\"></i>\n        </button>\n        <!-- #/Add Page -->\n      </div>\n    </div>\n    <!-- #/Card Footer -->\n  </div>\n</div>\n",
                styles: [".dropdown-menu li:hover{cursor:pointer}.cdk-drop-list-dragging .cdk-drag{transition:transform 250ms cubic-bezier(0,0,.2,1);transition:transform 250ms cubic-bezier(0,0,.2,1),-webkit-transform 250ms cubic-bezier(0,0,.2,1)}.cdk-drag-animating{transition:transform .3s cubic-bezier(0,0,.2,1);transition:transform .3s cubic-bezier(0,0,.2,1),-webkit-transform .3s cubic-bezier(0,0,.2,1)}.cdk-drag-preview{box-sizing:border-box;border-radius:4px;box-shadow:0 5px 5px -3px rgba(0,0,0,.2),0 8px 10px 1px rgba(0,0,0,.14),0 3px 14px 2px rgba(0,0,0,.12)}.drag-drop-placeholder-question{background:rgba(0,0,0,.03);border:1px solid rgba(0,0,0,.125);border-radius:10px;min-height:400px;transition:transform 250ms cubic-bezier(0,0,.2,1);transition:transform 250ms cubic-bezier(0,0,.2,1),-webkit-transform 250ms cubic-bezier(0,0,.2,1)}.option-min-height{min-height:65px}.drag-drop-placeholder-question-option{background:rgba(0,0,0,.03);border:1px solid rgba(0,0,0,.125);border-radius:10px;min-height:65px;transition:transform 250ms cubic-bezier(0,0,.2,1);transition:transform 250ms cubic-bezier(0,0,.2,1),-webkit-transform 250ms cubic-bezier(0,0,.2,1)}.z-depth-1{box-shadow:0 2px 5px 0 rgba(0,0,0,.16),0 2px 10px 0 rgba(0,0,0,.12)}.card-body{border-left:1px solid rgba(0,0,0,.125)!important}"]
            }] }
];
/** @nocollapse */
PageBuilderContainerComponent.ctorParameters = () => [
    { type: NgSurveyStore },
    { type: PagesReducer },
    { type: ElementsReducer }
];
PageBuilderContainerComponent.propDecorators = {
    surveyId: [{ type: Input }],
    page: [{ type: Input }],
    pages: [{ type: Input }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class PageViewerContainerComponent {
    /**
     * @param {?} _ngSurveyStore
     */
    constructor(_ngSurveyStore) {
        this._ngSurveyStore = _ngSurveyStore;
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        this.elementsSub = this._ngSurveyStore.elements.subscribe(res => {
            this.elements = this.page ? res.get(this.page.id) : null;
            if (res) {
                this.elementsSize = res.size;
            }
        });
    }
    /**
     * @param {?} index
     * @param {?} item
     * @return {?}
     */
    trackElement(index, item) {
        return item ? item.key : null;
    }
}
PageViewerContainerComponent.decorators = [
    { type: Component, args: [{
                selector: 'ngs-page-viewer-container',
                template: "<div *ngFor=\"let item of elements | mapValues; trackBy: trackElement\">\n  <ngs-question-viewer-container\n    class=\"w-100\"\n    [element]=\"item?.value\"\n    [surveyId]=\"page.surveyId\"\n  ></ngs-question-viewer-container>\n</div>\n",
                styles: [""]
            }] }
];
/** @nocollapse */
PageViewerContainerComponent.ctorParameters = () => [
    { type: NgSurveyStore }
];
PageViewerContainerComponent.propDecorators = {
    page: [{ type: Input }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class ElementAndOptionAnswersModel {
    /**
     * @param {?} element
     * @param {?} optionAnswers
     */
    constructor(element, optionAnswers) {
        this.element = element;
        this.optionAnswers = optionAnswers;
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class QuestionBuilderContainerComponent {
    /**
     * @param {?} _ngSurveyStore
     * @param {?} _elementsReducer
     * @param {?} _optionAnswersReducer
     */
    constructor(_ngSurveyStore, _elementsReducer, _optionAnswersReducer) {
        this._ngSurveyStore = _ngSurveyStore;
        this._elementsReducer = _elementsReducer;
        this._optionAnswersReducer = _optionAnswersReducer;
        this.isSavedEvent = new EventEmitter();
        this.builderOptionsSub = this._ngSurveyStore.builderOptions.subscribe(res => {
            this.builderOptions = res;
            this.elementButtons = this.builderOptions.elementButtons;
            this.importElementButton = this.builderOptions.importElement;
        });
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        if (this.element.type === 'question') {
            this.questionType = this.element.question.type;
            this.prevQuestionType = this.questionType;
        }
        setTimeout(() => {
            if (!!this.questionType) {
                this.isSavedEvent.emit({ key: this.element.id, isSaved: this.element.isSaved });
            }
        }, 100);
    }
    /**
     * @param {?} cb
     * @param {?} currentElement
     * @return {?}
     */
    importElement(cb, currentElement) {
        cb().subscribe(({ element, optionAnswers }) => {
            this._elementsReducer.elementsReducer({
                type: ElementsActionTypes.IMPORT_ELEMENT,
                payload: { element, optionAnswers, pageId: this.pageId, currentElement }
            });
        });
    }
    /**
     * @param {?} element
     * @param {?} cb
     * @return {?}
     */
    handleCustomElementButton(element, cb) {
        this._ngSurveyStore.optionAnswers.pipe(map(res => {
            /** @type {?} */
            const optionAnswers = res.get(element.id);
            /** @type {?} */
            const elementAndOptionAnswers = new ElementAndOptionAnswersModel(element, optionAnswers);
            cb({ elementAndOptionAnswers });
        }));
    }
    /**
     * @param {?} type
     * @param {?} elementId
     * @return {?}
     */
    onQuestionTypeSelect(type, elementId) {
        this.questionType = type;
        if (this.prevQuestionType === 'checkboxes' || this.prevQuestionType === 'radio' || this.prevQuestionType === 'select') {
            this._optionAnswersReducer.optionAnswersReducer({
                type: OptionAnswersActionTypes.REMOVE_OPTION_ANSWERS_MAP_ACTION,
                payload: { elementId: this.element.id },
            });
        }
        this._elementsReducer.elementsReducer({
            type: ElementsActionTypes.QUESTION_ADD_TYPE_ACTION,
            payload: {
                pageId: this.pageId,
                elementId,
                type,
            }
        });
        this._elementsReducer.elementsReducer({
            type: ElementsActionTypes.TOGGLE_IS_ACTIVE_ELEMENT_ACTION,
            payload: { pageId: this.pageId, elementId, isSaved: false }
        });
        this.prevQuestionType = type;
    }
    /**
     * @param {?} elementId
     * @return {?}
     */
    saveQuestion(elementId) {
        this._elementsReducer.elementsReducer({
            type: ElementsActionTypes.TOGGLE_IS_ACTIVE_ELEMENT_ACTION,
            payload: { pageId: this.pageId, elementId, isSaved: true }
        });
        this.isSavedEvent.emit({ key: this.element.id, isSaved: true });
    }
    /**
     * @param {?} elementId
     * @return {?}
     */
    editQuestion(elementId) {
        this._elementsReducer.elementsReducer({
            type: ElementsActionTypes.TOGGLE_IS_ACTIVE_ELEMENT_ACTION,
            payload: { pageId: this.pageId, elementId, isSaved: false }
        });
        this.isSavedEvent.emit({ key: this.element.id, isSaved: false });
    }
    /**
     * @param {?} elementId
     * @return {?}
     */
    cloneElement(elementId) {
        this._elementsReducer.elementsReducer({
            type: ElementsActionTypes.CLONE_ELEMENT_ACTION,
            payload: { pageId: this.pageId, elementId }
        });
    }
    /**
     * @param {?} elementId
     * @return {?}
     */
    removeElement(elementId) {
        this._elementsReducer.elementsReducer({
            type: ElementsActionTypes.REMOVE_ELEMENT_ACTION,
            payload: { pageId: this.pageId, elementId }
        });
    }
    /**
     * @param {?} elementId
     * @return {?}
     */
    moveElementDown(elementId) {
        this._elementsReducer.elementsReducer({
            type: ElementsActionTypes.MOVE_ELEMENT_DOWN_ACTION,
            payload: { pageId: this.pageId, elementId }
        });
    }
    /**
     * @param {?} elementId
     * @return {?}
     */
    moveElementUp(elementId) {
        this._elementsReducer.elementsReducer({
            type: ElementsActionTypes.MOVE_ELEMENT_UP_ACTION,
            payload: { pageId: this.pageId, elementId }
        });
    }
    /**
     * @param {?} index
     * @param {?} item
     * @return {?}
     */
    trackElement(index, item) {
        return item ? item.key : null;
    }
}
QuestionBuilderContainerComponent.decorators = [
    { type: Component, args: [{
                selector: 'ngs-question-builder-container',
                template: "<div>\n  <!-- Header -->\n  <div class=\"d-flex justify-content-end ml-3\">\n    <!-- Element Button Group -->\n    <div class=\"btn-group\" role=\"group\">\n      <!-- Remove Element -->\n      <button\n        *ngIf=\"!element?.isSaved\"\n        type=\"button\"\n        class=\"btn btn-outline-primary\"\n        tooltip=\"Remove Element\"\n        (click)=\"removeElement(element?.id)\">\n        <i class=\"fas fa-trash-alt\"></i>\n      </button>\n      <!-- #/Remove Element -->\n\n      <!-- Move Element Down -->\n      <button\n        *ngIf=\"!element?.isSaved\"\n        type=\"button\"\n        class=\"btn btn-outline-primary\"\n        tooltip=\"Move Down\"\n        (click)=\"moveElementDown(element?.id)\"\n        [disabled]=\"element?.orderNo === elementsSize\">\n        <i class=\"fas fa-chevron-down\"></i>\n      </button>\n      <!-- #/Move Element Down -->\n\n      <!-- Move Element Up -->\n      <button\n        *ngIf=\"!element?.isSaved\"\n        type=\"button\"\n        class=\"btn btn-outline-primary\"\n        tooltip=\"Move Up\"\n        (click)=\"moveElementUp(element?.id)\"\n        [disabled]=\"element?.orderNo === 1\">\n        <i class=\"fas fa-chevron-up\"></i>\n      </button>\n      <!-- Move Element Up -->\n\n      <!-- Clone Element -->\n      <button\n        *ngIf=\"element?.isSaved\"\n        type=\"button\"\n        class=\"btn btn-outline-primary\"\n        tooltip=\"Clone Element\"\n        (click)=\"cloneElement(element?.id)\"\n      >\n        <i class=\"fas fa-clone\"></i>\n      </button>\n      <!-- #/Clone Element -->\n\n      <!-- Edit Question -->\n      <button\n        [id]=\"'edit-question-button-' + element?.id\"\n        *ngIf=\"element?.isSaved && element.type === 'question'\"\n        type=\"button\"\n        class=\"btn btn-outline-primary\"\n        tooltip=\"Edit Element\"\n        (click)=\"editQuestion(element?.id)\">\n        <i class=\"fas fa-edit\"></i>\n      </button>\n      <!-- #/Edit Question -->\n\n      <!-- Import Element -->\n      <button\n        id=\"import-element\"\n        *ngIf=\"!!importElementButton && element.type === 'question'\"\n        type=\"button\"\n        class=\"btn btn-outline-primary\"\n        [tooltip]=\"importElementButton?.title ? importElementButton?.title : 'Import Element'\"\n        (click)=\"importElement(importElementButton.callback, element)\"\n      >\n        <i [class]=\"importElementButton?.icon ? importElementButton?.icon : 'fas fa-file-import'\"></i>\n      </button>\n      <!-- #/Import Element -->\n\n      <!-- Custom Element Buttons -->\n      <span *ngIf=\"!!elementButtons && elementButtons?.length > 0 && element.type === 'question'\">\n        <button\n          *ngFor=\"let button of elementButtons\"\n          [id]=\"'custom-element-button' + button?.title\"\n          type=\"button\"\n          class=\"btn btn-outline-primary bl-none\"\n          [tooltip]=\"button?.title\"\n          (click)=\"handleCustomElementButton(element, button?.callback)\"\n        >\n          <i [class]=\"button?.icon\"></i>\n        </button>\n        <!-- #/Custom Element Buttons -->\n      </span>\n    </div>\n    <!-- #/Element Button Group -->\n  </div>\n  <!-- #/Header -->\n\n  <!-- Question Builder -->\n  <div *ngIf=\"element.type === 'question'\" class=\"mt-4\">\n    <!-- Question Form Builder -->\n    <form name=\"questionForm\" #questionForm=\"ngForm\">\n\n      <!-- Question Value Input -->\n      <ngs-question-input\n        [elementId]=\"element?.id\"\n        [elementValue]=\"element?.question.text\"\n        [pageId]=\"pageId\"\n        [isElementSaved]=\"element?.isSaved\"\n      ></ngs-question-input>\n      <!-- #/Question Value Input -->\n\n      <!-- Question Type Selector -->\n      <div class=\"form-group\">\n        <label for=\"questionType\">Question Type</label>\n        <select\n          id=\"questionType\"\n          name=\"questionType\"\n          class=\"form-control\"\n          [(ngModel)]=\"element?.question.type\"\n          (ngModelChange)=\"onQuestionTypeSelect($event, element?.id)\"\n          [disabled]=\"element?.isSaved\"\n        >\n          <option selected></option>\n          <option value=\"shortText\">Short Text</option>\n          <option value=\"longText\">Long Text</option>\n          <option value=\"radio\">Radio</option>\n          <option value=\"checkboxes\">Checkboxes</option>\n          <option value=\"select\">Select</option>\n          <option value=\"date\">Date</option>\n          <option value=\"range\">Range</option>\n        </select>\n      </div>\n      <!-- #/Question Type Selector -->\n    </form>\n    <!-- #/Question Form Builder -->\n\n    <!-- Question Builder Element -->\n    <ngs-question-builder-component\n      [questionType]=\"element?.question.type\"\n      [element]=\"element\"\n      [surveyId]=\"surveyId\"\n      [isView]=\"false\"\n    ></ngs-question-builder-component>\n    <!-- #/Question Builder Element -->\n\n    <!-- Save Button -->\n    <button [id]=\"'save-question-button-' + element?.id\" *ngIf=\"!element?.isSaved\" type=\"button\" class=\"btn btn-outline-primary mt-4\" (click)=\"saveQuestion(element?.id)\" [disabled]=\"!questionType\">Save Question</button>\n    <!-- #/Save Button -->\n  </div>\n  <!-- #/Question Builder -->\n\n  <!-- Paragraph Builder -->\n  <div *ngIf=\"element.type === 'paragraph'\" class=\"mt-4\">\n    <ngs-paragraph\n      [element]=\"element\"\n    ></ngs-paragraph>\n  </div>\n  <!-- #/Paragraph Builder -->\n</div>\n\n",
                styles: ["#question-builder-container{padding:1% 2.5%}.bl-none{border-top-left-radius:0!important;border-left:0!important;border-bottom-left-radius:0!important}"]
            }] }
];
/** @nocollapse */
QuestionBuilderContainerComponent.ctorParameters = () => [
    { type: NgSurveyStore },
    { type: ElementsReducer },
    { type: OptionAnswersReducer }
];
QuestionBuilderContainerComponent.propDecorators = {
    surveyId: [{ type: Input }],
    pageId: [{ type: Input }],
    element: [{ type: Input }],
    elementsSize: [{ type: Input }],
    isSavedEvent: [{ type: Output }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class QuestionInputComponent {
    /**
     * @param {?} _elementsReducer
     */
    constructor(_elementsReducer) {
        this._elementsReducer = _elementsReducer;
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        setTimeout(() => {
            this.handleQuestionNameChange();
        }, 300);
    }
    /**
     * @return {?}
     */
    handleQuestionNameChange() {
        /** @type {?} */
        const $questionText = document.getElementById(`questionText-${this.elementId}`);
        fromEvent($questionText, 'input').pipe(map((event) => event.target.value), distinctUntilChanged(), debounceTime(1000), map(text => text)).subscribe(text => this._elementsReducer.elementsReducer({
            type: ElementsActionTypes.QUESTION_ADD_TEXT_ACTION,
            payload: {
                pageId: this.pageId,
                elementId: this.elementId,
                text,
            }
        }));
    }
}
QuestionInputComponent.decorators = [
    { type: Component, args: [{
                selector: 'ngs-question-input',
                template: "<!-- Question Value Input -->\n<div class=\"form-group\">\n  <label [for]=\"'questionText-' + elementId\">Question Text</label>\n  <input\n    [id]=\"'questionText-' + elementId\"\n    name=\"questionText\"\n    type=\"text\"\n    class=\"form-control\"\n    [ngModel]=\"elementValue\"\n    placeholder=\"Question Text\"\n    [disabled]=\"isElementSaved\"\n    required>\n</div>\n<!-- #/Question Value Input -->\n",
                styles: [""]
            }] }
];
/** @nocollapse */
QuestionInputComponent.ctorParameters = () => [
    { type: ElementsReducer }
];
QuestionInputComponent.propDecorators = {
    elementValue: [{ type: Input }],
    elementId: [{ type: Input }],
    pageId: [{ type: Input }],
    isElementSaved: [{ type: Input }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class QuestionViewerContainerComponent {
    constructor() { }
    /**
     * @return {?}
     */
    ngOnInit() {
    }
}
QuestionViewerContainerComponent.decorators = [
    { type: Component, args: [{
                selector: 'ngs-question-viewer-container',
                template: "<!-- Question Builder Element -->\n<div *ngIf=\"element?.type === 'question'\" class=\"mt-4\">\n  <ngs-question-builder-component\n    [questionType]=\"element?.question.type\"\n    [element]=\"element\"\n    [surveyId]=\"surveyId\"\n    [isView]=\"true\"\n  ></ngs-question-builder-component>\n</div>\n<!-- #/Question Builder Element -->\n\n<!-- Paragraph Builder Element-->\n<div *ngIf=\"element?.type === 'paragraph'\" class=\"mt-4\">\n  <ngs-paragraph-summary-viewer\n    [html]=\"element.paragraph.html\"\n  ></ngs-paragraph-summary-viewer>\n</div>\n<!-- #/Paragraph Builder Element-->\n",
                styles: [""]
            }] }
];
/** @nocollapse */
QuestionViewerContainerComponent.ctorParameters = () => [];
QuestionViewerContainerComponent.propDecorators = {
    element: [{ type: Input }],
    surveyId: [{ type: Input }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class SummaryContainerComponent {
    /**
     * @param {?} _ngSurveyStore
     * @param {?} _surveyReducer
     */
    constructor(_ngSurveyStore, _surveyReducer) {
        this._ngSurveyStore = _ngSurveyStore;
        this._surveyReducer = _surveyReducer;
        this.surveySub = this._ngSurveyStore.survey.subscribe(res => {
            this.survey = res;
        });
    }
    /**
     * @return {?}
     */
    ngOnInit() { }
    /**
     * @param {?} summary
     * @return {?}
     */
    handleEditorEvent(summary) {
        this._surveyReducer.surveyReducer({
            type: SurveyActionTypes.SURVEY_SUMMARY_CHANGED_ACTION,
            payload: { summary },
        });
    }
    /**
     * @return {?}
     */
    ngOnDestroy() {
        this.surveySub.unsubscribe();
    }
}
SummaryContainerComponent.decorators = [
    { type: Component, args: [{
                selector: 'ngs-summary-container',
                template: "<div class=\"card mt-5\">\n  <!-- Card Header -->\n  <div class=\"card-header d-flex w-100\">\n    <div class=\"mr-auto\">\n      <span>Summary Page</span>\n    </div>\n  </div>\n  <!-- #/Card Header -->\n\n  <!-- Card Body -->\n  <div class=\"card-body bg-white\">\n    <ngs-editor\n      [editorData]=\"survey.summary\"\n      (editorDataEvent)=\"handleEditorEvent($event)\"\n    ></ngs-editor>\n  </div>\n  <!-- #/Card Body -->\n\n  <!-- Card Footer -->\n  <div class=\"card-footer d-flex w-100\">\n    <div class=\"mr-auto\"></div>\n  </div>\n  <!-- #/Card Footer -->\n</div>\n",
                styles: [":host ::ng-deep .ck-editor__editable{min-height:250px}.card-body{border-left:1px solid rgba(0,0,0,.125)!important}"]
            }] }
];
/** @nocollapse */
SummaryContainerComponent.ctorParameters = () => [
    { type: NgSurveyStore },
    { type: SurveyReducer }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class SurveyTemplateFormComponent {
    /**
     * @param {?} _surveyReducer
     */
    constructor(_surveyReducer) {
        this._surveyReducer = _surveyReducer;
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        setTimeout(() => {
            if (!this.survey.isLoading) {
                this.handleSurveyNameChange();
                this.handleSurveyDescriptionChange();
            }
        }, 300);
    }
    /**
     * @return {?}
     */
    ngOnDestroy() {
        this.surveyNameSub$.unsubscribe();
        this.surveyNameSub$.unsubscribe();
    }
    /**
     * @return {?}
     */
    handleSurveyNameChange() {
        /** @type {?} */
        const $surveyName = document.getElementById('surveyName');
        this.surveyNameSub$ = fromEvent($surveyName, 'input').pipe(map((event) => event.target.value), distinctUntilChanged$1(), debounceTime$1(1000)).subscribe(name => {
            this._surveyReducer.surveyReducer({
                type: SurveyActionTypes.SURVEY_NAME_CHANGED_ACTION,
                payload: { name },
            });
        });
    }
    /**
     * @return {?}
     */
    handleSurveyDescriptionChange() {
        /** @type {?} */
        const $surveyDescription = document.getElementById('surveyDescription');
        this.surveyDescriptionSub$ = fromEvent($surveyDescription, 'input').pipe(map((event) => event.target.value), distinctUntilChanged$1(), debounceTime$1(1000)).subscribe(description => {
            this._surveyReducer.surveyReducer({
                type: SurveyActionTypes.SURVEY_DESCRIPTION_CHANGED_ACTION,
                payload: { description },
            });
        });
    }
}
SurveyTemplateFormComponent.decorators = [
    { type: Component, args: [{
                selector: 'ngs-survey-template-form',
                template: "<form>\n  <div class=\"form-group\">\n    <label for=\"surveyName\">Survey Name</label>\n    <input\n      id=\"surveyName\"\n      name=\"surveyName\"\n      type=\"text\"\n      class=\"form-control\"\n      placeholder=\"Name\"\n      [ngModel]=\"survey.name\"\n      required\n    >\n  </div>\n  <div class=\"form-group\">\n    <label for=\"surveyDescription\">Survey Description</label>\n    <textarea\n      id=\"surveyDescription\"\n      class=\"form-control\"\n      name=\"surveyDescription\"\n      rows=\"3\"\n      placeholder=\"Description\"\n      [ngModel]=\"survey.description\"\n    ></textarea>\n  </div>\n</form>\n",
                styles: [""]
            }] }
];
/** @nocollapse */
SurveyTemplateFormComponent.ctorParameters = () => [
    { type: SurveyReducer }
];
SurveyTemplateFormComponent.propDecorators = {
    survey: [{ type: Input }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class SurveyParagraphViewerComponent {
    constructor() { }
    /**
     * @return {?}
     */
    ngOnInit() {
    }
}
SurveyParagraphViewerComponent.decorators = [
    { type: Component, args: [{
                selector: 'ngs-paragraph-summary-viewer',
                template: "<div [innerHTML]=\"html\"></div>\n",
                styles: [""]
            }] }
];
/** @nocollapse */
SurveyParagraphViewerComponent.ctorParameters = () => [];
SurveyParagraphViewerComponent.propDecorators = {
    html: [{ type: Input }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class ParagraphComponent {
    /**
     * @param {?} _elementsReducer
     */
    constructor(_elementsReducer) {
        this._elementsReducer = _elementsReducer;
    }
    /**
     * @return {?}
     */
    ngOnInit() {
    }
    /**
     * @param {?} html
     * @return {?}
     */
    handleEditorEvent(html) {
        this._elementsReducer.elementsReducer({
            type: ElementsActionTypes.PARAGRAPH_UPDATE_HTML_ACTION,
            payload: { pageId: this.element.pageId, elementId: this.element.id, html }
        });
    }
}
ParagraphComponent.decorators = [
    { type: Component, args: [{
                selector: 'ngs-paragraph',
                template: "<ngs-editor\n  [editorData]=\"element.paragraph.html\"\n  (editorDataEvent)=\"handleEditorEvent($event)\"\n></ngs-editor>\n",
                styles: [":host ::ng-deep .ck-editor__editable{min-height:150px}"]
            }] }
];
/** @nocollapse */
ParagraphComponent.ctorParameters = () => [
    { type: ElementsReducer }
];
ParagraphComponent.propDecorators = {
    element: [{ type: Input }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class EditorComponent {
    constructor() {
        this.editorDataEvent = new EventEmitter();
        this.Editor = ClassicEditor;
        this.surveyDataSubject = new Subject();
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        this.surveyDataSubject.pipe(map$1((res) => res), distinctUntilChanged(), debounceTime(1000)).subscribe(editorData => {
            this.editorDataEvent.emit(editorData);
        });
    }
    /**
     * @param {?} __0
     * @return {?}
     */
    onEditorChange({ editor }) {
        /** @type {?} */
        const data = editor.getData();
        this.surveyDataSubject.next(data);
    }
}
EditorComponent.decorators = [
    { type: Component, args: [{
                selector: 'ngs-editor',
                template: "<ckeditor\n  id=\"summaryInput\"\n  [(ngModel)]=\"editorData\"\n  [editor]=\"Editor\"\n  (change)=\"onEditorChange($event)\"\n>\n</ckeditor>\n",
                styles: [""]
            }] }
];
/** @nocollapse */
EditorComponent.ctorParameters = () => [];
EditorComponent.propDecorators = {
    editorData: [{ type: Input }],
    editorDataEvent: [{ type: Output }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class BuilderModule {
}
BuilderModule.decorators = [
    { type: NgModule, args: [{
                imports: [
                    CommonModule,
                    FormsModule,
                    BrowserAnimationsModule,
                    DragDropModule,
                    SharedCommonModule,
                    ReactiveFormsModule,
                    CKEditorModule,
                    TooltipModule.forRoot(),
                    BsDropdownModule.forRoot(),
                ],
                providers: [
                    QuestionBuilderService
                ],
                declarations: [
                    ShortTextComponent,
                    LongTextComponent,
                    DateComponent,
                    RangeComponent,
                    QuestionBuilderDirective,
                    QuestionBuilderComponent,
                    OptionTemplateComponent,
                    RadioCheckboxSelectComponent,
                    SelectComponent,
                    CheckboxComponent,
                    RadioComponent,
                    PageBuilderContainerComponent,
                    PageViewerContainerComponent,
                    QuestionBuilderContainerComponent,
                    QuestionInputComponent,
                    QuestionViewerContainerComponent,
                    SummaryContainerComponent,
                    SurveyTemplateFormComponent,
                    SurveyParagraphViewerComponent,
                    ParagraphComponent,
                    EditorComponent,
                ],
                entryComponents: [
                    ShortTextComponent,
                    LongTextComponent,
                    DateComponent,
                    RangeComponent,
                    RadioCheckboxSelectComponent,
                    SelectComponent,
                    CheckboxComponent,
                    RadioComponent,
                ],
                exports: [
                    ShortTextComponent,
                    LongTextComponent,
                    QuestionBuilderDirective,
                    QuestionBuilderComponent,
                    DateComponent,
                    RangeComponent,
                    OptionTemplateComponent,
                    RadioCheckboxSelectComponent,
                    SelectComponent,
                    CheckboxComponent,
                    RadioComponent,
                    PageBuilderContainerComponent,
                    PageViewerContainerComponent,
                    QuestionBuilderContainerComponent,
                    QuestionInputComponent,
                    QuestionViewerContainerComponent,
                    SummaryContainerComponent,
                    SurveyTemplateFormComponent,
                    SurveyParagraphViewerComponent,
                    ParagraphComponent,
                    EditorComponent,
                ]
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgBuilderViewerModule {
}
NgBuilderViewerModule.decorators = [
    { type: NgModule, args: [{
                imports: [
                    CommonModule,
                    FormsModule,
                    TooltipModule$1.forRoot(),
                    SharedCommonModule,
                    BuilderModule,
                ],
                declarations: [NgBuilderViewerComponent],
                exports: [NgBuilderViewerComponent]
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class PageLinkedListNode {
    /**
     * @param {?=} page
     * @param {?=} next
     * @param {?=} previous
     */
    constructor(page, next, previous) {
        this.page = page;
        this.next = next;
        this.previous = previous;
        this.page = page;
        this.next = next;
        this.previous = previous;
    }
}
class PageLinkedList {
    constructor() {
        this.head = null;
        this.tail = null;
    }
    /**
     * @param {?} page
     * @return {?}
     */
    prepend(page) {
        // Make new node to be a head.
        /** @type {?} */
        const newNode = new PageLinkedListNode(page, this.head);
        // If there is head, then it won't be head anymore.
        // Therefore, make its previous reference to be new node (new head).
        // Then mark the new node as head.
        if (this.head) {
            this.head.previous = newNode;
        }
        this.head = newNode;
        // If there is no tail yet let's make new node a tail.
        if (!this.tail) {
            this.tail = newNode;
        }
        return this;
    }
    /**
     * @param {?} page
     * @return {?}
     */
    append(page) {
        /** @type {?} */
        const newNode = new PageLinkedListNode(page);
        // If there is no head yet let's make new node a head.
        if (!this.head) {
            this.head = newNode;
            this.tail = newNode;
            return this;
        }
        // Attach new node to the end of linked list.
        this.tail.next = newNode;
        // Attach current tail to the new node's previous reference.
        newNode.previous = this.tail;
        // Set new node to be the tail of linked list.
        this.tail = newNode;
        return this;
    }
    /**
     * @param {?} page
     * @return {?}
     */
    delete(page) {
        if (!this.head) {
            return null;
        }
        /** @type {?} */
        let deletedNode = null;
        /** @type {?} */
        let currentNode = this.head;
        while (currentNode) {
            if (currentNode.page.id === page.id) {
                deletedNode = currentNode;
                if (deletedNode === this.head) {
                    // If HEAD is going to be deleted...
                    // Set head to second node, which will become new head.
                    this.head = deletedNode.next;
                    // Set new head's previous to null.
                    if (this.head) {
                        this.head.previous = null;
                    }
                    // If all the nodes in list has same value that is passed as argument
                    // then all nodes will get deleted, therefore tail needs to be updated.
                    if (deletedNode === this.tail) {
                        this.tail = null;
                    }
                }
                else if (deletedNode === this.tail) {
                    // If TAIL is going to be deleted...
                    // Set tail to second last node, which will become new tail.
                    this.tail = deletedNode.previous;
                    this.tail.next = null;
                }
                else {
                    // If MIDDLE node is going to be deleted...
                    /** @type {?} */
                    const previousNode = deletedNode.previous;
                    /** @type {?} */
                    const nextNode = deletedNode.next;
                    previousNode.next = nextNode;
                    nextNode.previous = previousNode;
                }
            }
            currentNode = currentNode.next;
        }
        return deletedNode;
    }
    /**
     * @param {?} page
     * @param {?=} callback
     * @return {?}
     */
    find(page, callback) {
        if (!this.head) {
            return null;
        }
        /** @type {?} */
        let currentNode = this.head;
        while (currentNode) {
            // If callback is specified then try to find node by callback.
            if (callback && callback(currentNode.page)) {
                return currentNode;
            }
            // If value is specified then try to compare by value's ID
            if (page !== undefined && currentNode.page.id === page.id) {
                return currentNode;
            }
            currentNode = currentNode.next;
        }
        return null;
    }
    /**
     * @param {?} pageId
     * @return {?}
     */
    findByPageId(pageId) {
        if (!this.head) {
            return null;
        }
        /** @type {?} */
        let currentNode = this.head;
        while (currentNode) {
            if (pageId !== undefined && currentNode.page.id === pageId) {
                return currentNode;
            }
            currentNode = currentNode.next;
        }
        return null;
    }
    /**
     * @return {?}
     */
    deleteTail() {
        /** @type {?} */
        let deletedTail;
        if (!this.tail) {
            // No tail to delete.
            return null;
        }
        if (this.head === this.tail) {
            // There is only one node in linked list.
            deletedTail = this.tail;
            this.head = null;
            this.tail = null;
            return deletedTail;
        }
        // If there are many nodes in linked list...
        deletedTail = this.tail;
        this.tail = this.tail.previous;
        this.tail.next = null;
        return deletedTail;
    }
    /**
     * @return {?}
     */
    deleteHead() {
        if (!this.head) {
            return null;
        }
        /** @type {?} */
        const deletedHead = this.head;
        if (this.head.next) {
            this.head = this.head.next;
            this.head.previous = null;
        }
        else {
            this.head = null;
            this.tail = null;
        }
        return deletedHead;
    }
    /**
     * @return {?}
     */
    toArray() {
        /** @type {?} */
        const nodes = [];
        /** @type {?} */
        let currentNode = this.head;
        while (currentNode) {
            nodes.push(currentNode);
            currentNode = currentNode.next;
        }
        return nodes;
    }
    /**
     * @param {?} values
     * @return {?}
     */
    fromArray(values) {
        values.forEach(value => this.append(value.page));
        return this;
    }
    /**
     * @return {?}
     */
    reverse() {
        /** @type {?} */
        let currNode = this.head;
        /** @type {?} */
        let prevNode = null;
        /** @type {?} */
        let nextNode = null;
        while (currNode) {
            // Store next node.
            nextNode = currNode.next;
            prevNode = currNode.previous;
            // Change next node of the current node so it would link to previous node.
            currNode.next = prevNode;
            currNode.previous = nextNode;
            // Move prevNode and currNode nodes one step forward.
            prevNode = currNode;
            currNode = nextNode;
        }
        // Reset head and tail.
        this.tail = this.head;
        this.head = prevNode;
        return this;
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgSurveyViewerNavigationService {
    /**
     * @param {?} _ngSurveyStore
     */
    constructor(_ngSurveyStore) {
        this._ngSurveyStore = _ngSurveyStore;
        this.pageLinkedList = new BehaviorSubject(new PageLinkedList());
        this.currentPageNode = new BehaviorSubject(new PageLinkedListNode());
        this.prevPageLinkedList = new BehaviorSubject(new PageLinkedList());
        this.page = new BehaviorSubject(null);
        this.initPageStack();
    }
    /**
     * @param {?} pageId
     * @return {?}
     */
    setGoToPage(pageId) {
        /** @type {?} */
        const currentPage = this.currentPageNode.value;
        /** @type {?} */
        const nextPage = this.findByPageId(pageId);
        this.currentPageNode.next(nextPage);
        this.prevPageLinkedList.value.append(currentPage.page);
        this.prevPageLinkedList.next(this.prevPageLinkedList.value);
        return nextPage.page;
    }
    /**
     * @return {?}
     */
    setNextPage() {
        /** @type {?} */
        const currentPage = this.currentPageNode.value;
        /** @type {?} */
        const nextPage = currentPage.next;
        this.prevPageLinkedList.value.append(currentPage.page);
        this.prevPageLinkedList.next(this.prevPageLinkedList.value);
        if (!!nextPage) {
            this.currentPageNode.next(nextPage);
            return nextPage.page;
        }
        else {
            return { id: 'summary', surveyId: '' };
        }
    }
    /**
     * @return {?}
     */
    setPrevPage() {
        // Get last visited page
        /** @type {?} */
        const prevPage = this.prevPageLinkedList.value.tail;
        // Find last visited page in page linked list and assign it as current page
        /** @type {?} */
        const currentPageNode = this.pageLinkedList.value.find(prevPage.page);
        this.currentPageNode.next(currentPageNode);
        // Update prev page linked list by deleting new current page node
        this.prevPageLinkedList.value.delete(prevPage.page);
        this.prevPageLinkedList.next(this.prevPageLinkedList.value);
        return currentPageNode.page;
    }
    /**
     * @param {?} pageId
     * @return {?}
     */
    findByPageId(pageId) {
        /** @type {?} */
        const pageNode = this.pageLinkedList.value.findByPageId(pageId);
        this.currentPageNode.next(pageNode);
        return pageNode;
    }
    /**
     * @private
     * @return {?}
     */
    initPageStack() {
        this._ngSurveyStore.pages.subscribe(res => {
            this.pages = res;
            /** @type {?} */
            const pageLinkedList = new PageLinkedList();
            this.pages.forEach((el) => {
                pageLinkedList.append(el);
            });
            this.pageLinkedList.next(pageLinkedList);
            // Assign head as current page
            this.currentPageNode.next(this.pageLinkedList.value.head);
        });
        // Get Elements
        this._ngSurveyStore.elements.subscribe(res => {
            this.elements = res;
        });
    }
    /**
     * @return {?}
     */
    checkSurveyEmpty() {
        if (this.elements.size === 1) {
            if (this.page.value) {
                /** @type {?} */
                const elements = this.elements.get(this.page.value.id);
                if (elements.size === 1) {
                    /** @type {?} */
                    const element = elements.values().next().value;
                    if (element.question.type === '' || element.question.type === null) {
                        return true;
                    }
                }
            }
            else {
                return true;
            }
        }
        return false;
    }
}
NgSurveyViewerNavigationService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
NgSurveyViewerNavigationService.ctorParameters = () => [
    { type: NgSurveyStore }
];
/** @nocollapse */ NgSurveyViewerNavigationService.ngInjectableDef = defineInjectable({ factory: function NgSurveyViewerNavigationService_Factory() { return new NgSurveyViewerNavigationService(inject(NgSurveyStore)); }, token: NgSurveyViewerNavigationService, providedIn: "root" });

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgSurveyViewerComponent {
    /**
     * @param {?} _ngSurveyStore
     * @param {?} router
     * @param {?} surveyViewerNavigation$
     */
    constructor(_ngSurveyStore, router, surveyViewerNavigation$) {
        this._ngSurveyStore = _ngSurveyStore;
        this.router = router;
        this.surveyViewerNavigation$ = surveyViewerNavigation$;
        this.surveySub = this._ngSurveyStore.survey.subscribe(res => {
            this.survey = res;
            this.surveyId = res.id;
        });
        this._ngSurveyStore.pages.subscribe(res => {
            this.pages = res;
            if (res) {
                this.pageSize = res.size;
            }
        });
        this.elementsSub = this._ngSurveyStore.elements.subscribe(res => {
            this.elements = res;
        });
        this.optionAnswersSub = this._ngSurveyStore.optionAnswers.subscribe(res => {
            this.optionAnswers = res;
        });
        this.initNavigation();
        router.events.subscribe(event => {
            if (event instanceof NavigationStart) {
                this.isPrevPageEmpty = false;
                this.isNextPageEmpty = false;
                this.isLoading = true;
            }
            if (event instanceof NavigationEnd) {
                setTimeout(() => {
                    this.initNavigation();
                    this.isLoading = false;
                }, 10);
            }
            if (event instanceof NavigationError) {
                setTimeout(() => {
                    this.isLoading = false;
                }, 10);
                throw event.error;
            }
        });
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        this.isSurveyEmpty = this.checkSurveyEmpty();
    }
    /**
     * @return {?}
     */
    ngOnDestroy() {
        this.surveySub.unsubscribe();
    }
    /**
     * @return {?}
     */
    initNavigation() {
        /** @type {?} */
        const currentPageNode = this.surveyViewerNavigation$.currentPageNode.value;
        /** @type {?} */
        const pageUrlId = this.getCurrentPageUrlId();
        this.showSummary = false;
        this.page = currentPageNode.page;
        this.isPrevPageEmpty = isNil$$1(currentPageNode.previous);
        this.isNextPageEmpty = isNil$$1(currentPageNode.next) && isNil$$1(this.survey.summary);
        if (pageUrlId === 'summary') {
            this.showSummary = true;
            this.isNextPageEmpty = true;
        }
    }
    /**
     * @return {?}
     */
    nextPage() {
        /** @type {?} */
        const elementPageFlowModifier = this.getElementPageFlowModifier();
        if (!!elementPageFlowModifier) {
            this.pageNext = this.surveyViewerNavigation$.setGoToPage(elementPageFlowModifier.pageId);
        }
        else if (this.page.pageFlow.label === 'pageFlow.goToPage') {
            this.pageNext = this.surveyViewerNavigation$.setGoToPage(this.page.pageFlow.pageId);
        }
        else {
            this.pageNext = this.surveyViewerNavigation$.setNextPage();
        }
        this.router.navigate([`/viewer/${this.pageNext.id}`]);
    }
    /**
     * @return {?}
     */
    prevPage() {
        this.pagePrev = this.surveyViewerNavigation$.setPrevPage();
        this.router.navigate([`/viewer/${this.pagePrev.id}`]);
    }
    /**
     * @return {?}
     */
    getElementPageFlowModifier() {
        /** @type {?} */
        const pageElements = this.elements.get(this.page.id);
        /** @type {?} */
        let isElementPageFlowModifier = false;
        /** @type {?} */
        let elementPageFlowModifier;
        pageElements.forEach((element, key) => {
            if (element.question.pageFlowModifier) {
                isElementPageFlowModifier = true;
                elementPageFlowModifier = element;
            }
        });
        if (isElementPageFlowModifier && !!elementPageFlowModifier) {
            /** @type {?} */
            const elementOptionAnswers = this.optionAnswers.get(elementPageFlowModifier.id);
            /** @type {?} */
            let isPageFlowModifier = false;
            /** @type {?} */
            let optionAnswersPageFlowModifier;
            elementOptionAnswers.forEach((optionAnswer, key) => {
                if (elementPageFlowModifier.question.answer === optionAnswer.value && optionAnswer.pageFlow.label === 'pageFlow.goToPage') {
                    isPageFlowModifier = true;
                    optionAnswersPageFlowModifier = optionAnswer.pageFlow;
                }
            });
            if (isPageFlowModifier && !!optionAnswersPageFlowModifier) {
                return optionAnswersPageFlowModifier;
            }
        }
        return null;
    }
    /**
     * @return {?}
     */
    getCurrentPageUrlId() {
        /** @type {?} */
        const pageUrlArray = this.router.url.split('/');
        return pageUrlArray.pop();
    }
    /**
     * @return {?}
     */
    checkSurveyEmpty() {
        if (this.elements.size === 1) {
            if (this.page) {
                /** @type {?} */
                const elements = this.elements.get(this.page.id);
                if (elements.size === 1) {
                    /** @type {?} */
                    const element = elements.values().next().value;
                    if (element.question.type === '' || element.question.type === null) {
                        return true;
                    }
                }
            }
            else {
                return true;
            }
        }
        return false;
    }
}
NgSurveyViewerComponent.decorators = [
    { type: Component, args: [{
                selector: 'ngs-survey-viewer',
                template: "<div *ngIf=\"isLoading\" class=\"h-100\">\n  <ngs-loader [isInherit]=\"true\"></ngs-loader>\n</div>\n\n<div *ngIf=\"!isLoading && !isSurveyEmpty\" class=\"card\">\n  <!-- Card Header -->\n  <div class=\"card-header d-flex w-100\">\n    <div class=\"mr-auto d-flex flex-row\">\n      <span *ngIf=\"!showSummary\">Page {{page?.orderNo}} of {{pageSize}}</span>\n      <span *ngIf=\"showSummary\">Survey Summary</span>\n    </div>\n  </div>\n  <!-- #/Card Header -->\n\n  <!-- Card Body -->\n  <div class=\"card-body\">\n    <div *ngIf=\"!showSummary\">\n      <ngs-page-viewer-container\n        [page]=\"page\"\n      ></ngs-page-viewer-container>\n    </div>\n    <div *ngIf=\"showSummary\">\n      <ngs-paragraph-summary-viewer\n        [html]=\"survey.summary\"\n      ></ngs-paragraph-summary-viewer>\n    </div>\n  </div>\n  <!-- #/Card Body -->\n\n  <!-- Card Footer -->\n  <div class=\"card-footer d-flex w-100\">\n    <div class=\"mr-auto\">\n      <button type=\"button\" class=\"btn btn-primary btn-lg\" [disabled]=\"isPrevPageEmpty\" (click)=\"prevPage()\">Back</button>\n    </div>\n    <div class=\"ml-auto\">\n      <!--[disabled]=\"!pageNext\"-->\n      <button type=\"button\" class=\"btn btn-primary btn-lg\" [disabled]=\"isNextPageEmpty\" (click)=\"nextPage()\">Next</button>\n    </div>\n  </div>\n  <!-- #/Card Footer -->\n</div>\n\n<div *ngIf=\"isSurveyEmpty\">\n  <h1>No Survey Data</h1>\n</div>\n",
                styles: [""]
            }] }
];
/** @nocollapse */
NgSurveyViewerComponent.ctorParameters = () => [
    { type: NgSurveyStore },
    { type: Router },
    { type: NgSurveyViewerNavigationService }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgSurveyViewerModule {
}
NgSurveyViewerModule.decorators = [
    { type: NgModule, args: [{
                imports: [
                    CommonModule,
                    RouterModule,
                    BrowserAnimationsModule,
                    SharedCommonModule,
                    BuilderModule
                ],
                declarations: [NgSurveyViewerComponent],
                exports: [NgSurveyViewerComponent]
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgModelViewerComponent {
    /**
     * @param {?} _ngSurveyStore
     */
    constructor(_ngSurveyStore) {
        this._ngSurveyStore = _ngSurveyStore;
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        this.surveyModel$ = this._ngSurveyStore.ngSurveyState;
    }
}
NgModelViewerComponent.decorators = [
    { type: Component, args: [{
                selector: 'ngs-model-viewer',
                template: "<pre>{{surveyModel$ | async | json}}</pre>\n",
                styles: [""]
            }] }
];
/** @nocollapse */
NgModelViewerComponent.ctorParameters = () => [
    { type: NgSurveyStore }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgModelViewerModule {
}
NgModelViewerModule.decorators = [
    { type: NgModule, args: [{
                imports: [
                    CommonModule
                ],
                declarations: [NgModelViewerComponent],
                exports: [NgModelViewerComponent]
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgSurveysModule {
}
NgSurveysModule.decorators = [
    { type: NgModule, args: [{
                imports: [
                    NgBuilderViewerModule,
                    NgSurveyViewerModule,
                    NgSurveyViewerModule,
                    NgModelViewerModule,
                ],
                declarations: [],
                providers: [NgSurveyStore, SurveyReducer, PagesReducer, ElementsReducer, OptionAnswersReducer, BuilderOptionsReducer],
                exports: [
                    NgBuilderViewerModule,
                    NgSurveyViewerModule,
                    NgModelViewerModule,
                ]
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { NgBuilderViewerComponent, NgBuilderViewerModule, NgSurveyViewerComponent, NgSurveyViewerModule, NgModelViewerComponent, NgModelViewerModule, Page, Elements, OptionAnswers, PageFlow, Paragraph, Question, BuilderOptionsModel, NgSurveysService, NgSurveysModule, BuilderModule as ɵi, QuestionBuilderComponent as ɵp, QuestionBuilderDirective as ɵo, QuestionBuilderService as ɵj, CheckboxComponent as ɵt, DateComponent as ɵm, EditorComponent as ɵbf, LongTextComponent as ɵl, OptionTemplateComponent as ɵq, ParagraphComponent as ɵbe, RadioCheckboxSelectComponent as ɵr, RadioComponent as ɵu, RangeComponent as ɵn, SelectComponent as ɵs, ShortTextComponent as ɵk, PageBuilderContainerComponent as ɵv, PageViewerContainerComponent as ɵw, QuestionBuilderContainerComponent as ɵx, QuestionInputComponent as ɵy, QuestionViewerContainerComponent as ɵz, SummaryContainerComponent as ɵba, SurveyParagraphViewerComponent as ɵbd, SurveyTemplateFormComponent as ɵbc, LoaderComponent as ɵh, PageSelectComponent as ɵd, MapValuesPipe as ɵc, SharedCommonModule as ɵb, BuilderOptionsReducer as ɵbg, ElementsReducer as ɵf, NgSurveyStore as ɵa, OptionAnswersReducer as ɵg, PagesReducer as ɵe, SurveyReducer as ɵbb, NgSurveyViewerNavigationService as ɵbh };

//# sourceMappingURL=ng-surveys.js.map