import { OnChanges, OnDestroy, OnInit, SimpleChanges } from '@angular/core';
import { Subscription } from 'rxjs';
import { CdkDragDrop } from '@angular/cdk/drag-drop';
import { IPage, IPageMap } from '../../../models/page.model';
import { IElementsMap } from '../../../models/elements.model';
import { NgSurveyStore } from '../../../store/ng-survey.store';
import { PagesReducer } from '../../../store/pages/pages.reducer';
import { ElementsReducer } from '../../../store/elements/elements.reducer';
export declare class PageBuilderContainerComponent implements OnInit, OnDestroy, OnChanges {
    private _ngSurveyStore;
    private _pagesReducer;
    private _elementsReducer;
    surveyId: string;
    page: IPage;
    pages: IPageMap;
    pageSizeSub: Subscription;
    pageSize: number;
    elementsSub: Subscription;
    elements: IElementsMap;
    elementsSize: number;
    isEditPage: boolean;
    isSavedMap: Map<string, boolean>;
    constructor(_ngSurveyStore: NgSurveyStore, _pagesReducer: PagesReducer, _elementsReducer: ElementsReducer);
    ngOnInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    ngOnDestroy(): void;
    removePage(pageId: string): void;
    insertPage(previousPageId: string): void;
    movePageDown(pageId: string): void;
    movePageUp(pageId: string): void;
    addElement(pageId: string): void;
    addParagraph(pageId: string): void;
    onEditPageClick(pageId: string): void;
    editPageName(pageId: string): void;
    editPageDescription(pageId: string): void;
    drop(event: CdkDragDrop<string[]>, pageId: string): void;
    handleIsSavedEvent({ key, isSaved }: {
        key: any;
        isSaved: any;
    }): void;
    private setSavedMap;
    trackElement(index: number, item: any): any;
}
