import { EventEmitter, OnInit } from '@angular/core';
import { IElements } from '../../../models/elements.model';
import { Subscription } from 'rxjs';
import { IBuilderOptions } from '../../../models/index';
import { IBuilderElementButtonsOptionsBuilder, IBuilderImportElementOptionsBuilder } from '../../../models/builder-options.model';
import { ElementsReducer } from '../../../store/elements/elements.reducer';
import { NgSurveyStore } from '../../../store/ng-survey.store';
import { OptionAnswersReducer } from '../../../store/option-answers/option-answers.reducer';
export declare class QuestionBuilderContainerComponent implements OnInit {
    private _ngSurveyStore;
    private _elementsReducer;
    private _optionAnswersReducer;
    surveyId: string;
    pageId: string;
    element: IElements;
    elementsSize: number;
    isSavedEvent: EventEmitter<any>;
    questionType: string;
    prevQuestionType: string;
    builderOptionsSub: Subscription;
    builderOptions: IBuilderOptions;
    elementButtons: IBuilderElementButtonsOptionsBuilder[];
    importElementButton: IBuilderImportElementOptionsBuilder;
    constructor(_ngSurveyStore: NgSurveyStore, _elementsReducer: ElementsReducer, _optionAnswersReducer: OptionAnswersReducer);
    ngOnInit(): void;
    importElement(cb: any, currentElement: any): void;
    handleCustomElementButton(element: IElements, cb: any): void;
    onQuestionTypeSelect(type: string, elementId: string): void;
    saveQuestion(elementId: string): void;
    editQuestion(elementId: string): void;
    cloneElement(elementId: string): void;
    removeElement(elementId: string): void;
    moveElementDown(elementId: string): void;
    moveElementUp(elementId: string): void;
    trackElement(index: number, item: any): any;
}
