import { OnDestroy, OnInit } from '@angular/core';
import { Router } from '@angular/router';
import { Subscription } from 'rxjs';
import { IPage, IPageMap } from '../../models/page.model';
import { IElementsMaps, INgSurvey, IOptionAnswersMaps, IPageFlow } from '../../models';
import { NgSurveyStore } from '../../store/ng-survey.store';
import { NgSurveyViewerNavigationService } from './ng-survey-viewer-navigation.service';
export declare class NgSurveyViewerComponent implements OnInit, OnDestroy {
    private _ngSurveyStore;
    private router;
    private surveyViewerNavigation$;
    survey: INgSurvey;
    surveyId: string;
    surveySub: Subscription;
    pageSize: number;
    pages: IPageMap;
    page: IPage;
    pageNext: IPage;
    pagePrev: IPage;
    elementsSub: Subscription;
    elements: IElementsMaps;
    optionAnswersSub: Subscription;
    optionAnswers: IOptionAnswersMaps;
    isPrevPageEmpty: boolean;
    isNextPageEmpty: boolean;
    showSummary: boolean;
    isLoading: boolean;
    isSurveyEmpty: boolean;
    constructor(_ngSurveyStore: NgSurveyStore, router: Router, surveyViewerNavigation$: NgSurveyViewerNavigationService);
    ngOnInit(): void;
    ngOnDestroy(): void;
    initNavigation(): void;
    nextPage(): void;
    prevPage(): void;
    getElementPageFlowModifier(): IPageFlow;
    getCurrentPageUrlId(): string;
    checkSurveyEmpty(): boolean;
}
