import { IPage } from '../../models';
export interface IPageLinkedListNode {
    page?: IPage;
    next?: IPageLinkedListNode;
    previous?: IPageLinkedListNode;
}
export declare class PageLinkedListNode implements IPageLinkedListNode {
    page?: IPage;
    next?: IPageLinkedListNode;
    previous?: IPageLinkedListNode;
    constructor(page?: IPage, next?: IPageLinkedListNode, previous?: IPageLinkedListNode);
}
export declare type Prepend = (page: IPage) => IPageLinkedList;
export declare type Append = (page: IPage) => IPageLinkedList;
export declare type Delete = (page: IPage) => IPageLinkedList;
export declare type FindByPageId = (pageId: string) => IPageLinkedListNode;
export declare type Find = (page: IPage, callback?: Function) => IPageLinkedListNode;
export declare type DeleteHead = () => IPageLinkedListNode;
export declare type DeleteTail = () => IPageLinkedListNode;
export declare type ToArray = () => PageLinkedListNode[];
export declare type FromArray = (values: PageLinkedListNode[]) => IPageLinkedList;
export declare type Reverse = () => IPageLinkedList;
export interface IPageLinkedList {
    head: IPageLinkedListNode | null;
    tail: IPageLinkedListNode | null;
    prepend: Prepend;
    append: Append;
    delete: Delete;
    findByPageId: FindByPageId;
    find: Find;
    deleteHead: DeleteHead;
    deleteTail: DeleteTail;
    toArray: ToArray;
    fromArray: FromArray;
    reverse: Reverse;
}
export declare class PageLinkedList implements IPageLinkedList {
    head: IPageLinkedListNode | null;
    tail: IPageLinkedListNode | null;
    constructor();
    prepend(page: IPage): IPageLinkedList;
    append(page: IPage): IPageLinkedList;
    delete(page: IPage): IPageLinkedList;
    find(page: IPage, callback?: Function): IPageLinkedListNode;
    findByPageId(pageId: string): IPageLinkedListNode;
    deleteTail(): IPageLinkedListNode;
    deleteHead(): IPageLinkedListNode;
    toArray(): PageLinkedListNode[];
    fromArray(values: PageLinkedListNode[]): IPageLinkedList;
    reverse(): IPageLinkedList;
}
