import { TooltipModule as TooltipModule$1 } from 'ngx-bootstrap';
import { moveItemInArray, DragDropModule } from '@angular/cdk/drag-drop';
import { TooltipModule } from 'ngx-bootstrap/tooltip';
import { BsDropdownModule } from 'ngx-bootstrap/dropdown';
import { CKEditorModule } from '@ckeditor/ckeditor5-angular';
import { FormsModule, FormBuilder, FormControl, FormArray, ReactiveFormsModule } from '@angular/forms';
import { __assign, __spread, __values } from 'tslib';
import { map, debounceTime as debounceTime$1, distinctUntilChanged as distinctUntilChanged$1 } from 'rxjs/operators';
import { debounceTime, distinctUntilChanged, map as map$1 } from 'rxjs/internal/operators';
import * as ClassicEditor from '@ckeditor/ckeditor5-build-classic';
import { BehaviorSubject, fromEvent, Subject } from 'rxjs';
import { NavigationEnd, NavigationError, NavigationStart, Router, RouterModule } from '@angular/router';
import { BrowserAnimationsModule } from '@angular/platform-browser/animations';
import { CommonModule } from '@angular/common';
import { Injectable, NgModule, Component, ComponentFactoryResolver, Input, ViewChild, Directive, ViewContainerRef, Pipe, Output, EventEmitter, defineInjectable, inject } from '@angular/core';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgSurvey = /** @class */ (function () {
    function NgSurvey(id, name, description, summary, isLoading) {
        this.id = id;
        this.name = name;
        this.description = description;
        this.summary = summary;
        this.isLoading = isLoading;
        this.id = id ? id : UUID$$1();
        this.name = name ? name : '';
        this.description = description ? description : '';
        this.summary = summary ? summary : '';
        this.isLoading = isLoading ? isLoading : false;
    }
    return NgSurvey;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var PageFlow = /** @class */ (function () {
    function PageFlow(nextPage, label, pageId) {
        this.nextPage = nextPage;
        this.label = label;
        this.pageId = pageId;
        this.nextPage = nextPage ? nextPage : true;
        this.label = label ? label : 'pageFlow.goToNextPage';
        this.pageId = pageId ? pageId : '';
    }
    return PageFlow;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var Page = /** @class */ (function () {
    function Page(id, surveyId, orderNo, pageFlow, name, description) {
        this.id = id;
        this.surveyId = surveyId;
        this.orderNo = orderNo;
        this.pageFlow = pageFlow;
        this.name = name;
        this.description = description;
        this.orderNo = orderNo ? orderNo : 1;
        this.pageFlow = pageFlow ? pageFlow : new PageFlow();
        this.name = name ? name : '';
        this.description = description ? description : '';
    }
    return Page;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var Question = /** @class */ (function () {
    function Question(id, text, answer, type, required, pageFlowModifier, elementId, min, max) {
        this.id = id;
        this.text = text;
        this.answer = answer;
        this.type = type;
        this.required = required;
        this.pageFlowModifier = pageFlowModifier;
        this.elementId = elementId;
        this.min = min;
        this.max = max;
        this.id = id ? id : UUID$$1();
        this.text = text ? text : '';
        this.answer = answer ? answer : '';
        this.type = type ? type : '';
        this.required = required ? required : false;
        this.pageFlowModifier = pageFlowModifier ? pageFlowModifier : false;
        this.elementId = elementId ? elementId : '';
        this.min = min ? min : null;
        this.max = max ? max : null;
    }
    return Question;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var Elements = /** @class */ (function () {
    function Elements(pageId, id, orderNo, type, question, paragraph, isSaved, showPageFlowToggle) {
        this.pageId = pageId;
        this.id = id;
        this.orderNo = orderNo;
        this.type = type;
        this.question = question;
        this.paragraph = paragraph;
        this.isSaved = isSaved;
        this.showPageFlowToggle = showPageFlowToggle;
        /** @type {?} */
        var uuid = UUID$$1();
        /** @type {?} */
        var newQuestion = new Question();
        newQuestion.elementId = uuid;
        this.id = id ? id : uuid;
        this.pageId = pageId ? pageId : '';
        this.orderNo = orderNo ? orderNo : 1;
        this.type = type ? type : 'question';
        this.question = question ? question : newQuestion;
        this.paragraph = paragraph ? paragraph : null;
        this.isSaved = isSaved ? isSaved : false;
        this.showPageFlowToggle = showPageFlowToggle ? showPageFlowToggle : true;
    }
    return Elements;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var OptionAnswers = /** @class */ (function () {
    function OptionAnswers(elementId, id, orderNo, value, pageFlow, isSaved) {
        this.elementId = elementId;
        this.id = id;
        this.orderNo = orderNo;
        this.value = value;
        this.pageFlow = pageFlow;
        this.isSaved = isSaved;
        this.id = id ? id : UUID$$1();
        this.elementId = elementId ? elementId : '';
        this.orderNo = orderNo ? orderNo : 1;
        this.value = value ? value : '';
        this.pageFlow = pageFlow ? pageFlow : new PageFlow();
        this.isSaved = isSaved ? isSaved : false;
    }
    return OptionAnswers;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var Paragraph = /** @class */ (function () {
    function Paragraph(id, html, elementId) {
        this.id = id;
        this.html = html;
        this.elementId = elementId;
        this.id = id ? id : UUID$$1();
        this.html = html ? html : '';
        this.elementId = elementId ? elementId : '';
    }
    return Paragraph;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var BuilderOptionsModel = /** @class */ (function () {
    function BuilderOptionsModel(importSurvey, surveyButtons, importPage, pageButtons, importElement, elementButtons) {
        this.importSurvey = importSurvey;
        this.surveyButtons = surveyButtons;
        this.importPage = importPage;
        this.pageButtons = pageButtons;
        this.importElement = importElement;
        this.elementButtons = elementButtons;
        this.importSurvey = importSurvey ? importSurvey : null;
        this.surveyButtons = surveyButtons ? surveyButtons : null;
        this.importPage = importPage ? importPage : null;
        this.pageButtons = pageButtons ? pageButtons : null;
        this.importElement = importElement ? importElement : null;
        this.elementButtons = elementButtons ? elementButtons : null;
    }
    return BuilderOptionsModel;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var getLastValueInMap$$1 = function (map$$1) { return Array.from(map$$1)[map$$1.size - 1][1]; };
/** @type {?} */
var arrayToMap$$1 = function (array) { return array.reduce(function (map$$1, arrayEl) { return map$$1.set(arrayEl[0], arrayEl[1]); }, new Map()); };
/** @type {?} */
var moveItemInMap$$1 = function (map$$1, index, item) {
    /** @type {?} */
    var array = Array.from(map$$1);
    if (index > array.length - 1) {
        array.push([item.id, item]);
    }
    else {
        array = array.reduce(function (newArray, el, idx) {
            if (idx === index) {
                newArray.push([item.id, item]);
                newArray.push(el);
            }
            else {
                newArray.push(el);
            }
            return newArray;
        }, []);
    }
    return arrayToMap$$1(array);
};
/** @type {?} */
var dragItemInArray$$1 = function (map$$1, startIndex, endIndex) {
    /** @type {?} */
    var array = Array.from(map$$1);
    moveItemInArray(array, startIndex, endIndex);
    return arrayToMap$$1(array);
};
/** @type {?} */
var updateElementPositionInMap$$1 = function (map$$1) { return Array.from(map$$1).reduce(function (acc, el) { return el[1].orderNo = acc + 1; }, 0); };
/** @type {?} */
var resetNgSurveyState$$1 = function () {
    // Init Survey
    /** @type {?} */
    var angularSurvey = new NgSurvey();
    // Init Pages
    /** @type {?} */
    var pageId = UUID$$1();
    /** @type {?} */
    var page = new Page(pageId, angularSurvey.id);
    /** @type {?} */
    var pageMap = new Map().set(page.id, page);
    // Init Elements
    /** @type {?} */
    var element = new Elements(page.id);
    /** @type {?} */
    var elementMap = new Map().set(element.id, element);
    /** @type {?} */
    var elementsMap = new Map().set(page.id, elementMap);
    // Init Option Answers
    /** @type {?} */
    var optionAnswerMap = new Map();
    /** @type {?} */
    var optionAnswersMap = new Map().set(element.id, optionAnswerMap);
    return {
        survey: angularSurvey,
        pages: pageMap,
        elements: elementsMap,
        optionAnswers: optionAnswersMap,
        builderOptions: new BuilderOptionsModel(),
    };
};
/**
 * @param {?} obj
 * @return {?}
 */
function isNil$$1(obj) {
    return obj === undefined || obj === null;
}
/** @type {?} */
var UUID$$1 = function () {
    if (typeof (window) !== 'undefined'
        && typeof (window.crypto) !== 'undefined'
        && typeof (window.crypto.getRandomValues) !== 'undefined') {
        // If we have a cryptographically secure PRNG, use that
        // http://stackoverflow.com/questions/6906916/collisions-when-generating-uuids-in-javascript
        /** @type {?} */
        var buf = new Uint16Array(8);
        window.crypto.getRandomValues(buf);
        return (pad4$$1(buf[0]) + pad4$$1(buf[1])
            + '-' + pad4$$1(buf[2])
            + '-' + pad4$$1(buf[3])
            + '-' + pad4$$1(buf[4])
            + '-' + pad4$$1(buf[5])
            + pad4$$1(buf[6])
            + pad4$$1(buf[7]));
    }
    else {
        // Otherwise, just use Math.random
        // https://stackoverflow.com/questions/105034/create-guid-uuid-in-javascript
        // https://stackoverflow.com/questions/11605068/why-does-jshint-argue-against-bitwise-operators-how-should-i-express-this-code
        return random4$$1() + random4$$1() + '-' + random4$$1() + '-' + random4$$1() + '-' +
            random4$$1() + '-' + random4$$1() + random4$$1() + random4$$1();
    }
};
/** @type {?} */
var pad4$$1 = function (num) {
    /** @type {?} */
    var ret = num.toString(16);
    while (ret.length < 4) {
        ret = '0' + ret;
    }
    return ret;
};
/** @type {?} */
var random4$$1 = function () {
    return Math.floor((1 + Math.random()) * 0x10000)
        .toString(16)
        .substring(1);
};
/** @type {?} */
var arrayTag = '[object Array]';
/** @type {?} */
var objectTag = '[object Object]';
/** @type {?} */
var mapTag = '[object Map]';
/** @type {?} */
var dateTag = '[object Date]';
/** @type {?} */
var deepCopy$$1 = function (value) {
    var e_1, _a;
    /** @type {?} */
    var output;
    /** @type {?} */
    var v;
    /** @type {?} */
    var tag = getTag(value);
    if (tag === arrayTag || tag === objectTag) {
        output = Array.isArray(value) ? [] : {};
        try {
            for (var _b = __values(Object.keys(value)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var key = _c.value;
                v = value[key];
                output[key] = (typeof v === 'object') ? deepCopy$$1(v) : v;
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_1) throw e_1.error; }
        }
    }
    else if (tag === mapTag) {
        output = new Map();
        value.forEach(function (subValue, key) {
            output.set(key, deepCopy$$1(subValue));
        });
        return output;
    }
    else if (tag === dateTag) {
        return new Date(value.getTime());
    }
    return output;
};
/**
 * @param {?} value
 * @return {?}
 */
function getTag(value) {
    if (value == null) {
        return value === undefined ? '[object Undefined]' : '[object Null]';
    }
    return toString.call(value);
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var appInitialState = resetNgSurveyState$$1();

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgSurveyStore = /** @class */ (function () {
    function NgSurveyStore() {
        this.dataStore = appInitialState;
        this._ngSurveyState = (/** @type {?} */ (new BehaviorSubject(this.dataStore)));
        this.ngSurveyState = this._ngSurveyState.asObservable();
        this._survey = (/** @type {?} */ (new BehaviorSubject(this.dataStore.survey)));
        this.survey = this._survey.asObservable();
        this._pages = (/** @type {?} */ (new BehaviorSubject(this.dataStore.pages)));
        this.pages = this._pages.asObservable();
        this._elements = (/** @type {?} */ (new BehaviorSubject(this.dataStore.elements)));
        this.elements = this._elements.asObservable();
        this._optionAnswers = (/** @type {?} */ (new BehaviorSubject(this.dataStore.optionAnswers)));
        this.optionAnswers = this._optionAnswers.asObservable();
        this._builderOptions = (/** @type {?} */ (new BehaviorSubject(this.dataStore.builderOptions)));
        this.builderOptions = this._builderOptions.asObservable();
    }
    /**
     * @param {?} payload
     * @return {?}
     */
    NgSurveyStore.prototype.updateNgSurveyState = /**
     * @param {?} payload
     * @return {?}
     */
    function (payload) {
        /** @type {?} */
        var newState = Object.assign({}, deepCopy$$1(this.dataStore), payload);
        this.dataStore = newState;
        this._ngSurveyState.next(newState);
    };
    /**
     * @param {?} survey
     * @return {?}
     */
    NgSurveyStore.prototype.updateSurvey = /**
     * @param {?} survey
     * @return {?}
     */
    function (survey) {
        this.dataStore.survey = survey;
        this._survey.next(survey);
        this.updateNgSurveyState(survey);
    };
    /**
     * @param {?} pages
     * @return {?}
     */
    NgSurveyStore.prototype.updatePages = /**
     * @param {?} pages
     * @return {?}
     */
    function (pages) {
        this.dataStore.pages = pages;
        this._pages.next(pages);
        this.updateNgSurveyState(pages);
    };
    /**
     * @param {?} elements
     * @return {?}
     */
    NgSurveyStore.prototype.updateElements = /**
     * @param {?} elements
     * @return {?}
     */
    function (elements) {
        this.dataStore.elements = elements;
        this._elements.next(elements);
        this.updateNgSurveyState(elements);
    };
    /**
     * @param {?} optionAnswers
     * @return {?}
     */
    NgSurveyStore.prototype.updateOptionAnswers = /**
     * @param {?} optionAnswers
     * @return {?}
     */
    function (optionAnswers) {
        this.dataStore.optionAnswers = optionAnswers;
        this._optionAnswers.next(optionAnswers);
        this.updateNgSurveyState(optionAnswers);
    };
    /**
     * @param {?} builderOptions
     * @return {?}
     */
    NgSurveyStore.prototype.updateBuilderOptions = /**
     * @param {?} builderOptions
     * @return {?}
     */
    function (builderOptions) {
        this.dataStore.builderOptions = builderOptions;
        this._builderOptions.next(builderOptions);
        this.updateNgSurveyState(builderOptions);
    };
    NgSurveyStore.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    NgSurveyStore.ctorParameters = function () { return []; };
    return NgSurveyStore;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgSurveysService = /** @class */ (function () {
    function NgSurveysService(_ngSurveyStore) {
        this._ngSurveyStore = _ngSurveyStore;
    }
    /**
     * Listen to the latest state changes in the stream.
     * @return This method returns changes
     * that occur to all of the survey state.
     */
    /**
     * Listen to the latest state changes in the stream.
     * @return {?} This method returns changes
     * that occur to all of the survey state.
     */
    NgSurveysService.prototype.getNgSurveyState = /**
     * Listen to the latest state changes in the stream.
     * @return {?} This method returns changes
     * that occur to all of the survey state.
     */
    function () {
        return this._ngSurveyStore.ngSurveyState;
    };
    /**
     * Listen to the latest survey state changes in the stream.
     * @return This method returns changes
     * that occur to the survey state.
     */
    /**
     * Listen to the latest survey state changes in the stream.
     * @return {?} This method returns changes
     * that occur to the survey state.
     */
    NgSurveysService.prototype.getSurveyChanges = /**
     * Listen to the latest survey state changes in the stream.
     * @return {?} This method returns changes
     * that occur to the survey state.
     */
    function () {
        return this._ngSurveyStore.survey;
    };
    /**
     * Listen to the latest pages state changes in the stream.
     * @return This method returns changes
     * that occur to the pages state.
     */
    /**
     * Listen to the latest pages state changes in the stream.
     * @return {?} This method returns changes
     * that occur to the pages state.
     */
    NgSurveysService.prototype.getPagesChanges = /**
     * Listen to the latest pages state changes in the stream.
     * @return {?} This method returns changes
     * that occur to the pages state.
     */
    function () {
        return this._ngSurveyStore.pages;
    };
    /**
     * Listen to the latest element state changes in the stream.
     * @return This method returns changes
     * that occur to the elements state.
     */
    /**
     * Listen to the latest element state changes in the stream.
     * @return {?} This method returns changes
     * that occur to the elements state.
     */
    NgSurveysService.prototype.getElementsChanges = /**
     * Listen to the latest element state changes in the stream.
     * @return {?} This method returns changes
     * that occur to the elements state.
     */
    function () {
        return this._ngSurveyStore.elements;
    };
    /**
     * Listen to the latest element state changes of a page in the stream.
     * @param pageId to retrieve elements of a specific page
     * @return This method returns changes
     * that occur to the elements state filtered by pageId.
     */
    /**
     * Listen to the latest element state changes of a page in the stream.
     * @param {?} pageId to retrieve elements of a specific page
     * @return {?} This method returns changes
     * that occur to the elements state filtered by pageId.
     */
    NgSurveysService.prototype.getElementsByPageIdChanges = /**
     * Listen to the latest element state changes of a page in the stream.
     * @param {?} pageId to retrieve elements of a specific page
     * @return {?} This method returns changes
     * that occur to the elements state filtered by pageId.
     */
    function (pageId) {
        return this._ngSurveyStore.elements.pipe(map(function (res) {
            return res.get(pageId);
        }));
    };
    /**
     * Listen to the latest option answers state changes in the stream.
     * @return This method returns changes
     * that occur to the option answers state.
     */
    /**
     * Listen to the latest option answers state changes in the stream.
     * @return {?} This method returns changes
     * that occur to the option answers state.
     */
    NgSurveysService.prototype.getOptionAnswersChanges = /**
     * Listen to the latest option answers state changes in the stream.
     * @return {?} This method returns changes
     * that occur to the option answers state.
     */
    function () {
        return this._ngSurveyStore.optionAnswers;
    };
    /**
     * Listen to the latest option answers state changes of an element in the stream.
     * @param elementId to retrieve option answers of a specific element
     * @return This method returns changes
     * that occur to the option answers state filtered by elementId.
     */
    /**
     * Listen to the latest option answers state changes of an element in the stream.
     * @param {?} elementId to retrieve option answers of a specific element
     * @return {?} This method returns changes
     * that occur to the option answers state filtered by elementId.
     */
    NgSurveysService.prototype.getOptionAnswersByElementIdChanges = /**
     * Listen to the latest option answers state changes of an element in the stream.
     * @param {?} elementId to retrieve option answers of a specific element
     * @return {?} This method returns changes
     * that occur to the option answers state filtered by elementId.
     */
    function (elementId) {
        return this._ngSurveyStore.optionAnswers.pipe(map(function (res) {
            return res.get(elementId);
        }));
    };
    NgSurveysService.decorators = [
        { type: Injectable, args: [{ providedIn: 'root' },] }
    ];
    /** @nocollapse */
    NgSurveysService.ctorParameters = function () { return [
        { type: NgSurveyStore }
    ]; };
    /** @nocollapse */ NgSurveysService.ngInjectableDef = defineInjectable({ factory: function NgSurveysService_Factory() { return new NgSurveysService(inject(NgSurveyStore)); }, token: NgSurveysService, providedIn: "root" });
    return NgSurveysService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @enum {string} */
var SurveyActionTypes = {
    SURVEY_NAME_CHANGED_ACTION: '[Angular Surveys] Survey title change',
    SURVEY_DESCRIPTION_CHANGED_ACTION: '[Angular Surveys] Survey description change',
    SURVEY_SUMMARY_CHANGED_ACTION: '[Angular Surveys] Survey summary change',
    RESET_SURVEY_STATE_ACTION: '[Angular Surveys] Reset survey state',
    HANDLE_SURVEY_LOADING: '[Angular Surveys] Handle is survey loading',
    IMPORT_SURVEY_STATE_ACTION: '[Angular Surveys] Import survey state',
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @enum {string} */
var PagesActionTypes = {
    ADD_PAGE_ACTION: '[Angular Page] Add survey page',
    INSERT_PAGE_ACTION: '[Angular Page] Insert survey page',
    MOVE_PAGE_UP_ACTION: '[Angular Page] Move survey page up',
    MOVE_PAGE_DOWN_ACTION: '[Angular Page] Move survey page down',
    REMOVE_PAGE_ACTION: '[Angular Page] Remove survey page',
    UPDATE_PAGE_NAME_ACTION: '[Angular Page] Update survey page name',
    UPDATE_PAGE_DESCRIPTION_ACTION: '[Angular Page] Update survey page description',
    UPDATE_PAGE_PAGE_FLOW_ACTION: '[Angular Page] Update survey page page flow',
    RESET_PAGE_STATE: '[Angular Page] Reset page state',
    IMPORT_PAGE_STATE: '[Angular Page] Import page state',
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @param {?} pages
 * @param {?} surveyId
 * @param {?} pageId
 * @return {?}
 */
function createNextPage(pages, surveyId, pageId) {
    /** @type {?} */
    var newPage = new Page(pageId, surveyId);
    if (pages.size >= 1) {
        /** @type {?} */
        var lastPage = getLastValueInMap$$1(pages);
        newPage.orderNo = lastPage.orderNo + 1;
    }
    pages.set(newPage.id, newPage);
    return new Map(pages);
}
/**
 * @param {?} pages
 * @param {?} previousPageId
 * @param {?} surveyId
 * @param {?} pageId
 * @return {?}
 */
function insertPage(pages, previousPageId, surveyId, pageId) {
    /** @type {?} */
    var newPage = new Page(pageId, surveyId);
    /** @type {?} */
    var pagesMap = new Map();
    pages.forEach(function (value, key) {
        if (key === previousPageId) {
            pagesMap.set(key, value);
            pagesMap.set(newPage.id, newPage);
        }
        else {
            pagesMap.set(key, value);
        }
    });
    updateElementPositionInMap$$1(pagesMap);
    return new Map(pagesMap);
}
/**
 * @param {?} pages
 * @param {?} pageId
 * @return {?}
 */
function movePageUp(pages, pageId) {
    /** @type {?} */
    var currentPage = pages.get(pageId);
    /** @type {?} */
    var index = currentPage.orderNo - 2;
    pages.delete(pageId);
    /** @type {?} */
    var pagesMap = moveItemInMap$$1(pages, index, currentPage);
    updateElementPositionInMap$$1(pagesMap);
    return new Map(pagesMap);
}
/**
 * @param {?} pages
 * @param {?} pageId
 * @return {?}
 */
function movePageDown(pages, pageId) {
    /** @type {?} */
    var currentPage = pages.get(pageId);
    /** @type {?} */
    var index = currentPage.orderNo;
    pages.delete(pageId);
    /** @type {?} */
    var pagesMap = moveItemInMap$$1(pages, index, currentPage);
    updateElementPositionInMap$$1(pagesMap);
    return new Map(pagesMap);
}
/**
 * @param {?} pages
 * @param {?} pageId
 * @return {?}
 */
function removePage(pages, pageId) {
    pages.delete(pageId);
    updateElementPositionInMap$$1(pages);
    return new Map(pages);
}
/**
 * @param {?} pages
 * @param {?} pageId
 * @param {?} name
 * @return {?}
 */
function updatePageName(pages, pageId, name) {
    /** @type {?} */
    var currentPage = pages.get(pageId);
    currentPage.name = name;
    return new Map(pages);
}
/**
 * @param {?} pages
 * @param {?} pageId
 * @param {?} description
 * @return {?}
 */
function updatePageDescription(pages, pageId, description) {
    /** @type {?} */
    var currentPage = pages.get(pageId);
    currentPage.description = description;
    return new Map(pages);
}
/**
 * @param {?} pages
 * @param {?} pageId
 * @param {?} pageFlow
 * @return {?}
 */
function updatePagePageFlow(pages, pageId, pageFlow) {
    /** @type {?} */
    var currentPage = pages.get(pageId);
    currentPage.pageFlow = pageFlow;
    return new Map(pages);
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @enum {string} */
var ElementsActionTypes = {
    ADD_ELEMENT_ACTION: '[Angular Element] Add survey question element',
    REMOVE_ELEMENT_ACTION: '[Angular Element] Remove survey question element',
    REMOVE_ELEMENT_MAP_ACTION: '[Angular Element] Remove element map',
    MOVE_ELEMENT_UP_ACTION: '[Angular Element] Move survey question element up',
    MOVE_ELEMENT_DOWN_ACTION: '[Angular Element] Move survey question element down',
    DRAG_ELEMENT_ACTION: '[Angular Element] Drag survey question element',
    QUESTION_ADD_TEXT_ACTION: '[Angular Question] Add question text',
    QUESTION_ADD_TYPE_ACTION: '[Angular Question] Add question type',
    QUESTION_UPDATE_MIN_ACTION: '[Angular Question] Update question max value',
    QUESTION_UPDATE_MAX_ACTION: '[Angular Question] Update question min value',
    QUESTION_REMOVE_VALUES_ACTION: '[Angular Question] Remove question values',
    QUESTION_UPDATE_PAGE_FLOW_MODIFIER_ACTION: '[Angular Question] UPDATE question page flow modifier',
    TOGGLE_IS_ACTIVE_ELEMENT_ACTION: '[Angular Element] Toggle isActive element',
    QUESTION_UPDATE_ANSWER_ACTION: '[Angular Question] Update question answer value',
    PARAGRAPH_UPDATE_HTML_ACTION: '[Angular Paragraph] Update paragraph HTML value',
    RESET_ELEMENTS_STATE: '[Angular Element] Reset elements state',
    IMPORT_ELEMENTS_STATE: '[Angular Element] Import elements state',
    IMPORT_ELEMENT: '[Angular Element] Import element',
    CLONE_ELEMENT_ACTION: '[Angular Element] Clone element',
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @param {?} pageId
 * @param {?} elements
 * @param {?} type
 * @return {?}
 */
function createNextElement(pageId, elements, type) {
    /** @type {?} */
    var newElement = new Elements(pageId);
    newElement.type = type;
    if (newElement.type === 'paragraph') {
        newElement = addParagraphType(newElement);
    }
    handleElementShowPageFlowToggle(elements, newElement);
    elements.set(newElement.id, newElement);
    updateElementPositionInMap$$1(elements);
    return new Map(elements);
}
/**
 * @param {?} pageId
 * @param {?} type
 * @return {?}
 */
function createNewElementMap(pageId, type) {
    /** @type {?} */
    var newElement = new Elements(pageId);
    newElement.type = type;
    if (newElement.type === 'paragraph') {
        newElement = addParagraphType(newElement);
    }
    /** @type {?} */
    var newElementMap = new Map().set(newElement.id, newElement);
    return new Map(newElementMap);
}
/**
 * @param {?} elementId
 * @param {?} elements
 * @return {?}
 */
function removeElement(elementId, elements) {
    elements.delete(elementId);
    updateElementPositionInMap$$1(elements);
    handleElementsShowPageFlowToggle(elements);
    return new Map(elements);
}
/**
 * @param {?} elementId
 * @param {?} elements
 * @return {?}
 */
function moveElementUp(elementId, elements) {
    /** @type {?} */
    var currentElement = elements.get(elementId);
    /** @type {?} */
    var index = currentElement.orderNo - 2;
    elements.delete(elementId);
    /** @type {?} */
    var newElementsMap = moveItemInMap$$1(elements, index, currentElement);
    updateElementPositionInMap$$1(newElementsMap);
    return new Map(newElementsMap);
}
/**
 * @param {?} elementId
 * @param {?} elements
 * @return {?}
 */
function moveElementDown(elementId, elements) {
    /** @type {?} */
    var currentElement = elements.get(elementId);
    /** @type {?} */
    var index = currentElement.orderNo;
    elements.delete(elementId);
    /** @type {?} */
    var newElementsMap = moveItemInMap$$1(elements, index, currentElement);
    updateElementPositionInMap$$1(newElementsMap);
    return new Map(newElementsMap);
}
/**
 * @param {?} startIndex
 * @param {?} endIndex
 * @param {?} elements
 * @return {?}
 */
function dragElement(startIndex, endIndex, elements) {
    /** @type {?} */
    var newElementsMap = dragItemInArray$$1(elements, startIndex, endIndex);
    updateElementPositionInMap$$1(newElementsMap);
    return new Map(newElementsMap);
}
/**
 * @param {?} elementId
 * @param {?} text
 * @param {?} elements
 * @return {?}
 */
function addQuestionText(elementId, text, elements) {
    /** @type {?} */
    var currentQuestion = elements.get(elementId).question;
    currentQuestion.text = text;
    return new Map(elements);
}
/**
 * @param {?} elementId
 * @param {?} type
 * @param {?} elements
 * @return {?}
 */
function addQuestionType(elementId, type, elements) {
    /** @type {?} */
    var currentQuestion = elements.get(elementId).question;
    currentQuestion.type = type;
    return new Map(elements);
}
/**
 * @param {?} elementId
 * @param {?} min
 * @param {?} elements
 * @return {?}
 */
function updateQuestionMin(elementId, min, elements) {
    /** @type {?} */
    var currentQuestion = elements.get(elementId).question;
    currentQuestion.min = min;
    return new Map(elements);
}
/**
 * @param {?} elementId
 * @param {?} max
 * @param {?} elements
 * @return {?}
 */
function updateQuestionMax(elementId, max, elements) {
    /** @type {?} */
    var currentQuestion = elements.get(elementId).question;
    currentQuestion.max = max;
    return new Map(elements);
}
/**
 * @param {?} elementId
 * @param {?} elements
 * @return {?}
 */
function removeQuestionValues(elementId, elements) {
    /** @type {?} */
    var currentElement = elements.get(elementId);
    if (currentElement) {
        /** @type {?} */
        var currentQuestion = currentElement.question;
        currentQuestion.min = null;
        currentQuestion.max = null;
        currentQuestion.answer = '';
        currentQuestion.text = '';
        currentElement.question = currentQuestion;
    }
    return new Map(elements);
}
/**
 * @param {?} elementId
 * @param {?} pageFlowModifier
 * @param {?} elements
 * @return {?}
 */
function updateQuestionPageFlowModifier(elementId, pageFlowModifier, elements) {
    /** @type {?} */
    var currentQuestion = elements.get(elementId).question;
    currentQuestion.pageFlowModifier = pageFlowModifier;
    updateShowPageFlowToggle(elements, elementId);
    return new Map(elements);
}
/**
 * @param {?} elementId
 * @param {?} isSaved
 * @param {?} elements
 * @return {?}
 */
function toggleElementIsSaved(elementId, isSaved, elements) {
    /** @type {?} */
    var element = elements.get(elementId);
    element.isSaved = isSaved;
    return new Map(elements);
}
/**
 * @param {?} elementId
 * @param {?} answer
 * @param {?} elements
 * @return {?}
 */
function updateQuestionAnswer(elementId, answer, elements) {
    /** @type {?} */
    var currentQuestion = elements.get(elementId).question;
    currentQuestion.answer = answer;
    return new Map(elements);
}
/**
 * @param {?} elementId
 * @param {?} html
 * @param {?} elements
 * @return {?}
 */
function updateParagraphHTML(elementId, html, elements) {
    /** @type {?} */
    var currentParagraph = elements.get(elementId).paragraph;
    currentParagraph.html = html;
    return new Map(elements);
}
/**
 * @param {?} element
 * @param {?} pageId
 * @param {?} elements
 * @param {?} currentElement
 * @return {?}
 */
function importElement(element, pageId, elements, currentElement) {
    elements.delete(currentElement.id);
    element.pageId = pageId;
    elements.set(element.id, element);
    updateElementPositionInMap$$1(elements);
    handleElementsShowPageFlowToggle(elements);
    return new Map(elements);
}
/**
 * @param {?} elementId
 * @param {?} elements
 * @return {?}
 */
function cloneElement(elementId, elements) {
    /** @type {?} */
    var currentElement = elements.get(elementId);
    /** @type {?} */
    var clonedElement = deepCopy$$1(currentElement);
    /** @type {?} */
    var index = currentElement.orderNo;
    /** @type {?} */
    var clonedElementId = UUID$$1();
    clonedElement.id = clonedElementId;
    updateElementTypeWithNewElementId(clonedElement, clonedElementId);
    /** @type {?} */
    var newElementsMap = insertElement(elements, clonedElement, index);
    updateElementPositionInMap$$1(newElementsMap);
    return new Map(newElementsMap);
}
/** @type {?} */
var updateShowPageFlowToggle = function (elements, elementId) {
    return elements.forEach(function (value, key) { return value.showPageFlowToggle = key === elementId; });
};
/** @type {?} */
var handleElementShowPageFlowToggle = function (elements, newElement) {
    return newElement.showPageFlowToggle = Array.from(elements).reduce(function (show, el) { return show && el[1].showPageFlowToggle; }, true);
};
/** @type {?} */
var handleElementsShowPageFlowToggle = function (elements) {
    /** @type {?} */
    var changeElementsShowPageFlowToggle = Array.from(elements).reduce(function (show, el) { return show && !el[1].showPageFlowToggle; }, true);
    if (changeElementsShowPageFlowToggle) {
        elements.forEach(function (value) { return value.showPageFlowToggle = true; });
    }
};
/** @type {?} */
var addParagraphType = function (element) {
    /** @type {?} */
    var paragraph = new Paragraph();
    paragraph.elementId = element.id;
    element.paragraph = paragraph;
    element.question = null;
    return element;
};
/** @type {?} */
var insertElement = function (elements, element, index) {
    /** @type {?} */
    var elementsArray = Array.from(elements);
    elementsArray.splice(index, 0, [element.id, element]);
    return arrayToMap$$1(elementsArray);
};
/** @type {?} */
var updateElementTypeWithNewElementId = function (element, newElementId) {
    for (var key in element) {
        if (key === 'elementId') {
            element[key] = newElementId;
        }
        else if (typeof element[key] === 'object') {
            updateElementTypeWithNewElementId(element[key], newElementId);
        }
    }
    return element;
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @enum {string} */
var OptionAnswersActionTypes = {
    ADD_OPTION_ANSWERS_ACTION: '[Angular Option Answers] Add question option answer',
    REMOVE_OPTION_ANSWERS_ACTION: '[Angular Option Answers] Remove question option answer',
    REMOVE_OPTION_ANSWERS_MAP_ACTION: '[Angular Option Answers] Remove question option answer map',
    REMOVE_OPTION_ANSWERS_MAPS_ACTION: '[Angular Option Answers] Remove question option answer maps',
    ADD_OPTION_ANSWERS_VALUE_ACTION: '[Angular Option Answers] Add question option answer value',
    UPDATE_OPTION_ANSWERS_PAGE_FLOW: '[Angular Option Answers] Update question option page flow',
    DRAG_OPTION_ANSWERS_ACTION: '[Angular Option Answers] Drag question options',
    TOGGLE_IS_ACTIVE_OPTION_ANSWERS_ACTION: '[Angular Option Answers] Toggle isActive question options',
    RESET_OPTION_ANSWERS_STATE: '[Angular Option Answers] Reset option answers state',
    IMPORT_OPTION_ANSWERS_STATE: '[Angular Option Answers] Import option answers state',
    IMPORT_OPTION_ANSWERS: '[Angular Option Answers] Import option answers',
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @param {?} elementId
 * @param {?} optionAnswers
 * @return {?}
 */
function addOptionAnswer(elementId, optionAnswers) {
    /** @type {?} */
    var newOptionAnswers = new OptionAnswers(elementId);
    optionAnswers.set(newOptionAnswers.id, newOptionAnswers);
    updateElementPositionInMap$$1(optionAnswers);
    return new Map(optionAnswers);
}
/**
 * @param {?} elementId
 * @return {?}
 */
function createNewOptionAnswersMap(elementId) {
    /** @type {?} */
    var newOptionAnswers = new OptionAnswers(elementId);
    /** @type {?} */
    var newOptionAnswersMap = new Map().set(newOptionAnswers.id, newOptionAnswers);
    return new Map(newOptionAnswersMap);
}
/**
 * @param {?} optionAnswersId
 * @param {?} optionAnswers
 * @return {?}
 */
function removeOptionAnswer(optionAnswersId, optionAnswers) {
    optionAnswers.delete(optionAnswersId);
    updateElementPositionInMap$$1(optionAnswers);
    return new Map(optionAnswers);
}
/**
 * @param {?} optionAnswersId
 * @param {?} value
 * @param {?} optionAnswers
 * @return {?}
 */
function addOptionAnswerValue(optionAnswersId, value, optionAnswers) {
    /** @type {?} */
    var currentOptionAnswer = optionAnswers.get(optionAnswersId);
    currentOptionAnswer.value = value;
    return new Map(optionAnswers);
}
/**
 * @param {?} optionAnswersId
 * @param {?} pageFlow
 * @param {?} optionAnswers
 * @return {?}
 */
function updateOptionAnswerPageFlow(optionAnswersId, pageFlow, optionAnswers) {
    /** @type {?} */
    var currentOptionAnswer = optionAnswers.get(optionAnswersId);
    currentOptionAnswer.pageFlow = pageFlow;
    return new Map(optionAnswers);
}
/**
 * @param {?} startIndex
 * @param {?} endIndex
 * @param {?} optionAnswers
 * @return {?}
 */
function dragOptionAnswer(startIndex, endIndex, optionAnswers) {
    /** @type {?} */
    var newOptionAnswersMap = dragItemInArray$1(optionAnswers, startIndex, endIndex);
    updateElementPositionInMap$$1(newOptionAnswersMap);
    return new Map(newOptionAnswersMap);
}
/**
 * @param {?} isSaved
 * @param {?} optionAnswers
 * @return {?}
 */
function toggleIsActiveOptionAnswerValue(isSaved, optionAnswers) {
    optionAnswers.forEach(function (value) {
        value.isSaved = isSaved;
    });
    return new Map(optionAnswers);
}
/** @type {?} */
var dragItemInArray$1 = function (map$$1, startIndex, endIndex) {
    /** @type {?} */
    var array = Array.from(map$$1);
    moveItemInArray(array, startIndex, endIndex);
    return arrayToMap$$1(array);
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var OptionAnswersReducer = /** @class */ (function () {
    function OptionAnswersReducer(_ngSurveyStore) {
        this._ngSurveyStore = _ngSurveyStore;
    }
    /**
     * @param {?} action
     * @return {?}
     */
    OptionAnswersReducer.prototype.optionAnswersReducer = /**
     * @param {?} action
     * @return {?}
     */
    function (action) {
        /** @type {?} */
        var state = this._ngSurveyStore.dataStore.optionAnswers;
        switch (action.type) {
            case OptionAnswersActionTypes.ADD_OPTION_ANSWERS_ACTION: {
                var elementId = action.payload.elementId;
                /** @type {?} */
                var prevOptionAnswers = state.get(elementId);
                /** @type {?} */
                var newOptionAnswers = void 0;
                if (!prevOptionAnswers) {
                    newOptionAnswers = createNewOptionAnswersMap(elementId);
                }
                else {
                    newOptionAnswers = addOptionAnswer(elementId, prevOptionAnswers);
                }
                state.set(elementId, newOptionAnswers);
                this._ngSurveyStore.updateOptionAnswers(state);
                break;
            }
            case OptionAnswersActionTypes.REMOVE_OPTION_ANSWERS_ACTION: {
                var _a = action.payload, elementId = _a.elementId, optionAnswerId = _a.optionAnswerId;
                /** @type {?} */
                var prevOptionAnswers = state.get(elementId);
                /** @type {?} */
                var newOptionAnswers = removeOptionAnswer(optionAnswerId, prevOptionAnswers);
                state.set(elementId, newOptionAnswers);
                this._ngSurveyStore.updateOptionAnswers(state);
                break;
            }
            case OptionAnswersActionTypes.REMOVE_OPTION_ANSWERS_MAP_ACTION: {
                var elementId = action.payload.elementId;
                state.delete(elementId);
                this._ngSurveyStore.updateOptionAnswers(state);
                break;
            }
            case OptionAnswersActionTypes.REMOVE_OPTION_ANSWERS_MAPS_ACTION: {
                var elementIds = action.payload.elementIds;
                elementIds.forEach(function (id) { return state.delete(id); });
                this._ngSurveyStore.updateOptionAnswers(state);
                break;
            }
            case OptionAnswersActionTypes.ADD_OPTION_ANSWERS_VALUE_ACTION: {
                var _b = action.payload, elementId = _b.elementId, optionAnswerId = _b.optionAnswerId, value = _b.value;
                /** @type {?} */
                var prevOptionAnswers = state.get(elementId);
                /** @type {?} */
                var newOptionAnswers = addOptionAnswerValue(optionAnswerId, value, prevOptionAnswers);
                state.set(elementId, newOptionAnswers);
                this._ngSurveyStore.updateOptionAnswers(state);
                break;
            }
            case OptionAnswersActionTypes.UPDATE_OPTION_ANSWERS_PAGE_FLOW: {
                var _c = action.payload, elementId = _c.elementId, optionAnswerId = _c.optionAnswerId, pageFlow = _c.pageFlow;
                /** @type {?} */
                var prevOptionAnswers = state.get(elementId);
                /** @type {?} */
                var newOptionAnswers = updateOptionAnswerPageFlow(optionAnswerId, pageFlow, prevOptionAnswers);
                state.set(elementId, newOptionAnswers);
                this._ngSurveyStore.updateOptionAnswers(state);
                break;
            }
            case OptionAnswersActionTypes.DRAG_OPTION_ANSWERS_ACTION: {
                var _d = action.payload, elementId = _d.elementId, startIndex = _d.startIndex, endIndex = _d.endIndex;
                /** @type {?} */
                var prevOptionAnswers = state.get(elementId);
                /** @type {?} */
                var newOptionAnswers = dragOptionAnswer(startIndex, endIndex, prevOptionAnswers);
                state.set(elementId, newOptionAnswers);
                this._ngSurveyStore.updateOptionAnswers(state);
                break;
            }
            case OptionAnswersActionTypes.TOGGLE_IS_ACTIVE_OPTION_ANSWERS_ACTION: {
                var _e = action.payload, elementId = _e.elementId, isSaved = _e.isSaved;
                /** @type {?} */
                var prevOptionAnswers = state.get(elementId);
                if (prevOptionAnswers) {
                    /** @type {?} */
                    var newOptionAnswers = toggleIsActiveOptionAnswerValue(isSaved, prevOptionAnswers);
                    state.set(elementId, newOptionAnswers);
                }
                this._ngSurveyStore.updateOptionAnswers(state);
                break;
            }
            case OptionAnswersActionTypes.RESET_OPTION_ANSWERS_STATE: {
                var ngSurveyState = action.payload.ngSurveyState;
                this._ngSurveyStore.updateOptionAnswers(ngSurveyState.optionAnswers);
                break;
            }
            case OptionAnswersActionTypes.IMPORT_OPTION_ANSWERS_STATE: {
                var ngSurveyState = action.payload.ngSurveyState;
                this._ngSurveyStore.updateOptionAnswers(ngSurveyState.optionAnswers);
                break;
            }
            case OptionAnswersActionTypes.IMPORT_OPTION_ANSWERS: {
                var _f = action.payload, newOptionAnswers = _f.newOptionAnswers, elementId = _f.elementId;
                state.set(elementId, newOptionAnswers);
                this._ngSurveyStore.updateOptionAnswers(state);
                break;
            }
            default: {
                return state;
            }
        }
    };
    OptionAnswersReducer.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    OptionAnswersReducer.ctorParameters = function () { return [
        { type: NgSurveyStore }
    ]; };
    return OptionAnswersReducer;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ElementsReducer = /** @class */ (function () {
    function ElementsReducer(_ngSurveyStore, _optionAnswersReducer) {
        this._ngSurveyStore = _ngSurveyStore;
        this._optionAnswersReducer = _optionAnswersReducer;
    }
    /**
     * @param {?} action
     * @return {?}
     */
    ElementsReducer.prototype.elementsReducer = /**
     * @param {?} action
     * @return {?}
     */
    function (action) {
        /** @type {?} */
        var state = this._ngSurveyStore.dataStore.elements;
        switch (action.type) {
            case ElementsActionTypes.ADD_ELEMENT_ACTION: {
                var _a = action.payload, pageId = _a.pageId, type = _a.type;
                /** @type {?} */
                var prevElements = state.get(pageId);
                /** @type {?} */
                var newElements = void 0;
                if (!prevElements) {
                    newElements = createNewElementMap(pageId, type);
                }
                else {
                    newElements = createNextElement(pageId, prevElements, type);
                }
                state.set(pageId, newElements);
                this._ngSurveyStore.updateElements(state);
                break;
            }
            case ElementsActionTypes.REMOVE_ELEMENT_ACTION: {
                var _b = action.payload, pageId = _b.pageId, elementId = _b.elementId;
                /** @type {?} */
                var prevElements = state.get(pageId);
                /** @type {?} */
                var newElements = removeElement(elementId, prevElements);
                state.set(pageId, newElements);
                this._ngSurveyStore.updateElements(state);
                // Effect
                this._optionAnswersReducer.optionAnswersReducer({
                    type: OptionAnswersActionTypes.REMOVE_OPTION_ANSWERS_MAP_ACTION,
                    payload: { elementId: elementId }
                });
                break;
            }
            case ElementsActionTypes.REMOVE_ELEMENT_MAP_ACTION: {
                var _c = action.payload, pageId = _c.pageId, elementIds = _c.elementIds;
                state.delete(pageId);
                this._ngSurveyStore.updateElements(state);
                // Effect
                this._optionAnswersReducer.optionAnswersReducer({
                    type: OptionAnswersActionTypes.REMOVE_OPTION_ANSWERS_MAPS_ACTION,
                    payload: { elementIds: elementIds }
                });
                break;
            }
            case ElementsActionTypes.MOVE_ELEMENT_UP_ACTION: {
                var _d = action.payload, pageId = _d.pageId, elementId = _d.elementId;
                /** @type {?} */
                var prevElements = state.get(pageId);
                /** @type {?} */
                var newElements = moveElementUp(elementId, prevElements);
                state.set(pageId, newElements);
                this._ngSurveyStore.updateElements(state);
                break;
            }
            case ElementsActionTypes.MOVE_ELEMENT_DOWN_ACTION: {
                var _e = action.payload, pageId = _e.pageId, elementId = _e.elementId;
                /** @type {?} */
                var prevElements = state.get(pageId);
                /** @type {?} */
                var newElements = moveElementDown(elementId, prevElements);
                state.set(pageId, newElements);
                this._ngSurveyStore.updateElements(state);
                break;
            }
            case ElementsActionTypes.DRAG_ELEMENT_ACTION: {
                var _f = action.payload, pageId = _f.pageId, startIndex = _f.startIndex, endIndex = _f.endIndex;
                /** @type {?} */
                var prevElements = state.get(pageId);
                /** @type {?} */
                var newElements = dragElement(startIndex, endIndex, prevElements);
                state.set(pageId, newElements);
                this._ngSurveyStore.updateElements(state);
                break;
            }
            case ElementsActionTypes.QUESTION_ADD_TEXT_ACTION: {
                var _g = action.payload, pageId = _g.pageId, elementId = _g.elementId, text = _g.text;
                /** @type {?} */
                var prevElements = state.get(pageId);
                /** @type {?} */
                var newElements = addQuestionText(elementId, text, prevElements);
                state.set(pageId, newElements);
                this._ngSurveyStore.updateElements(state);
                break;
            }
            case ElementsActionTypes.QUESTION_ADD_TYPE_ACTION: {
                var _h = action.payload, pageId = _h.pageId, elementId = _h.elementId, type = _h.type;
                /** @type {?} */
                var prevElements = state.get(pageId);
                /** @type {?} */
                var newElements = addQuestionType(elementId, type, prevElements);
                state.set(pageId, newElements);
                this._ngSurveyStore.updateElements(state);
                // Effects
                if (type === 'radio' || type === 'checkboxes' || type === 'select') {
                    this._optionAnswersReducer.optionAnswersReducer({
                        type: OptionAnswersActionTypes.ADD_OPTION_ANSWERS_ACTION,
                        payload: { elementId: elementId }
                    });
                }
                break;
            }
            case ElementsActionTypes.QUESTION_UPDATE_MIN_ACTION: {
                var _j = action.payload, pageId = _j.pageId, elementId = _j.elementId, min = _j.min;
                /** @type {?} */
                var prevElements = state.get(pageId);
                /** @type {?} */
                var newElements = updateQuestionMin(elementId, min, prevElements);
                state.set(pageId, newElements);
                this._ngSurveyStore.updateElements(state);
                break;
            }
            case ElementsActionTypes.QUESTION_UPDATE_MAX_ACTION: {
                var _k = action.payload, pageId = _k.pageId, elementId = _k.elementId, max = _k.max;
                /** @type {?} */
                var prevElements = state.get(pageId);
                /** @type {?} */
                var newElements = updateQuestionMax(elementId, max, prevElements);
                state.set(pageId, newElements);
                this._ngSurveyStore.updateElements(state);
                break;
            }
            case ElementsActionTypes.QUESTION_REMOVE_VALUES_ACTION: {
                var _l = action.payload, pageId = _l.pageId, elementId = _l.elementId;
                /** @type {?} */
                var prevElements = state.get(pageId);
                /** @type {?} */
                var newElements = removeQuestionValues(elementId, prevElements);
                state.set(pageId, newElements);
                this._ngSurveyStore.updateElements(state);
                break;
            }
            case ElementsActionTypes.QUESTION_UPDATE_PAGE_FLOW_MODIFIER_ACTION: {
                var _m = action.payload, pageId = _m.pageId, elementId = _m.elementId, pageFlowModifier = _m.pageFlowModifier;
                /** @type {?} */
                var prevElements = state.get(pageId);
                /** @type {?} */
                var newElements = updateQuestionPageFlowModifier(elementId, pageFlowModifier, prevElements);
                state.set(pageId, newElements);
                this._ngSurveyStore.updateElements(state);
                break;
            }
            case ElementsActionTypes.TOGGLE_IS_ACTIVE_ELEMENT_ACTION: {
                var _o = action.payload, pageId = _o.pageId, elementId = _o.elementId, isSaved = _o.isSaved;
                /** @type {?} */
                var prevElements = state.get(pageId);
                /** @type {?} */
                var newElements = toggleElementIsSaved(elementId, isSaved, prevElements);
                state.set(pageId, newElements);
                this._ngSurveyStore.updateElements(state);
                // Effect
                this._optionAnswersReducer.optionAnswersReducer({
                    type: OptionAnswersActionTypes.TOGGLE_IS_ACTIVE_OPTION_ANSWERS_ACTION,
                    payload: { elementId: elementId, isSaved: isSaved }
                });
                break;
            }
            case ElementsActionTypes.QUESTION_UPDATE_ANSWER_ACTION: {
                var _p = action.payload, pageId = _p.pageId, elementId = _p.elementId, answer = _p.answer, pageFlowModifier = _p.pageFlowModifier, pageFlow = _p.pageFlow;
                /** @type {?} */
                var prevElements = state.get(pageId);
                /** @type {?} */
                var newElements = updateQuestionAnswer(elementId, answer, prevElements);
                state.set(pageId, newElements);
                this._ngSurveyStore.updateElements(state);
                break;
            }
            case ElementsActionTypes.PARAGRAPH_UPDATE_HTML_ACTION: {
                var _q = action.payload, pageId = _q.pageId, elementId = _q.elementId, html = _q.html;
                /** @type {?} */
                var prevElements = state.get(pageId);
                /** @type {?} */
                var newElements = updateParagraphHTML(elementId, html, prevElements);
                state.set(pageId, newElements);
                this._ngSurveyStore.updateElements(state);
                break;
            }
            case ElementsActionTypes.RESET_ELEMENTS_STATE: {
                var ngSurveyState = action.payload.ngSurveyState;
                this._ngSurveyStore.updateElements(ngSurveyState.elements);
                break;
            }
            case ElementsActionTypes.IMPORT_ELEMENTS_STATE: {
                var ngSurveyState = action.payload.ngSurveyState;
                this._ngSurveyStore.updateElements(ngSurveyState.elements);
                break;
            }
            case ElementsActionTypes.IMPORT_ELEMENT: {
                var _r = action.payload, element = _r.element, pageId = _r.pageId, currentElement = _r.currentElement, newOptionAnswers = _r.newOptionAnswers, elementId = _r.elementId, optionAnswers = _r.optionAnswers;
                /** @type {?} */
                var prevElements = state.get(pageId);
                /** @type {?} */
                var newElements = importElement(element, pageId, prevElements, currentElement);
                state.set(pageId, newElements);
                this._ngSurveyStore.updateElements(state);
                // Effect
                if (!isNil$$1(optionAnswers)) {
                    this._optionAnswersReducer.optionAnswersReducer({
                        type: OptionAnswersActionTypes.IMPORT_OPTION_ANSWERS,
                        payload: { newOptionAnswers: newOptionAnswers, elementId: elementId }
                    });
                }
                break;
            }
            case ElementsActionTypes.CLONE_ELEMENT_ACTION: {
                var _s = action.payload, pageId = _s.pageId, elementId = _s.elementId;
                /** @type {?} */
                var prevElements = state.get(pageId);
                /** @type {?} */
                var newElements = cloneElement(elementId, prevElements);
                state.set(pageId, newElements);
                this._ngSurveyStore.updateElements(state);
                break;
            }
            default: {
                return state;
            }
        }
    };
    ElementsReducer.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    ElementsReducer.ctorParameters = function () { return [
        { type: NgSurveyStore },
        { type: OptionAnswersReducer }
    ]; };
    return ElementsReducer;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var PagesReducer = /** @class */ (function () {
    function PagesReducer(_ngSurveyStore, _elementsReducer) {
        this._ngSurveyStore = _ngSurveyStore;
        this._elementsReducer = _elementsReducer;
    }
    /**
     * @param {?} action
     * @return {?}
     */
    PagesReducer.prototype.pagesReducer = /**
     * @param {?} action
     * @return {?}
     */
    function (action) {
        /** @type {?} */
        var state = this._ngSurveyStore.dataStore.pages;
        switch (action.type) {
            case PagesActionTypes.ADD_PAGE_ACTION: {
                var _a = action.payload, surveyId = _a.surveyId, pageId = _a.pageId;
                /** @type {?} */
                var prevPages = state;
                /** @type {?} */
                var pages = createNextPage(prevPages, surveyId, pageId);
                /** @type {?} */
                var newState = deepCopy$$1(pages);
                this._ngSurveyStore.updatePages(newState);
                // Effects
                this._elementsReducer.elementsReducer({
                    type: ElementsActionTypes.ADD_ELEMENT_ACTION,
                    payload: { pageId: pageId, type: 'question' }
                });
                break;
            }
            case PagesActionTypes.INSERT_PAGE_ACTION: {
                var _b = action.payload, previousPageId = _b.previousPageId, surveyId = _b.surveyId, pageId = _b.pageId;
                /** @type {?} */
                var pages = insertPage(state, previousPageId, surveyId, pageId);
                /** @type {?} */
                var newState = deepCopy$$1(pages);
                this._ngSurveyStore.updatePages(newState);
                // Effects
                this._elementsReducer.elementsReducer({
                    type: ElementsActionTypes.ADD_ELEMENT_ACTION,
                    payload: { pageId: pageId, type: 'question' }
                });
                break;
            }
            case PagesActionTypes.MOVE_PAGE_UP_ACTION: {
                var pageId = action.payload.pageId;
                /** @type {?} */
                var pages = movePageUp(state, pageId);
                /** @type {?} */
                var newState = deepCopy$$1(pages);
                this._ngSurveyStore.updatePages(newState);
                break;
            }
            case PagesActionTypes.MOVE_PAGE_DOWN_ACTION: {
                var pageId = action.payload.pageId;
                /** @type {?} */
                var pages = movePageDown(state, pageId);
                /** @type {?} */
                var newState = deepCopy$$1(pages);
                this._ngSurveyStore.updatePages(newState);
                break;
            }
            case PagesActionTypes.REMOVE_PAGE_ACTION: {
                var _c = action.payload, pageId = _c.pageId, elementIds = _c.elementIds;
                /** @type {?} */
                var pages = removePage(state, pageId);
                /** @type {?} */
                var newState = deepCopy$$1(pages);
                this._ngSurveyStore.updatePages(newState);
                // Effects
                this._elementsReducer.elementsReducer({
                    type: ElementsActionTypes.REMOVE_ELEMENT_MAP_ACTION,
                    payload: { pageId: pageId, elementIds: elementIds }
                });
                break;
            }
            case PagesActionTypes.UPDATE_PAGE_NAME_ACTION: {
                var _d = action.payload, pageId = _d.pageId, name_1 = _d.name;
                /** @type {?} */
                var pages = updatePageName(state, pageId, name_1);
                /** @type {?} */
                var newState = deepCopy$$1(pages);
                this._ngSurveyStore.updatePages(newState);
                break;
            }
            case PagesActionTypes.UPDATE_PAGE_DESCRIPTION_ACTION: {
                var _e = action.payload, pageId = _e.pageId, description = _e.description;
                /** @type {?} */
                var pages = updatePageDescription(state, pageId, description);
                /** @type {?} */
                var newState = deepCopy$$1(pages);
                this._ngSurveyStore.updatePages(newState);
                break;
            }
            case PagesActionTypes.UPDATE_PAGE_PAGE_FLOW_ACTION: {
                var _f = action.payload, pageId = _f.pageId, pageFlow = _f.pageFlow;
                /** @type {?} */
                var pages = updatePagePageFlow(state, pageId, pageFlow);
                /** @type {?} */
                var newState = deepCopy$$1(pages);
                this._ngSurveyStore.updatePages(newState);
                break;
            }
            case PagesActionTypes.RESET_PAGE_STATE: {
                var ngSurveyState = action.payload.ngSurveyState;
                this._ngSurveyStore.updatePages(Object.assign(ngSurveyState.pages));
                break;
            }
            case PagesActionTypes.IMPORT_PAGE_STATE: {
                var ngSurveyState = action.payload.ngSurveyState;
                this._ngSurveyStore.updatePages(Object.assign(ngSurveyState.pages));
                break;
            }
            default: {
                return state;
            }
        }
    };
    PagesReducer.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    PagesReducer.ctorParameters = function () { return [
        { type: NgSurveyStore },
        { type: ElementsReducer }
    ]; };
    return PagesReducer;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var SurveyReducer = /** @class */ (function () {
    function SurveyReducer(_ngSurveyStore, _pagesReducer, _elementsReducer, _optionAnswersReducer) {
        this._ngSurveyStore = _ngSurveyStore;
        this._pagesReducer = _pagesReducer;
        this._elementsReducer = _elementsReducer;
        this._optionAnswersReducer = _optionAnswersReducer;
    }
    /**
     * @param {?} action
     * @return {?}
     */
    SurveyReducer.prototype.surveyReducer = /**
     * @param {?} action
     * @return {?}
     */
    function (action) {
        var _this = this;
        /** @type {?} */
        var state = this._ngSurveyStore.dataStore.survey;
        switch (action.type) {
            case SurveyActionTypes.SURVEY_NAME_CHANGED_ACTION: {
                /** @type {?} */
                var newState = Object.assign(deepCopy$$1(state), __assign({}, action.payload));
                this._ngSurveyStore.updateSurvey(newState);
                break;
            }
            case SurveyActionTypes.SURVEY_DESCRIPTION_CHANGED_ACTION: {
                /** @type {?} */
                var newState = Object.assign(deepCopy$$1(state), __assign({}, action.payload));
                this._ngSurveyStore.updateSurvey(newState);
                break;
            }
            case SurveyActionTypes.SURVEY_SUMMARY_CHANGED_ACTION: {
                /** @type {?} */
                var newState = Object.assign(deepCopy$$1(state), __assign({}, action.payload));
                this._ngSurveyStore.updateSurvey(newState);
                break;
            }
            case SurveyActionTypes.RESET_SURVEY_STATE_ACTION: {
                var ngSurveyState = action.payload.ngSurveyState;
                this._ngSurveyStore.updateSurvey(ngSurveyState.survey);
                // Effects
                this._pagesReducer.pagesReducer({
                    type: PagesActionTypes.RESET_PAGE_STATE,
                    payload: { ngSurveyState: ngSurveyState },
                });
                this._elementsReducer.elementsReducer({
                    type: ElementsActionTypes.RESET_ELEMENTS_STATE,
                    payload: { ngSurveyState: ngSurveyState },
                });
                this._optionAnswersReducer.optionAnswersReducer({
                    type: OptionAnswersActionTypes.RESET_OPTION_ANSWERS_STATE,
                    payload: { ngSurveyState: ngSurveyState },
                });
                setTimeout(function () {
                    _this.surveyReducer({
                        type: SurveyActionTypes.HANDLE_SURVEY_LOADING,
                        payload: { isLoading: false }
                    });
                }, 1000);
                break;
            }
            case SurveyActionTypes.HANDLE_SURVEY_LOADING: {
                /** @type {?} */
                var newState = Object.assign(deepCopy$$1(state), __assign({}, action.payload));
                this._ngSurveyStore.updateSurvey(newState);
                break;
            }
            case SurveyActionTypes.IMPORT_SURVEY_STATE_ACTION: {
                var ngSurveyState = action.payload.ngSurveyState;
                this._ngSurveyStore.updateSurvey(ngSurveyState.survey);
                // Effects
                this._pagesReducer.pagesReducer({
                    type: PagesActionTypes.IMPORT_PAGE_STATE,
                    payload: { ngSurveyState: ngSurveyState },
                });
                this._elementsReducer.elementsReducer({
                    type: ElementsActionTypes.IMPORT_ELEMENTS_STATE,
                    payload: { ngSurveyState: ngSurveyState },
                });
                this._optionAnswersReducer.optionAnswersReducer({
                    type: OptionAnswersActionTypes.IMPORT_OPTION_ANSWERS_STATE,
                    payload: { ngSurveyState: ngSurveyState },
                });
                this.surveyReducer({
                    type: SurveyActionTypes.HANDLE_SURVEY_LOADING,
                    payload: { isLoading: false }
                });
                break;
            }
            default: {
                return this._ngSurveyStore.survey;
            }
        }
    };
    SurveyReducer.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    SurveyReducer.ctorParameters = function () { return [
        { type: NgSurveyStore },
        { type: PagesReducer },
        { type: ElementsReducer },
        { type: OptionAnswersReducer }
    ]; };
    return SurveyReducer;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @enum {string} */
var BuilderOptionsActionTypes = {
    UPDATE_BUILDER_OPTIONS_ACTION: '[Builder Options] Update builder options',
    RESET_BUILDER_OPTIONS_ACTION: '[Builder Options] Reset builder options',
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var BuilderOptionsReducer = /** @class */ (function () {
    function BuilderOptionsReducer(_ngSurveyStore) {
        this._ngSurveyStore = _ngSurveyStore;
    }
    /**
     * @param {?} action
     * @return {?}
     */
    BuilderOptionsReducer.prototype.builderOptionsReducer = /**
     * @param {?} action
     * @return {?}
     */
    function (action) {
        /** @type {?} */
        var state = this._ngSurveyStore.dataStore.builderOptions;
        switch (action.type) {
            case BuilderOptionsActionTypes.UPDATE_BUILDER_OPTIONS_ACTION: {
                /** @type {?} */
                var newState = Object.assign(deepCopy$$1(state), __assign({}, action.payload.builderOptions));
                this._ngSurveyStore.updateBuilderOptions(newState);
                break;
            }
            case BuilderOptionsActionTypes.RESET_BUILDER_OPTIONS_ACTION: {
                /** @type {?} */
                var newState = Object.assign(deepCopy$$1(state), __assign({}, action.payload.builderOptions));
                this._ngSurveyStore.updateBuilderOptions(newState);
                break;
            }
            default: {
                return state;
            }
        }
    };
    BuilderOptionsReducer.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    BuilderOptionsReducer.ctorParameters = function () { return [
        { type: NgSurveyStore }
    ]; };
    return BuilderOptionsReducer;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgBuilderViewerComponent = /** @class */ (function () {
    function NgBuilderViewerComponent(_ngSurveyStore, _surveyReducer, _pagesReducer, _builderOptionsReducer) {
        var _this = this;
        this._ngSurveyStore = _ngSurveyStore;
        this._surveyReducer = _surveyReducer;
        this._pagesReducer = _pagesReducer;
        this._builderOptionsReducer = _builderOptionsReducer;
        this.isLoading = false;
        this.surveySub = this._ngSurveyStore.survey.subscribe(function (res) {
            _this.survey = res;
        });
        this.ngSurveyStateSub = this._ngSurveyStore.ngSurveyState.subscribe(function (res) {
            _this.ngSurveyState = res;
        });
        this.pagesSub = this._ngSurveyStore.pages.subscribe(function (pagesRes) {
            _this.pages = pagesRes;
        });
    }
    Object.defineProperty(NgBuilderViewerComponent.prototype, "options", {
        get: /**
         * @return {?}
         */
        function () {
            return this._options;
        },
        set: /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            this._options = value;
            this.handleBuilderOptionsChange(this._options);
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    NgBuilderViewerComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
    };
    /**
     * @return {?}
     */
    NgBuilderViewerComponent.prototype.ngOnDestroy = /**
     * @return {?}
     */
    function () {
        this.surveySub.unsubscribe();
        this.pagesSub.unsubscribe();
        this.ngSurveyStateSub.unsubscribe();
    };
    /**
     * @param {?} builderOptions
     * @return {?}
     */
    NgBuilderViewerComponent.prototype.handleBuilderOptionsChange = /**
     * @param {?} builderOptions
     * @return {?}
     */
    function (builderOptions) {
        this._builderOptionsReducer.builderOptionsReducer({
            type: BuilderOptionsActionTypes.UPDATE_BUILDER_OPTIONS_ACTION,
            payload: { builderOptions: builderOptions }
        });
    };
    /**
     * @return {?}
     */
    NgBuilderViewerComponent.prototype.addPage = /**
     * @return {?}
     */
    function () {
        /** @type {?} */
        var pageId = UUID$$1();
        this._pagesReducer.pagesReducer({
            type: PagesActionTypes.ADD_PAGE_ACTION,
            payload: { surveyId: this.survey.id, pageId: pageId },
        });
    };
    /**
     * @return {?}
     */
    NgBuilderViewerComponent.prototype.reset = /**
     * @return {?}
     */
    function () {
        /** @type {?} */
        var ngSurveyState = resetNgSurveyState$$1();
        ngSurveyState.survey.isLoading = true;
        this._surveyReducer.surveyReducer({
            type: SurveyActionTypes.RESET_SURVEY_STATE_ACTION,
            payload: { ngSurveyState: ngSurveyState },
        });
    };
    /**
     * @param {?} cb
     * @return {?}
     */
    NgBuilderViewerComponent.prototype.importSurvey = /**
     * @param {?} cb
     * @return {?}
     */
    function (cb) {
        var _this = this;
        cb().subscribe(function (ngSurveyState) {
            ngSurveyState.survey.isLoading = true;
            _this._surveyReducer.surveyReducer({
                type: SurveyActionTypes.IMPORT_SURVEY_STATE_ACTION,
                payload: { ngSurveyState: ngSurveyState },
            });
        });
    };
    /**
     * @param {?} index
     * @param {?} item
     * @return {?}
     */
    NgBuilderViewerComponent.prototype.trackElement = /**
     * @param {?} index
     * @param {?} item
     * @return {?}
     */
    function (index, item) {
        return item ? item.key : null;
    };
    NgBuilderViewerComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ngs-builder-viewer',
                    template: "<div *ngIf=\"survey.isLoading\">\n  <ngs-loader [isInherit]=\"true\"></ngs-loader>\n</div>\n\n<div *ngIf=\"!survey.isLoading\">\n  <div class=\"mb-3 d-flex flex-md-row flex-column justify-content-start\">\n    <span>\n      <button class=\"btn btn-primary mb-md-0 mb-3\" tooltip=\"Reset Survey\" (click)=\"reset()\"><i class=\"fas fa-trash-alt\"></i> Reset Survey</button>\n    </span>\n    <span>\n      <button\n        *ngIf=\"!!options?.importSurvey\"\n        class=\"btn btn-primary ml-md-3 mb-md-0 mb-3\"\n        [tooltip]=\"!!options.importSurvey?.title ? options.importSurvey?.title : 'Import Survey'\"\n        (click)=\"importSurvey(options.importSurvey.callback)\"\n      >\n      <i [class]=\"!!options.importSurvey?.icon ? options.importSurvey?.icon : 'fas fa-file-import'\"></i> Import Survey\n    </button>\n    </span>\n    <span *ngIf=\"!!options?.surveyButtons && options?.surveyButtons.length > 0\">\n      <button *ngFor=\"let button of options?.surveyButtons\" class=\"btn btn-primary ml-md-3\" [tooltip]=\"button?.title\" (click)=\"button?.callback(ngSurveyState)\">\n        <i *ngIf=\"button.icon\" [class]=\"button?.icon\"></i> {{button?.text}}\n      </button>\n    </span>\n  </div>\n  <div class=\"card\">\n    <div class=\"card-header\">\n      Survey Template Info\n    </div>\n    <div class=\"card-body\">\n      <ngs-survey-template-form\n        [survey]=\"survey\"\n      ></ngs-survey-template-form>\n\n      <!-- Page Builder Container -->\n      <div *ngFor=\"let item of pages | mapValues; trackBy: trackElement\">\n        <ngs-page-builder-container\n                [surveyId]=\"survey.id\"\n                [page]=\"item?.value\"\n                [pages]=\"pages\"\n        ></ngs-page-builder-container>\n      </div>\n      <!-- #/Page Builder Container -->\n    </div>\n  </div>\n\n  <!-- Survey Summary -->\n  <ngs-summary-container></ngs-summary-container>\n  <!-- Survey Summary -->\n\n  <div class=\"mt-5\">\n    <div class=\"d-flex flex-row justify-content-between align-items-end\">\n\n      <!-- TODO add pagination-->\n      <!--<nav aria-label=\"Page navigation example\">-->\n        <!--<ul class=\"pagination mb-0\">-->\n          <!--<li class=\"page-item\">-->\n            <!--<a class=\"page-link\" href=\"#\" aria-label=\"Previous\">-->\n              <!--<span aria-hidden=\"true\">&laquo;</span>-->\n              <!--<span class=\"sr-only\">Previous</span>-->\n            <!--</a>-->\n          <!--</li>-->\n          <!--<li class=\"page-item\"><a class=\"page-link\" href=\"#\">1</a></li>-->\n          <!--<li class=\"page-item\"><a class=\"page-link\" href=\"#\">2</a></li>-->\n          <!--<li class=\"page-item\"><a class=\"page-link\" href=\"#\">3</a></li>-->\n          <!--<li class=\"page-item\">-->\n            <!--<a class=\"page-link\" href=\"#\" aria-label=\"Next\">-->\n              <!--<span aria-hidden=\"true\">&raquo;</span>-->\n              <!--<span class=\"sr-only\">Next</span>-->\n            <!--</a>-->\n          <!--</li>-->\n        <!--</ul>-->\n      <!--</nav>-->\n\n      <!--<select class=\"custom-select custom-select-lg mb-0 w-auto\">-->\n        <!--<option value=\"1\" selected>10</option>-->\n        <!--<option value=\"2\">25</option>-->\n        <!--<option value=\"3\">50</option>-->\n      <!--</select>-->\n\n      <button type=\"button\" class=\"btn btn-outline-primary\" (click)=\"addPage()\">Add Page</button>\n    </div>\n  </div>\n</div>\n",
                    styles: [".card-body{border-left:1px solid rgba(0,0,0,.125)}"]
                }] }
    ];
    /** @nocollapse */
    NgBuilderViewerComponent.ctorParameters = function () { return [
        { type: NgSurveyStore },
        { type: SurveyReducer },
        { type: PagesReducer },
        { type: BuilderOptionsReducer }
    ]; };
    NgBuilderViewerComponent.propDecorators = {
        options: [{ type: Input }]
    };
    return NgBuilderViewerComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var MapValuesPipe = /** @class */ (function () {
    function MapValuesPipe() {
    }
    /**
     * @param {?} value
     * @param {?=} args
     * @return {?}
     */
    MapValuesPipe.prototype.transform = /**
     * @param {?} value
     * @param {?=} args
     * @return {?}
     */
    function (value, args) {
        /** @type {?} */
        var returnArray = [];
        /** @type {?} */
        var isTrue = !!value && (value instanceof Array || value instanceof Map);
        if (isTrue) {
            value.forEach(function (entryValue, entryKey) {
                returnArray.push({
                    key: entryKey,
                    value: entryValue
                });
            });
        }
        return returnArray;
    };
    MapValuesPipe.decorators = [
        { type: Pipe, args: [{
                    name: 'mapValues',
                    pure: true
                },] }
    ];
    return MapValuesPipe;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var PageSelectComponent = /** @class */ (function () {
    function PageSelectComponent(_ngSurveyStore, _pagesReducer, _optionAnswersReducer) {
        this._ngSurveyStore = _ngSurveyStore;
        this._pagesReducer = _pagesReducer;
        this._optionAnswersReducer = _optionAnswersReducer;
    }
    /**
     * @return {?}
     */
    PageSelectComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this.pagesSub = this._ngSurveyStore.pages.subscribe(function (res) { return _this.pages = res; });
    };
    /**
     * @return {?}
     */
    PageSelectComponent.prototype.ngOnDestroy = /**
     * @return {?}
     */
    function () {
        this.pagesSub.unsubscribe();
    };
    /**
     * @param {?} value
     * @return {?}
     */
    PageSelectComponent.prototype.handlePageNavNext = /**
     * @param {?} value
     * @return {?}
     */
    function (value) {
        console.log('value: ', value);
        if (this.isPage) {
            /** @type {?} */
            var pageFlow = new PageFlow();
            if (value === '') {
                pageFlow.nextPage = true;
                pageFlow.label = 'pageFlow.goToNextPage';
            }
            else {
                pageFlow.nextPage = false;
                pageFlow.label = 'pageFlow.goToPage';
                pageFlow.pageId = value;
            }
            this._pagesReducer.pagesReducer({
                type: PagesActionTypes.UPDATE_PAGE_PAGE_FLOW_ACTION,
                payload: {
                    pageId: this.pageId,
                    pageFlow: pageFlow,
                },
            });
        }
        else {
            /** @type {?} */
            var pageFlow = new PageFlow();
            if (value === '') {
                pageFlow.nextPage = true;
                pageFlow.label = 'pageFlow.goToNextPage';
            }
            else {
                pageFlow.nextPage = false;
                pageFlow.label = 'pageFlow.goToPage';
                pageFlow.pageId = value;
            }
            this._optionAnswersReducer.optionAnswersReducer({
                type: OptionAnswersActionTypes.UPDATE_OPTION_ANSWERS_PAGE_FLOW,
                payload: {
                    elementId: this.elementId,
                    optionAnswerId: this.optionAnswerId,
                    pageFlow: pageFlow
                }
            });
        }
    };
    /**
     * @param {?} index
     * @param {?} item
     * @return {?}
     */
    PageSelectComponent.prototype.trackElement = /**
     * @param {?} index
     * @param {?} item
     * @return {?}
     */
    function (index, item) {
        return item ? item.key : null;
    };
    PageSelectComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ngs-page-select',
                    template: "<!-- Navigate to page selection -->\n<!-- TODO *ngIf=\"!optionAnswer?.isSaved && element.question.pageFlowModifier\"-->\n<div *ngIf=\"isPage || (!isPage && !isOptionAnswerSaved && questionPageFlowModifier)\" class=\"ml-md-3 ml-0 mt-md-0 mt-3 form-group mb-0\">\n  <select\n    id=\"pageNavNext\"\n    name=\"pageNavNext\"\n    class=\"form-control\"\n    [(ngModel)]=\"pageFlow.pageId\"\n    (ngModelChange)=\"handlePageNavNext($event)\">\n    <option value=\"\" selected>Continue to next page</option>\n    <option\n      *ngFor=\"let item of pages | mapValues; trackBy: trackElement\"\n      [value]=\"item.value.id\"\n      [disabled]=\"item.value.id === pageId\"\n    >\n      <span id=\"page-orderNo\" *ngIf=\"item.value.orderNo\">Go to page {{item.value.orderNo}}</span>\n      <span id=\"page-title\" *ngIf=\"item.value.title\">| {{item.value.title}}</span>\n    </option>\n  </select>\n</div>\n<!-- #/Navigate to page selection -->\n",
                    styles: [""]
                }] }
    ];
    /** @nocollapse */
    PageSelectComponent.ctorParameters = function () { return [
        { type: NgSurveyStore },
        { type: PagesReducer },
        { type: OptionAnswersReducer }
    ]; };
    PageSelectComponent.propDecorators = {
        isPage: [{ type: Input }],
        surveyId: [{ type: Input }],
        pageId: [{ type: Input }],
        pageFlow: [{ type: Input }],
        elementId: [{ type: Input }],
        optionAnswerId: [{ type: Input }],
        isOptionAnswerSaved: [{ type: Input }],
        questionPageFlowModifier: [{ type: Input }]
    };
    return PageSelectComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var LoaderComponent = /** @class */ (function () {
    function LoaderComponent() {
        this.isInherit = false;
    }
    /**
     * @return {?}
     */
    LoaderComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
    };
    LoaderComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ngs-loader',
                    template: "<div class=\"container-loader\" [ngClass]=\"isInherit ? 'container-loader-inherit' : 'container-loader'\">\n  <div class=\"ball ball-one\"></div>\n  <div class=\"ball ball-two\"></div>\n  <div class=\"ball ball-three\"></div>\n  <div class=\"ball ball-four\"></div>\n  <div class=\"shadow shadow-one\"></div>\n  <div class=\"shadow shadow-two\"></div>\n  <div class=\"shadow shadow-three\"></div>\n  <div class=\"shadow shadow-four\"></div>\n</div>\n",
                    styles: [".container-loader{position:absolute;height:50px;width:135px;top:0;right:0;bottom:0;left:0;margin:auto;text-align:center}.container-loader-inherit{position:inherit;height:75px;width:135px;top:0;right:0;bottom:0;left:0;margin:auto;text-align:center;padding-top:35px}div div.ball{width:20px;position:relative;display:inline-block;margin:5px;height:20px;border-radius:50%;z-index:999}.ball-one{background-color:#ffce64;-webkit-animation:.5s infinite alternate jump;animation:.5s infinite alternate jump}.ball-two{background-color:#4bb3ef;-webkit-animation:.5s .15s infinite alternate jump;animation:.5s .15s infinite alternate jump}.ball-three{background-color:#63dd79;-webkit-animation:.5s .25s infinite alternate jump;animation:.5s .25s infinite alternate jump}.ball-four{background-color:#fd6c6c;-webkit-animation:.5s .35s infinite alternate jump;animation:.5s .35s infinite alternate jump}.shadow{position:relative;opacity:.1;bottom:20px;width:20px;height:5px;border-radius:50%;background-color:#262626;display:inline-block;margin:5px}.shadow-one{-webkit-animation:.5s infinite alternate shrink;animation:.5s infinite alternate shrink}.shadow-two{-webkit-animation:.5s .15s infinite alternate shrink;animation:.5s .15s infinite alternate shrink}.shadow-three{-webkit-animation:.5s .25s infinite alternate shrink;animation:.5s .25s infinite alternate shrink}.shadow-four{-webkit-animation:.5s .35s infinite alternate shrink;animation:.5s .35s infinite alternate shrink}@-webkit-keyframes jump{0%{-webkit-transform:scaleY(.8);transform:scaleY(.8)}100%{-webkit-transform:translateY(-40px);transform:translateY(-40px)}}@keyframes jump{0%{-webkit-transform:scaleY(.8);transform:scaleY(.8)}100%{-webkit-transform:translateY(-40px);transform:translateY(-40px)}}@-webkit-keyframes shrink{100%{-webkit-transform:scaleX(.5);transform:scaleX(.5);opacity:.01}}@keyframes shrink{100%{-webkit-transform:scaleX(.5);transform:scaleX(.5);opacity:.01}}"]
                }] }
    ];
    /** @nocollapse */
    LoaderComponent.ctorParameters = function () { return []; };
    LoaderComponent.propDecorators = {
        isInherit: [{ type: Input }]
    };
    return LoaderComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var SharedCommonModule = /** @class */ (function () {
    function SharedCommonModule() {
    }
    SharedCommonModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        CommonModule,
                        FormsModule,
                    ],
                    declarations: [
                        MapValuesPipe,
                        PageSelectComponent,
                        LoaderComponent,
                    ],
                    exports: [
                        MapValuesPipe,
                        PageSelectComponent,
                        LoaderComponent,
                    ],
                },] }
    ];
    return SharedCommonModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ShortTextComponent = /** @class */ (function () {
    function ShortTextComponent(_elementsReducer) {
        this._elementsReducer = _elementsReducer;
    }
    /**
     * @return {?}
     */
    ShortTextComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this.isView = this.data.isView;
        if (this.isView) {
            setTimeout(function () {
                _this.onShortTextChange();
            }, 300);
        }
    };
    /**
     * @return {?}
     */
    ShortTextComponent.prototype.ngOnDestroy = /**
     * @return {?}
     */
    function () {
        if (this.isView) {
            this.shortTextInputSub.unsubscribe();
        }
    };
    /**
     * @return {?}
     */
    ShortTextComponent.prototype.onShortTextChange = /**
     * @return {?}
     */
    function () {
        var _this = this;
        /** @type {?} */
        var $shortTextInput = document.getElementById("short-text-input-" + this.data.element.id);
        this.shortTextInputSub = fromEvent($shortTextInput, 'input').pipe(map(function (event) { return event.target.value; }), distinctUntilChanged(), debounceTime(1000)).subscribe(function (answer) {
            _this._elementsReducer.elementsReducer({
                type: ElementsActionTypes.QUESTION_UPDATE_ANSWER_ACTION,
                payload: {
                    pageId: _this.data.element.pageId,
                    elementId: _this.data.element.id,
                    answer: answer,
                    pageFlowModifier: _this.data.element.question.pageFlowModifier,
                    pageFlow: _this.data.element.pageFlow,
                }
            });
        });
    };
    ShortTextComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ngs-short-text',
                    template: "<h4>{{data.title}}</h4>\n<form>\n  <div class=\"form-group\">\n    <input\n      type=\"text\"\n      [id]=\"'short-text-input-' + data.element.id\"\n      class=\"form-control\"\n      id=\"short-text-question\"\n      placeholder=\"Short answer text\"\n      name=\"shortText\"\n      [ngModel]=\"data?.element.question.answer\"\n      [disabled]=\"!isView\">\n  </div>\n</form>\n",
                    styles: [""]
                }] }
    ];
    /** @nocollapse */
    ShortTextComponent.ctorParameters = function () { return [
        { type: ElementsReducer }
    ]; };
    ShortTextComponent.propDecorators = {
        data: [{ type: Input }]
    };
    return ShortTextComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var LongTextComponent = /** @class */ (function () {
    function LongTextComponent(_elementsReducer) {
        this._elementsReducer = _elementsReducer;
    }
    /**
     * @return {?}
     */
    LongTextComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this.isView = this.data.isView;
        if (this.isView) {
            setTimeout(function () {
                _this.onLongTextChange();
            }, 300);
        }
    };
    /**
     * @return {?}
     */
    LongTextComponent.prototype.ngOnDestroy = /**
     * @return {?}
     */
    function () {
        if (this.isView) {
            this.longTextInputSub.unsubscribe();
        }
    };
    /**
     * @return {?}
     */
    LongTextComponent.prototype.onLongTextChange = /**
     * @return {?}
     */
    function () {
        var _this = this;
        /** @type {?} */
        var $longTextInput = document.getElementById("long-text-input-" + this.data.element.id);
        this.longTextInputSub = fromEvent($longTextInput, 'input').pipe(map(function (event) { return event.target.value; }), distinctUntilChanged(), debounceTime(1000)).subscribe(function (answer) {
            _this._elementsReducer.elementsReducer({
                type: ElementsActionTypes.QUESTION_UPDATE_ANSWER_ACTION,
                payload: {
                    pageId: _this.data.element.pageId,
                    elementId: _this.data.element.id,
                    answer: answer,
                    pageFlowModifier: _this.data.element.question.pageFlowModifier,
                    pageFlow: _this.data.element.pageFlow,
                }
            });
        });
    };
    LongTextComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ngs-long-text',
                    template: "<h4>{{data.title}}</h4>\n<form>\n  <div class=\"form-group\">\n    <input\n      type=\"text\"\n      [id]=\"'long-text-input-' + data.element.id\"\n      class=\"form-control\"\n      placeholder=\"Long answer text\"\n      name=\"longText\"\n      [ngModel]=\"data?.element.question.answer\"\n      [disabled]=\"!isView\"\n    >\n  </div>\n</form>\n",
                    styles: [""]
                }] }
    ];
    /** @nocollapse */
    LongTextComponent.ctorParameters = function () { return [
        { type: ElementsReducer }
    ]; };
    LongTextComponent.propDecorators = {
        data: [{ type: Input }]
    };
    return LongTextComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var QuestionBuilderDirective = /** @class */ (function () {
    function QuestionBuilderDirective(viewContainerRef) {
        this.viewContainerRef = viewContainerRef;
    }
    QuestionBuilderDirective.decorators = [
        { type: Directive, args: [{
                    selector: '[sbQuestionBuilder]'
                },] }
    ];
    /** @nocollapse */
    QuestionBuilderDirective.ctorParameters = function () { return [
        { type: ViewContainerRef }
    ]; };
    return QuestionBuilderDirective;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var QuestionItemComponent = /** @class */ (function () {
    function QuestionItemComponent(component, data) {
        this.component = component;
        this.data = data;
    }
    return QuestionItemComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var DateComponent = /** @class */ (function () {
    function DateComponent(_elementsReducer) {
        this._elementsReducer = _elementsReducer;
    }
    /**
     * @return {?}
     */
    DateComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this.isView = this.data.isView;
        if (this.isView) {
            setTimeout(function () {
                _this.onDateChange();
            }, 300);
        }
    };
    /**
     * @return {?}
     */
    DateComponent.prototype.ngOnDestroy = /**
     * @return {?}
     */
    function () {
        if (this.isView) {
            this.dateTextInputSub.unsubscribe();
        }
    };
    /**
     * @return {?}
     */
    DateComponent.prototype.onDateChange = /**
     * @return {?}
     */
    function () {
        var _this = this;
        /** @type {?} */
        var $dateInput = document.getElementById("date-input-" + this.data.element.id);
        this.dateTextInputSub = fromEvent($dateInput, 'input').pipe(map(function (event) { return event.target.value; }), distinctUntilChanged(), debounceTime(1000)).subscribe(function (answer) {
            _this._elementsReducer.elementsReducer({
                type: ElementsActionTypes.QUESTION_UPDATE_ANSWER_ACTION,
                payload: {
                    pageId: _this.data.element.pageId,
                    elementId: _this.data.element.id,
                    answer: answer,
                    pageFlowModifier: _this.data.element.question.pageFlowModifier,
                    pageFlow: _this.data.element.pageFlow,
                }
            });
        });
    };
    DateComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ngs-date',
                    template: "<h4>{{data.title}}</h4>\n<form>\n  <div class=\"form-group\">\n    <input\n      type=\"date\"\n      [id]=\"'date-input-' + data.element.id\"\n      name=\"date\"\n      class=\"form-control\"\n      [ngModel]=\"data?.element.question.answer\"\n      [disabled]=\"!isView\">\n  </div>\n</form>\n",
                    styles: [""]
                }] }
    ];
    /** @nocollapse */
    DateComponent.ctorParameters = function () { return [
        { type: ElementsReducer }
    ]; };
    DateComponent.propDecorators = {
        data: [{ type: Input }]
    };
    return DateComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var RangeComponent = /** @class */ (function () {
    function RangeComponent(_elementsReducer) {
        this._elementsReducer = _elementsReducer;
    }
    /**
     * @return {?}
     */
    RangeComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this.element = this.data.element;
        this.pageId = this.data.element.pageId;
        this.isView = this.data.isView;
        if (!this.isView) {
            setTimeout(function () {
                _this.onMinChange();
                _this.onMaxChange();
            }, 300);
        }
        else {
            setTimeout(function () {
                _this.onRangeChange();
            }, 300);
        }
    };
    /**
     * @return {?}
     */
    RangeComponent.prototype.ngOnDestroy = /**
     * @return {?}
     */
    function () {
        if (this.isView) {
            this.rangeInputSub.unsubscribe();
        }
    };
    /**
     * @return {?}
     */
    RangeComponent.prototype.onMinChange = /**
     * @return {?}
     */
    function () {
        var _this = this;
        /** @type {?} */
        var $min = document.getElementById("min-range-" + this.element.id);
        this.minSub = fromEvent($min, 'input').pipe(map$1(function (event) { return event.target.value; }), distinctUntilChanged(), debounceTime(1000)).subscribe(function (min) { return _this._elementsReducer.elementsReducer({
            type: ElementsActionTypes.QUESTION_UPDATE_MIN_ACTION,
            payload: {
                pageId: _this.pageId,
                elementId: _this.element.id,
                min: min
            }
        }); });
    };
    /**
     * @return {?}
     */
    RangeComponent.prototype.onMaxChange = /**
     * @return {?}
     */
    function () {
        var _this = this;
        /** @type {?} */
        var $max = document.getElementById("max-range-" + this.element.id);
        this.maxSub = fromEvent($max, 'input').pipe(map$1(function (event) { return event.target.value; }), distinctUntilChanged(), debounceTime(1000)).subscribe(function (max) { return _this._elementsReducer.elementsReducer({
            type: ElementsActionTypes.QUESTION_UPDATE_MAX_ACTION,
            payload: {
                pageId: _this.pageId,
                elementId: _this.element.id,
                max: max
            }
        }); });
    };
    /**
     * @return {?}
     */
    RangeComponent.prototype.onRangeChange = /**
     * @return {?}
     */
    function () {
        var _this = this;
        /** @type {?} */
        var $rangeInput = document.getElementById("range-input-" + this.element.id);
        this.rangeInputSub = fromEvent($rangeInput, 'input').pipe(map$1(function (event) { return event.target.value; }), distinctUntilChanged(), debounceTime(1000)).subscribe(function (answer) {
            _this._elementsReducer.elementsReducer({
                type: ElementsActionTypes.QUESTION_UPDATE_ANSWER_ACTION,
                payload: {
                    pageId: _this.element.pageId,
                    elementId: _this.element.id,
                    answer: answer,
                    pageFlowModifier: _this.data.element.question.pageFlowModifier,
                    pageFlow: _this.data.element.pageFlow,
                }
            });
        });
    };
    RangeComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ngs-range',
                    template: "<div *ngIf=\"!isView\" class=\"row mt-5\">\n  <h4>{{data.title}}</h4>\n  <div class=\"col-8 offset-2\">\n    <form class=\"form-inline\">\n      <div class=\"form-group mb-2\">\n        <label class=\"mr-3 text-2x\">Range from </label>\n        <input type=\"number\" name=\"min\" class=\"form-control\" [id]=\"'min-range-' + element.id\" [ngModel]=\"element.question.min\" placeholder=\"Min Value\">\n      </div>\n      <div class=\"form-group mx-sm-3 mb-2\">\n        <label class=\"mr-3 text-2x\">to</label>\n        <input type=\"number\" name=\"max\" class=\"form-control\" [id]=\"'max-range-' + element.id\" [ngModel]=\"element.question.max\" placeholder=\"Max Value\">\n      </div>\n    </form>\n\n    <!-- Range Input -->\n    <div class=\"form-group mt-5\">\n      <input type=\"range\" class=\"form-control-range\" id=\"formControlRange\" disabled>\n    </div>\n    <!-- #/Range Input -->\n\n  </div>\n</div>\n\n<!-- Range Input -->\n<div class=\"form-group\" *ngIf=\"isView\">\n  <label [for]=\"'range' + element.id\"><h2>{{element.question.text}}</h2></label>\n  <span class=\"d-flex flex-row justify-content-between\">\n    <input\n      type=\"range\"\n      [id]=\"'range-input-' + element.id\"\n      class=\"custom-range\"\n      name=\"range-input\"\n      [(ngModel)]=\"data?.element.question.answer\"\n      [min]=\"element?.question.min\"\n      [max]=\"element?.question.max\"\n    >\n    <h1 class=\"ml-5\">{{data?.element.question.answer}}</h1>\n  </span>\n</div>\n<!-- #/Range Input -->\n",
                    styles: [""]
                }] }
    ];
    /** @nocollapse */
    RangeComponent.ctorParameters = function () { return [
        { type: ElementsReducer }
    ]; };
    RangeComponent.propDecorators = {
        data: [{ type: Input }]
    };
    return RangeComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var RadioCheckboxSelectComponent = /** @class */ (function () {
    function RadioCheckboxSelectComponent(_ngSurveyStore, _elementsReducer, _optionAnswersReducer) {
        this._ngSurveyStore = _ngSurveyStore;
        this._elementsReducer = _elementsReducer;
        this._optionAnswersReducer = _optionAnswersReducer;
        this.isPageNavChecked = false;
        this.isSaved = false;
        this.isNewOption = false;
    }
    /**
     * @return {?}
     */
    RadioCheckboxSelectComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this.pageId = this.data.element.pageId;
        this.surveyId = this.data.surveyId;
        this.elementSub = this._ngSurveyStore.elements.subscribe(function (res) {
            if (res && _this.pageId) {
                /** @type {?} */
                var elements = res.get(_this.pageId);
                if (elements) {
                    _this.element = elements.get(_this.data.element.id);
                }
            }
        });
        this.optionAnswersSub = this._ngSurveyStore.optionAnswers.subscribe(function (res) {
            _this.optionAnswers = res.get(_this.data.element.id);
            if (_this.optionAnswers) {
                _this.optionAnswersSize = _this.optionAnswers.size;
            }
        });
        setTimeout(function () {
            _this.onSaveQuestionClick();
        }, 300);
    };
    /**
     * @return {?}
     */
    RadioCheckboxSelectComponent.prototype.ngOnDestroy = /**
     * @return {?}
     */
    function () {
        this.elementSub.unsubscribe();
        this.optionAnswersSub.unsubscribe();
    };
    /**
     * @param {?} e
     * @return {?}
     */
    RadioCheckboxSelectComponent.prototype.togglePageNavChecked = /**
     * @param {?} e
     * @return {?}
     */
    function (e) {
        this.isPageNavChecked = e.target.checked;
        this._elementsReducer.elementsReducer({
            type: ElementsActionTypes.QUESTION_UPDATE_PAGE_FLOW_MODIFIER_ACTION,
            payload: {
                pageId: this.pageId,
                elementId: this.element.id,
                pageFlowModifier: this.isPageNavChecked
            }
        });
    };
    /**
     * @return {?}
     */
    RadioCheckboxSelectComponent.prototype.addOptionInput = /**
     * @return {?}
     */
    function () {
        if (!this.element.isSaved) {
            this._optionAnswersReducer.optionAnswersReducer({
                type: OptionAnswersActionTypes.ADD_OPTION_ANSWERS_ACTION,
                payload: {
                    elementId: this.element.id
                }
            });
            this.isNewOption = true;
        }
    };
    /**
     * @param {?} event
     * @return {?}
     */
    RadioCheckboxSelectComponent.prototype.drop = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        this._optionAnswersReducer.optionAnswersReducer({
            type: OptionAnswersActionTypes.DRAG_OPTION_ANSWERS_ACTION,
            payload: {
                elementId: this.element.id,
                startIndex: event.previousIndex,
                endIndex: event.currentIndex,
            }
        });
    };
    /**
     * @return {?}
     */
    RadioCheckboxSelectComponent.prototype.onSaveQuestionClick = /**
     * @return {?}
     */
    function () {
        var _this = this;
        /** @type {?} */
        var $saveQuestionButton = document.getElementById("save-question-button-" + this.element.id);
        if ($saveQuestionButton) {
            fromEvent($saveQuestionButton, 'click').pipe(map(function (event) { return event; })).subscribe(function (res) {
                if (res) {
                    _this.isSaved = true;
                    _this.onEditQuestionClick();
                }
            });
        }
    };
    /**
     * @return {?}
     */
    RadioCheckboxSelectComponent.prototype.onEditQuestionClick = /**
     * @return {?}
     */
    function () {
        var _this = this;
        /** @type {?} */
        var $editQuestionButton = document.getElementById("edit-question-button-" + this.element.id);
        fromEvent($editQuestionButton, 'click').pipe(map(function (event) { return event; })).subscribe(function (res) {
            if (res) {
                _this.isSaved = false;
                _this.onSaveQuestionClick();
            }
        });
    };
    /**
     * @param {?} index
     * @param {?} item
     * @return {?}
     */
    RadioCheckboxSelectComponent.prototype.trackElement = /**
     * @param {?} index
     * @param {?} item
     * @return {?}
     */
    function (index, item) {
        return item ? item.key : null;
    };
    RadioCheckboxSelectComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ngs-radio-checkbox-select',
                    template: "<div class=\"card\">\n  <div class=\"card-body\">\n    <h4>{{data.title}}</h4>\n\n    <div class=\"row\">\n      <div class=\"col-md-9 offset-md-2 col-12\">\n        <form>\n          <div class=\"form-group form-check\" *ngIf=\"element?.showPageFlowToggle && (data.type === 'radio' || data.type === 'select')\">\n            <input\n              id=\"pageNavCheckbox\"\n              type=\"checkbox\"\n              name=\"isPageNavChecked\"\n              class=\"form-check-input\"\n              [disabled]=\"element?.isSaved\"\n              [(ngModel)]=\"element?.question.pageFlowModifier\"\n              (change)=\"togglePageNavChecked($event)\"\n            >\n            <label class=\"form-check-label\" for=\"pageNavCheckbox\">Go to page based on answer</label>\n          </div>\n          <div cdkDropList [cdkDropListData]=\"optionAnswers\" [cdkDropListDisabled]=\"element?.isSaved\" #optionAnswers%=\"cdkDropList\" (cdkDropListDropped)=\"drop($event)\">\n            <div *ngFor=\"let item of optionAnswers | mapValues; trackBy: trackElement\" cdkDrag>\n              <!-- Drag and Drop Background Place Holder -->\n              <div class=\"drag-drop-placeholder-question-option\" *cdkDragPlaceholder></div>\n              <!-- #/Drag and Drop Background Place Holder -->\n                <div class=\"d-flex flex-md-row flex-column align-items-md-center align-items-start option-min-height mb-md-0 mb-3\">\n                  <!-- Move Option Button -->\n                  <span *ngIf=\"!element?.isSaved\" class=\"mr-3 mb-3\">\n                    <button type=\"button\" class=\"btn btn-outline-secondary\" tooltip=\"Drag and Drop Option\" cdkDragHandle>\n                      <i class=\"fas fa-arrows-alt\"></i>\n                    </button>\n                  </span>\n                  <!-- #/Move Option Button -->\n\n                  <!-- Option Template -->\n                  <ngs-option-template\n                    class=\"w-100\"\n                    [optionAnswersSize]=\"optionAnswersSize\"\n                    [optionAnswer]=\"item.value\"\n                    [element]=\"element\"\n                    [isPageNavChecked]=\"isPageNavChecked\"\n                    [surveyId]=\"surveyId\"\n                    [isNewOption]=\"isNewOption\"\n                  ></ngs-option-template>\n                  <!-- #/Option Template -->\n                </div>\n            </div>\n          </div>\n          <!-- Add Option Input -->\n          <span *ngIf=\"!element?.isSaved\" (click)=\"addOptionInput()\">\n            <div class=\"row\">\n              <div class=\"col-md-5 col-12\">\n                <input\n                  class=\"form-control ml-md-5 ml-0\"\n                  name=\"radioTemplate\"\n                  type=\"text\"\n                  placeholder=\"Click to add options\"\n                  disabled\n                >\n              </div>\n            </div>\n          </span>\n          <!-- #/Add Option Input -->\n        </form>\n      </div>\n    </div>\n  </div>\n</div>\n",
                    styles: [".cdk-drop-list-dragging .cdk-drag{transition:transform 250ms cubic-bezier(0,0,.2,1);transition:transform 250ms cubic-bezier(0,0,.2,1),-webkit-transform 250ms cubic-bezier(0,0,.2,1)}.cdk-drag-animating{transition:transform .3s cubic-bezier(0,0,.2,1);transition:transform .3s cubic-bezier(0,0,.2,1),-webkit-transform .3s cubic-bezier(0,0,.2,1)}.cdk-drag-preview{box-sizing:border-box;border-radius:4px;box-shadow:0 5px 5px -3px rgba(0,0,0,.2),0 8px 10px 1px rgba(0,0,0,.14),0 3px 14px 2px rgba(0,0,0,.12)}.drag-drop-placeholder-question{background:rgba(0,0,0,.03);border:1px solid rgba(0,0,0,.125);border-radius:10px;min-height:400px;transition:transform 250ms cubic-bezier(0,0,.2,1);transition:transform 250ms cubic-bezier(0,0,.2,1),-webkit-transform 250ms cubic-bezier(0,0,.2,1)}.option-min-height{min-height:65px}.drag-drop-placeholder-question-option{background:rgba(0,0,0,.03);border:1px solid rgba(0,0,0,.125);border-radius:10px;min-height:65px;transition:transform 250ms cubic-bezier(0,0,.2,1);transition:transform 250ms cubic-bezier(0,0,.2,1),-webkit-transform 250ms cubic-bezier(0,0,.2,1)}"]
                }] }
    ];
    /** @nocollapse */
    RadioCheckboxSelectComponent.ctorParameters = function () { return [
        { type: NgSurveyStore },
        { type: ElementsReducer },
        { type: OptionAnswersReducer }
    ]; };
    RadioCheckboxSelectComponent.propDecorators = {
        data: [{ type: Input }]
    };
    return RadioCheckboxSelectComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var SelectComponent = /** @class */ (function () {
    function SelectComponent(_ngSurveyStore, _elementsReducer) {
        this._ngSurveyStore = _ngSurveyStore;
        this._elementsReducer = _elementsReducer;
    }
    /**
     * @return {?}
     */
    SelectComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this.optionAnswersSub = this._ngSurveyStore.optionAnswers.subscribe(function (res) {
            _this.optionAnswers = res.get(_this.data.element.id);
        });
    };
    /**
     * @return {?}
     */
    SelectComponent.prototype.ngOnDestroy = /**
     * @return {?}
     */
    function () {
        this.optionAnswersSub.unsubscribe();
    };
    /**
     * @param {?} answer
     * @param {?} pageFlow
     * @return {?}
     */
    SelectComponent.prototype.handleSelect = /**
     * @param {?} answer
     * @param {?} pageFlow
     * @return {?}
     */
    function (answer, pageFlow) {
        this._elementsReducer.elementsReducer({
            type: ElementsActionTypes.QUESTION_UPDATE_ANSWER_ACTION,
            payload: {
                pageId: this.data.element.pageId,
                elementId: this.data.element.id,
                answer: answer,
                pageFlowModifier: this.data.element.question.pageFlowModifier,
                pageFlow: pageFlow,
            }
        });
    };
    /**
     * @param {?} index
     * @param {?} item
     * @return {?}
     */
    SelectComponent.prototype.trackElement = /**
     * @param {?} index
     * @param {?} item
     * @return {?}
     */
    function (index, item) {
        return item ? item.key : null;
    };
    SelectComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ngs-select',
                    template: "<form>\n  <div *ngIf=\"optionAnswers.size > 0\" class=\"form-group\">\n    <label for=\"select\">Example select</label>\n    <select\n      class=\"form-control\" id=\"select\"\n      name=\"select\"\n      [(ngModel)]=\"data?.element.question.answer\"\n      (ngModelChange)=\"handleSelect($event, item?.value.pageFlow)\"\n    >\n      <option disabled selected [value]=\"''\">Select</option>\n      <option\n        *ngFor=\"let item of optionAnswers | mapValues; trackBy:trackElement\"\n        [value]=\"item?.value.value\">\n        {{item?.value.value}}\n      </option>\n    </select>\n  </div>\n</form>\n",
                    styles: [""]
                }] }
    ];
    /** @nocollapse */
    SelectComponent.ctorParameters = function () { return [
        { type: NgSurveyStore },
        { type: ElementsReducer }
    ]; };
    SelectComponent.propDecorators = {
        data: [{ type: Input }]
    };
    return SelectComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var CheckboxComponent = /** @class */ (function () {
    function CheckboxComponent(_ngSurveyStore, _elementsReducer, formBuilder) {
        this._ngSurveyStore = _ngSurveyStore;
        this._elementsReducer = _elementsReducer;
        this.formBuilder = formBuilder;
    }
    /**
     * @return {?}
     */
    CheckboxComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this.optionAnswersSub = this._ngSurveyStore.optionAnswers.subscribe(function (res) {
            _this.optionAnswers = res.get(_this.data.element.id);
        });
        /** @type {?} */
        var answer = this.data.element.question.answer;
        /** @type {?} */
        var controls = Array.from(this.optionAnswers).map(function (c) {
            if (answer.indexOf(c[1].value) >= 0) {
                return new FormControl(true);
            }
            else {
                return new FormControl(false);
            }
        });
        this.form = this.formBuilder.group({
            optionAnswers: new FormArray(controls, this.minSelectedCheckboxes(1))
        });
    };
    /**
     * @return {?}
     */
    CheckboxComponent.prototype.ngOnDestroy = /**
     * @return {?}
     */
    function () {
        this.optionAnswersSub.unsubscribe();
    };
    /**
     * @private
     * @param {?=} min
     * @return {?}
     */
    CheckboxComponent.prototype.minSelectedCheckboxes = /**
     * @private
     * @param {?=} min
     * @return {?}
     */
    function (min) {
        if (min === void 0) { min = 1; }
        /** @type {?} */
        var validator = function (formArray) {
            /** @type {?} */
            var totalSelected = formArray.controls
                .map(function (control) { return control.value; })
                .reduce(function (prev, next) { return next ? prev + next : prev; }, 0);
            return totalSelected >= min ? null : { required: true };
        };
        return validator;
    };
    /**
     * @param {?} pageFlow
     * @return {?}
     */
    CheckboxComponent.prototype.handleChange = /**
     * @param {?} pageFlow
     * @return {?}
     */
    function (pageFlow) {
        var _this = this;
        /** @type {?} */
        var selectedOrderIds = this.form.value.optionAnswers
            .map(function (v, i) { return v ? Array.from(_this.optionAnswers)[i][1].value : null; })
            .filter(function (v) { return v !== null; });
        /** @type {?} */
        var answer = selectedOrderIds.toString();
        this._elementsReducer.elementsReducer({
            type: ElementsActionTypes.QUESTION_UPDATE_ANSWER_ACTION,
            payload: {
                pageId: this.data.element.pageId,
                elementId: this.data.element.id,
                answer: answer,
                pageFlowModifier: this.data.element.question.pageFlowModifier,
                pageFlow: pageFlow,
            }
        });
    };
    /**
     * @param {?} index
     * @param {?} item
     * @return {?}
     */
    CheckboxComponent.prototype.trackElement = /**
     * @param {?} index
     * @param {?} item
     * @return {?}
     */
    function (index, item) {
        return item ? item.key : null;
    };
    CheckboxComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ngs-checkbox',
                    template: "<h4>{{data.title}}</h4>\n\n<form [formGroup]=\"form\">\n  <label\n    class=\"container\"\n    formArrayName=\"optionAnswers\"\n    *ngFor=\"let item of optionAnswers | mapValues; trackBy: trackElement; let i = index\">\n    <span>{{item?.value.value}}</span>\n    <input type=\"checkbox\" [formControlName]=\"i\" (change)=\"handleChange(item?.value.pageFlow)\">\n    <span class=\"checkmark\"></span>\n  </label>\n\n  <div *ngIf=\"!form.valid\" class=\"text-red\">At least one checkbox must be selected</div>\n  <br>\n</form>\n\n",
                    styles: [".container{display:block;position:relative;padding-left:35px;margin-bottom:12px;cursor:pointer;font-size:22px;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none}.container input{position:absolute;opacity:0;cursor:pointer;height:0;width:0}.checkmark{position:absolute;bottom:0;left:0;height:25px;width:25px;background-color:#eee}.container:hover input~.checkmark{background-color:#ccc}.container input:checked~.checkmark{background-color:#2196f3}.checkmark:after{content:\"\";position:absolute;display:none}.container input:checked~.checkmark:after{display:block}.container .checkmark:after{left:9px;top:5px;width:5px;height:10px;border:solid #fff;border-width:0 3px 3px 0;-webkit-transform:rotate(45deg);transform:rotate(45deg)}"]
                }] }
    ];
    /** @nocollapse */
    CheckboxComponent.ctorParameters = function () { return [
        { type: NgSurveyStore },
        { type: ElementsReducer },
        { type: FormBuilder }
    ]; };
    CheckboxComponent.propDecorators = {
        data: [{ type: Input }]
    };
    return CheckboxComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var RadioComponent = /** @class */ (function () {
    function RadioComponent(_ngSurveyStore, _elementsReducer) {
        this._ngSurveyStore = _ngSurveyStore;
        this._elementsReducer = _elementsReducer;
    }
    /**
     * @return {?}
     */
    RadioComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this.optionAnswersSub = this._ngSurveyStore.optionAnswers.subscribe(function (res) {
            _this.optionAnswers = res.get(_this.data.element.id);
        });
    };
    /**
     * @return {?}
     */
    RadioComponent.prototype.ngOnDestroy = /**
     * @return {?}
     */
    function () {
        this.optionAnswersSub.unsubscribe();
    };
    /**
     * @param {?} answer
     * @param {?} pageFlow
     * @return {?}
     */
    RadioComponent.prototype.handleChange = /**
     * @param {?} answer
     * @param {?} pageFlow
     * @return {?}
     */
    function (answer, pageFlow) {
        this._elementsReducer.elementsReducer({
            type: ElementsActionTypes.QUESTION_UPDATE_ANSWER_ACTION,
            payload: {
                pageId: this.data.element.pageId,
                elementId: this.data.element.id,
                answer: answer,
                pageFlowModifier: this.data.element.question.pageFlowModifier,
                pageFlow: pageFlow,
            }
        });
    };
    /**
     * @param {?} index
     * @param {?} item
     * @return {?}
     */
    RadioComponent.prototype.trackElement = /**
     * @param {?} index
     * @param {?} item
     * @return {?}
     */
    function (index, item) {
        return item ? item.key : null;
    };
    RadioComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ngs-radio',
                    template: "<h4>{{data.title}}</h4>\n<div class=\"custom-control custom-radio\" *ngFor=\"let item of optionAnswers | mapValues; trackBy: trackElement;\">\n  <input\n    type=\"radio\"\n    [id]=\"'radio' + item?.key\"\n    name=\"customRadio\"\n    class=\"custom-control-input\"\n    [value]=\"item?.value.value\"\n    [(ngModel)]=\"data?.element.question.answer\"\n    (ngModelChange)=\"handleChange($event, item?.value.pageFlow)\"\n  >\n  <label class=\"custom-control-label\" [for]=\"'radio' + item?.key\">{{item?.value.value}}</label>\n</div>\n",
                    styles: [""]
                }] }
    ];
    /** @nocollapse */
    RadioComponent.ctorParameters = function () { return [
        { type: NgSurveyStore },
        { type: ElementsReducer }
    ]; };
    RadioComponent.propDecorators = {
        data: [{ type: Input }]
    };
    return RadioComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var QuestionBuilderService = /** @class */ (function () {
    function QuestionBuilderService() {
    }
    /**
     * @param {?} type
     * @param {?} element
     * @param {?} surveyId
     * @param {?} isView
     * @return {?}
     */
    QuestionBuilderService.prototype.getElementTypeComponent = /**
     * @param {?} type
     * @param {?} element
     * @param {?} surveyId
     * @param {?} isView
     * @return {?}
     */
    function (type, element, surveyId, isView) {
        /** @type {?} */
        var title = '';
        /** @type {?} */
        var component;
        if (type === 'shortText') {
            component = ShortTextComponent;
            title = isView ? element.question.text : 'Short Text Question Template';
        }
        else if (type === 'longText') {
            component = LongTextComponent;
            title = isView ? element.question.text : 'Long Text Question Template';
        }
        else if (type === 'radio') {
            component = isView ? RadioComponent : RadioCheckboxSelectComponent;
            title = isView ? element.question.text : 'Radio Question Template';
        }
        else if (type === 'checkboxes') {
            component = isView ? CheckboxComponent : RadioCheckboxSelectComponent;
            title = isView ? element.question.text : 'Checkbox Question Template';
        }
        else if (type === 'select') {
            component = isView ? SelectComponent : RadioCheckboxSelectComponent;
            title = isView ? element.question.text : 'Select Question Template';
        }
        else if (type === 'date') {
            component = DateComponent;
            title = isView ? element.question.text : 'Date Question Template';
        }
        else if (type === 'range') {
            component = RangeComponent;
            title = isView ? element.question.text : 'Range Question Template';
        }
        return new QuestionItemComponent(component, {
            title: title,
            type: type,
            element: element,
            surveyId: surveyId,
            isView: isView,
        });
    };
    QuestionBuilderService.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    QuestionBuilderService.ctorParameters = function () { return []; };
    return QuestionBuilderService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var QuestionBuilderComponent = /** @class */ (function () {
    function QuestionBuilderComponent(componentFactoryResolver, questionBuilder$) {
        this.componentFactoryResolver = componentFactoryResolver;
        this.questionBuilder$ = questionBuilder$;
        this.hasQuestion = false;
        // initialize a private variable _questions as a BehaviorSubject
        this._questionType = new BehaviorSubject(null);
    }
    Object.defineProperty(QuestionBuilderComponent.prototype, "questionType", {
        get: /**
         * @return {?}
         */
        function () {
            // get the latest value from _questions BehaviorSubject
            return this._questionType.getValue();
        },
        // change questions to use getter and setter
        set: 
        // change questions to use getter and setter
        /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            // set the latest value for _questions BehaviorSubject
            this._questionType.next(value);
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    QuestionBuilderComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this._questionType.subscribe(function (payload) {
            if (!!payload) {
                _this.hasQuestion = true;
                setTimeout(function () {
                    _this.question = _this.questionBuilder$.getElementTypeComponent(payload, _this.element, _this.surveyId, _this.isView);
                    _this.loadComponent();
                }, 300);
            }
            else {
                _this.hasQuestion = false;
            }
        });
    };
    /**
     * @return {?}
     */
    QuestionBuilderComponent.prototype.loadComponent = /**
     * @return {?}
     */
    function () {
        /** @type {?} */
        var questionItem = this.question;
        /** @type {?} */
        var componentFactory = this.componentFactoryResolver.resolveComponentFactory(questionItem.component);
        /** @type {?} */
        var viewContainerRef = this.questionBuilderHost.viewContainerRef;
        viewContainerRef.clear();
        /** @type {?} */
        var componentRef = viewContainerRef.createComponent(componentFactory);
        if (!!questionItem.data) {
            ((/** @type {?} */ (componentRef.instance))).data = questionItem.data;
        }
    };
    QuestionBuilderComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ngs-question-builder-component',
                    template: "\n    <div *ngIf=\"hasQuestion\">\n      <ng-template sbQuestionBuilder></ng-template>\n    </div>\n  "
                }] }
    ];
    /** @nocollapse */
    QuestionBuilderComponent.ctorParameters = function () { return [
        { type: ComponentFactoryResolver },
        { type: QuestionBuilderService }
    ]; };
    QuestionBuilderComponent.propDecorators = {
        element: [{ type: Input }],
        surveyId: [{ type: Input }],
        isView: [{ type: Input }],
        questionType: [{ type: Input }],
        questionBuilderHost: [{ type: ViewChild, args: [QuestionBuilderDirective,] }]
    };
    return QuestionBuilderComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var OptionTemplateComponent = /** @class */ (function () {
    function OptionTemplateComponent(_ngSurveyStore, _optionAnswersReducer) {
        this._ngSurveyStore = _ngSurveyStore;
        this._optionAnswersReducer = _optionAnswersReducer;
        this.isOptionActive = true;
    }
    /**
     * @return {?}
     */
    OptionTemplateComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        var _this = this;
        setTimeout(function () {
            _this.pagesSub = _this._ngSurveyStore.pages.subscribe(function (res) { return _this.pages = res; });
            if (_this.isNewOption) {
                /** @type {?} */
                var $optionTemplateInput = document.getElementById("optionTemplateInput-" + _this.optionAnswer.id);
                $optionTemplateInput.focus();
                _this.isNewOption = false;
            }
            _this.onOptionsValueChange();
        }, 300);
    };
    /**
     * @return {?}
     */
    OptionTemplateComponent.prototype.ngOnDestroy = /**
     * @return {?}
     */
    function () {
        if (this.pagesSub) {
            this.pagesSub.unsubscribe();
        }
    };
    /**
     * @param {?} e
     * @return {?}
     */
    OptionTemplateComponent.prototype.onFocus = /**
     * @param {?} e
     * @return {?}
     */
    function (e) {
        if (e.returnValue && this.optionAnswer.orderNo === this.optionAnswersSize) {
            this.isOptionActive = e.returnValue;
        }
    };
    /**
     * @return {?}
     */
    OptionTemplateComponent.prototype.removeOptionAnswer = /**
     * @return {?}
     */
    function () {
        this._optionAnswersReducer.optionAnswersReducer({
            type: OptionAnswersActionTypes.REMOVE_OPTION_ANSWERS_ACTION,
            payload: {
                elementId: this.element.id,
                optionAnswerId: this.optionAnswer.id
            }
        });
    };
    /**
     * @return {?}
     */
    OptionTemplateComponent.prototype.onOptionsValueChange = /**
     * @return {?}
     */
    function () {
        var _this = this;
        /** @type {?} */
        var $optionTemplateInput = document.getElementById("optionTemplateInput-" + this.optionAnswer.id);
        /** @type {?} */
        var optionTemplateInput$ = fromEvent($optionTemplateInput, 'input').pipe(map(function (event) { return event.target.value; }), distinctUntilChanged$1(), debounceTime$1(1000));
        optionTemplateInput$.subscribe(function (value) {
            _this._optionAnswersReducer.optionAnswersReducer({
                type: OptionAnswersActionTypes.ADD_OPTION_ANSWERS_VALUE_ACTION,
                payload: {
                    elementId: _this.element.id,
                    optionAnswerId: _this.optionAnswer.id,
                    value: value
                }
            });
        });
    };
    /**
     * @param {?} index
     * @param {?} item
     * @return {?}
     */
    OptionTemplateComponent.prototype.trackElement = /**
     * @param {?} index
     * @param {?} item
     * @return {?}
     */
    function (index, item) {
        return item ? item.key : null;
    };
    OptionTemplateComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ngs-option-template',
                    template: "<div class=\"form-group d-flex flex-md-row flex-column align-items-md-center align-items-start\">\n  <!-- Option Type Icon -->\n  <div class=\"d-md-block d-none\">\n    <label *ngIf=\"element.question.type === 'radio'\" [for]=\"'optionTemplateInput-' + optionAnswer.id\" class=\"mr-3 mb-0\"><i class=\"fas fa-dot-circle\"></i></label>\n    <label *ngIf=\"element.question.type === 'checkboxes'\" [for]=\"'optionTemplateInput-' + optionAnswer.id\" class=\"mr-3 mb-0\"><i class=\"fas fa-check-square\"></i></label>\n    <label *ngIf=\"element.question.type === 'select'\" [for]=\"'optionTemplateInput-' + optionAnswer.id\" class=\"mr-3 mb-0\"><i class=\"fas fa-chevron-circle-down\"></i></label>\n  </div>\n  <!-- #/Option Type Icon -->\n\n  <div class=\"d-flex flex-row\">\n    <!-- Option Input -->\n    <input\n      [id]=\"'optionTemplateInput-' + optionAnswer.id\"\n      class=\"form-control w-100\"\n      name=\"radioTemplate\"\n      type=\"text\"\n      placeholder=\"Click to add options\"\n      (focus)=\"onFocus($event)\"\n      [ngModel]=\"optionAnswer.value\"\n      [disabled]=\"optionAnswer?.isSaved\"\n    >\n    <!-- #/Option Input -->\n\n    <!-- Remove Option Button -->\n    <span *ngIf=\"!optionAnswer?.isSaved\" class=\"ml-3 mb-0\">\n      <button type=\"button\" class=\"btn btn-outline-primary\" tooltip=\"Remove Option\" (click)=\"removeOptionAnswer()\">\n        <i class=\"fas fa-times\"></i>\n      </button>\n    </span>\n    <!-- #/Remove Option Button -->\n  </div>\n\n  <!-- Navigate to page selection -->\n  <ngs-page-select\n    [isPage]=\"false\"\n    [surveyId]=\"surveyId\"\n    [elementId]=\"element?.id\"\n    [pageId]=\"element?.pageId\"\n    [pageFlow]=\"optionAnswer.pageFlow\"\n    [isOptionAnswerSaved]=\"optionAnswer?.isSaved\"\n    [optionAnswerId]=\"optionAnswer?.id\"\n    [questionPageFlowModifier]=\"element.question.pageFlowModifier\"\n  ></ngs-page-select>\n  <!-- #/Navigate to page selection -->\n</div>\n",
                    styles: [""]
                }] }
    ];
    /** @nocollapse */
    OptionTemplateComponent.ctorParameters = function () { return [
        { type: NgSurveyStore },
        { type: OptionAnswersReducer }
    ]; };
    OptionTemplateComponent.propDecorators = {
        optionAnswersSize: [{ type: Input }],
        optionAnswer: [{ type: Input }],
        element: [{ type: Input }],
        isPageNavChecked: [{ type: Input }],
        surveyId: [{ type: Input }],
        isNewOption: [{ type: Input }]
    };
    return OptionTemplateComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var PageBuilderContainerComponent = /** @class */ (function () {
    function PageBuilderContainerComponent(_ngSurveyStore, _pagesReducer, _elementsReducer) {
        this._ngSurveyStore = _ngSurveyStore;
        this._pagesReducer = _pagesReducer;
        this._elementsReducer = _elementsReducer;
        this.isSavedMap = new Map();
    }
    /**
     * @return {?}
     */
    PageBuilderContainerComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this.pageSizeSub = this._ngSurveyStore.pages.subscribe(function (res) {
            _this.pageSize = res.size;
        });
        this.elementsSub = this._ngSurveyStore.elements.subscribe(function (res) {
            _this.elements = res.get(_this.page.id);
            if (res) {
                _this.elementsSize = res.size;
                _this.setSavedMap();
            }
        });
    };
    /**
     * @param {?} changes
     * @return {?}
     */
    PageBuilderContainerComponent.prototype.ngOnChanges = /**
     * @param {?} changes
     * @return {?}
     */
    function (changes) {
    };
    /**
     * @return {?}
     */
    PageBuilderContainerComponent.prototype.ngOnDestroy = /**
     * @return {?}
     */
    function () {
        this.elementsSub.unsubscribe();
        this.pageSizeSub.unsubscribe();
    };
    /**
     * @param {?} pageId
     * @return {?}
     */
    PageBuilderContainerComponent.prototype.removePage = /**
     * @param {?} pageId
     * @return {?}
     */
    function (pageId) {
        /** @type {?} */
        var elementIds = this.elements ? Array.from(this.elements).reduce(function (array, el) { return __spread(array, [el[0]]); }, []) : null;
        this._pagesReducer.pagesReducer({
            type: PagesActionTypes.REMOVE_PAGE_ACTION,
            payload: { pageId: pageId, elementIds: elementIds },
        });
    };
    /**
     * @param {?} previousPageId
     * @return {?}
     */
    PageBuilderContainerComponent.prototype.insertPage = /**
     * @param {?} previousPageId
     * @return {?}
     */
    function (previousPageId) {
        /** @type {?} */
        var pageId = UUID$$1();
        this._pagesReducer.pagesReducer({
            type: PagesActionTypes.INSERT_PAGE_ACTION,
            payload: { previousPageId: previousPageId, surveyId: this.surveyId, pageId: pageId },
        });
    };
    /**
     * @param {?} pageId
     * @return {?}
     */
    PageBuilderContainerComponent.prototype.movePageDown = /**
     * @param {?} pageId
     * @return {?}
     */
    function (pageId) {
        this._pagesReducer.pagesReducer({
            type: PagesActionTypes.MOVE_PAGE_DOWN_ACTION,
            payload: { pageId: pageId },
        });
    };
    /**
     * @param {?} pageId
     * @return {?}
     */
    PageBuilderContainerComponent.prototype.movePageUp = /**
     * @param {?} pageId
     * @return {?}
     */
    function (pageId) {
        this._pagesReducer.pagesReducer({
            type: PagesActionTypes.MOVE_PAGE_UP_ACTION,
            payload: { pageId: pageId },
        });
    };
    /**
     * @param {?} pageId
     * @return {?}
     */
    PageBuilderContainerComponent.prototype.addElement = /**
     * @param {?} pageId
     * @return {?}
     */
    function (pageId) {
        this._elementsReducer.elementsReducer({
            type: ElementsActionTypes.ADD_ELEMENT_ACTION,
            payload: { pageId: pageId, type: 'question' },
        });
    };
    /**
     * @param {?} pageId
     * @return {?}
     */
    PageBuilderContainerComponent.prototype.addParagraph = /**
     * @param {?} pageId
     * @return {?}
     */
    function (pageId) {
        this._elementsReducer.elementsReducer({
            type: ElementsActionTypes.ADD_ELEMENT_ACTION,
            payload: { pageId: pageId, type: 'paragraph' },
        });
    };
    /**
     * @param {?} pageId
     * @return {?}
     */
    PageBuilderContainerComponent.prototype.onEditPageClick = /**
     * @param {?} pageId
     * @return {?}
     */
    function (pageId) {
        var _this = this;
        this.isEditPage = true;
        setTimeout(function () {
            _this.editPageName(pageId);
            _this.editPageDescription(pageId);
        }, 300);
    };
    /**
     * @param {?} pageId
     * @return {?}
     */
    PageBuilderContainerComponent.prototype.editPageName = /**
     * @param {?} pageId
     * @return {?}
     */
    function (pageId) {
        var _this = this;
        /** @type {?} */
        var $pageNameInput = document.getElementById("page-name-input-" + pageId);
        fromEvent($pageNameInput, 'input').pipe(map(function (event) { return event.target.value; }), distinctUntilChanged(), debounceTime(1000)).subscribe(function (name) {
            _this._pagesReducer.pagesReducer({
                type: PagesActionTypes.UPDATE_PAGE_NAME_ACTION,
                payload: { pageId: pageId, name: name },
            });
        });
    };
    /**
     * @param {?} pageId
     * @return {?}
     */
    PageBuilderContainerComponent.prototype.editPageDescription = /**
     * @param {?} pageId
     * @return {?}
     */
    function (pageId) {
        var _this = this;
        /** @type {?} */
        var $pageDescriptionInput = document.getElementById("page-description-input-" + pageId);
        fromEvent($pageDescriptionInput, 'input').pipe(map(function (event) { return event.target.value; }), distinctUntilChanged(), debounceTime(1000)).subscribe(function (description) {
            _this._pagesReducer.pagesReducer({
                type: PagesActionTypes.UPDATE_PAGE_DESCRIPTION_ACTION,
                payload: { pageId: pageId, description: description },
            });
        });
    };
    /**
     * @param {?} event
     * @param {?} pageId
     * @return {?}
     */
    PageBuilderContainerComponent.prototype.drop = /**
     * @param {?} event
     * @param {?} pageId
     * @return {?}
     */
    function (event, pageId) {
        this._elementsReducer.elementsReducer({
            type: ElementsActionTypes.DRAG_ELEMENT_ACTION,
            payload: {
                pageId: pageId,
                startIndex: event.previousIndex,
                endIndex: event.currentIndex,
            },
        });
    };
    /**
     * @param {?} __0
     * @return {?}
     */
    PageBuilderContainerComponent.prototype.handleIsSavedEvent = /**
     * @param {?} __0
     * @return {?}
     */
    function (_a) {
        var key = _a.key, isSaved = _a.isSaved;
        this.isSavedMap.set(key, isSaved);
    };
    /**
     * @private
     * @return {?}
     */
    PageBuilderContainerComponent.prototype.setSavedMap = /**
     * @private
     * @return {?}
     */
    function () {
        var _this = this;
        if (this.elements) {
            this.elements.forEach(function (value, key) {
                if (value.isSaved) {
                    _this.isSavedMap.set(key, true);
                }
                else {
                    _this.isSavedMap.set(key, false);
                }
            });
        }
    };
    /**
     * @param {?} index
     * @param {?} item
     * @return {?}
     */
    PageBuilderContainerComponent.prototype.trackElement = /**
     * @param {?} index
     * @param {?} item
     * @return {?}
     */
    function (index, item) {
        return item ? item.key : null;
    };
    PageBuilderContainerComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ngs-page-builder-container',
                    template: "<div *ngIf=\"surveyId\">\n  <div class=\"card mt-5\">\n    <!-- Card Header -->\n    <div class=\"card-header d-flex flex-md-row flex-column w-100\">\n      <div class=\"mr-auto w-md-50 w-100 mb-md-0 mb-3\">\n        <span>Page {{page?.orderNo}} of {{pageSize}}</span>\n      </div>\n      <div class=\"btn-group\" role=\"group\">\n        <button *ngIf=\"!isEditPage\" type=\"button\" class=\"btn btn-outline-primary\" tooltip=\"Edit page name and description\" (click)=\"onEditPageClick(page?.id)\">\n          <i class=\"fas fa-pencil-alt\"></i>\n        </button>\n        <button *ngIf=\"isEditPage\" type=\"button\" class=\"btn btn-outline-primary\" tooltip=\"Save page name and description\" (click)=\"isEditPage = false\">\n          <i class=\"fas fa-save\"></i>\n        </button>\n        <button type=\"button\" class=\"btn btn-outline-primary\" tooltip=\"Move Down\" (click)=\"movePageDown(page?.id)\" [disabled]=\"page?.orderNo === pageSize\">\n          <i class=\"fas fa-chevron-down\"></i>\n        </button>\n        <button type=\"button\" class=\"btn btn-outline-primary\" tooltip=\"Move Up\" (click)=\"movePageUp(page?.id)\" [disabled]=\"page?.orderNo === 1\">\n          <i class=\"fas fa-chevron-up\"></i>\n        </button>\n        <button type=\"button\" class=\"btn btn-outline-primary\" tooltip=\"Remove Page\" (click)=\"removePage(page?.id)\">\n          <i class=\"fas fa-trash-alt\"></i>\n        </button>\n      </div>\n    </div>\n    <!-- #/Card Header -->\n\n    <!-- Card Body -->\n    <div class=\"card-body bg-white\">\n      <!-- Edit Page Name and Description Form -->\n      <form *ngIf=\"isEditPage\" class=\"mb-5 mt-2\">\n        <div class=\"form-group\">\n          <label [for]=\"'page-name-input-' + page?.id\">Edit Page Name</label>\n          <input\n            [id]=\"'page-name-input-' + page?.id\"\n            name=\"page-name-input\"\n            type=\"text\"\n            class=\"form-control w-100\"\n            placeholder=\"Enter page name\"\n            [ngModel]=\"page?.name\"\n          >\n        </div>\n        <div class=\"form-group\">\n          <label [for]=\"'page-description-input-' + page?.id\">Edit Page Description</label>\n          <input\n            [id]=\"'page-description-input-' + page?.id\"\n            name=\"page-description-input\"\n            type=\"text\"\n            class=\"form-control w-100\"\n            placeholder=\"Enter page description\"\n            [ngModel]=\"page?.description\"\n          >\n        </div>\n      </form>\n      <!-- #/Edit Page Name and Description Form -->\n\n      <!-- Page Name and Description -->\n      <div *ngIf=\"!isEditPage && (page?.name || page?.description)\" class=\"d-flex flex-column mb-3 mt-2\">\n        <div *ngIf=\"page?.name\">\n          <label>Page Name</label>\n          <h4>{{page?.name}}</h4>\n        </div>\n        <div *ngIf=\"page?.description\">\n          <label>Page Description</label>\n          <h4>{{page?.description}}</h4>\n        </div>\n      </div>\n      <!-- #/Page Name and Description -->\n\n      <!-- Question Builder Container -->\n      <div cdkDropList [cdkDropListData]=\"elements\" #pageElements=\"cdkDropList\" (cdkDropListDropped)=\"drop($event, page?.id)\">\n        <div *ngFor=\"let item of elements | mapValues; trackBy: trackElement\" class=\"mb-4\" cdkDrag>\n          <!-- Drag and Drop Background Place Holder -->\n          <div class=\"drag-drop-placeholder-question\" *cdkDragPlaceholder></div>\n          <!-- #/Drag and Drop Background Place Holder -->\n          <div\n            id=\"question-builder-container\"\n            class=\"d-flex flex-row align-content-start pt-md-4 pb-md-4 pr-md-3 pl-md-3 pt-3 pb-3 pr-2 pl-2\"\n            [ngClass]=\"!isSavedMap.get(item.key) ? 'z-depth-1' : ''\">\n            <!-- Move Option Button -->\n            <span class=\"mr-3 mb-3\">\n              <button [ngClass]=\"isSavedMap.get(item.key) || elements.size === 1 ? 'd-none' : ''\" type=\"button\" class=\"btn btn-outline-secondary\" tooltip=\"Drag and Drop Question\" cdkDragHandle>\n                <i class=\"fas fa-arrows-alt\"></i>\n              </button>\n            </span>\n            <!-- #/Move Option Button -->\n\n            <!-- Question Builder Container -->\n            <div class=\"w-100\">\n              <ngs-question-builder-container\n                [element]=\"item?.value\"\n                [elementsSize]=\"elementsSize\"\n                [pageId]=\"page?.id\"\n                [surveyId]=\"surveyId\"\n                (isSavedEvent)=\"handleIsSavedEvent($event)\"\n              ></ngs-question-builder-container>\n            </div>\n            <!-- #/Question Builder Container -->\n\n            <!-- Paragraph Builder Container -->\n          </div>\n        </div>\n      </div>\n      <!-- #/Question Builder Container -->\n    </div>\n    <!-- #/Card Body -->\n\n    <!-- Card Footer -->\n    <div class=\"card-footer d-flex flex-md-row flex-column w-100 mt-1\">\n      <div class=\"mr-auto\">\n        <div class=\"btn-group\" dropdown>\n          <button type=\"button\" class=\"btn btn-outline-primary\" (click)=\"addElement(page?.id)\">Add Element</button>\n          <button id=\"button-split\" type=\"button\" dropdownToggle class=\"btn btn-outline-primary dropdown-toggle dropdown-toggle-split\" aria-controls=\"dropdown-split\">\n            <span class=\"caret\"></span>\n            <span class=\"sr-only\">Split button!</span>\n          </button>\n          <ul id=\"dropdown-split\" *dropdownMenu class=\"dropdown-menu\"\n              role=\"menu\" aria-labelledby=\"button-split\">\n            <li role=\"menuitem\"><a class=\"dropdown-item\" (click)=\"addElement(page?.id)\">Question</a></li>\n            <li role=\"menuitem\"><a class=\"dropdown-item\" (click)=\"addParagraph(page?.id)\">Paragraph</a></li>\n          </ul>\n        </div>\n      </div>\n      <div class=\"d-flex flex-md-row flex-column\" *ngIf=\"pageSize > 1\">\n        <!-- Navigate to page selection -->\n        <ngs-page-select\n          [isPage]=\"true\"\n          [surveyId]=\"surveyId\"\n          [pageId]=\"page?.id\"\n          [pageFlow]=\"page.pageFlow\"\n        ></ngs-page-select>\n        <!-- #/Navigate to page selection -->\n\n        <!-- Insert Page -->\n        <button type=\"button\" class=\"btn btn-outline-primary ml-md-4 ml-0 mt-3\" tooltip=\"Insert Page\" (click)=\"insertPage(page?.id)\">\n          <i class=\"fas fa-plus\"></i>\n        </button>\n        <!-- #/Add Page -->\n      </div>\n    </div>\n    <!-- #/Card Footer -->\n  </div>\n</div>\n",
                    styles: [".dropdown-menu li:hover{cursor:pointer}.cdk-drop-list-dragging .cdk-drag{transition:transform 250ms cubic-bezier(0,0,.2,1);transition:transform 250ms cubic-bezier(0,0,.2,1),-webkit-transform 250ms cubic-bezier(0,0,.2,1)}.cdk-drag-animating{transition:transform .3s cubic-bezier(0,0,.2,1);transition:transform .3s cubic-bezier(0,0,.2,1),-webkit-transform .3s cubic-bezier(0,0,.2,1)}.cdk-drag-preview{box-sizing:border-box;border-radius:4px;box-shadow:0 5px 5px -3px rgba(0,0,0,.2),0 8px 10px 1px rgba(0,0,0,.14),0 3px 14px 2px rgba(0,0,0,.12)}.drag-drop-placeholder-question{background:rgba(0,0,0,.03);border:1px solid rgba(0,0,0,.125);border-radius:10px;min-height:400px;transition:transform 250ms cubic-bezier(0,0,.2,1);transition:transform 250ms cubic-bezier(0,0,.2,1),-webkit-transform 250ms cubic-bezier(0,0,.2,1)}.option-min-height{min-height:65px}.drag-drop-placeholder-question-option{background:rgba(0,0,0,.03);border:1px solid rgba(0,0,0,.125);border-radius:10px;min-height:65px;transition:transform 250ms cubic-bezier(0,0,.2,1);transition:transform 250ms cubic-bezier(0,0,.2,1),-webkit-transform 250ms cubic-bezier(0,0,.2,1)}.z-depth-1{box-shadow:0 2px 5px 0 rgba(0,0,0,.16),0 2px 10px 0 rgba(0,0,0,.12)}.card-body{border-left:1px solid rgba(0,0,0,.125)!important}"]
                }] }
    ];
    /** @nocollapse */
    PageBuilderContainerComponent.ctorParameters = function () { return [
        { type: NgSurveyStore },
        { type: PagesReducer },
        { type: ElementsReducer }
    ]; };
    PageBuilderContainerComponent.propDecorators = {
        surveyId: [{ type: Input }],
        page: [{ type: Input }],
        pages: [{ type: Input }]
    };
    return PageBuilderContainerComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var PageViewerContainerComponent = /** @class */ (function () {
    function PageViewerContainerComponent(_ngSurveyStore) {
        this._ngSurveyStore = _ngSurveyStore;
    }
    /**
     * @return {?}
     */
    PageViewerContainerComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this.elementsSub = this._ngSurveyStore.elements.subscribe(function (res) {
            _this.elements = _this.page ? res.get(_this.page.id) : null;
            if (res) {
                _this.elementsSize = res.size;
            }
        });
    };
    /**
     * @param {?} index
     * @param {?} item
     * @return {?}
     */
    PageViewerContainerComponent.prototype.trackElement = /**
     * @param {?} index
     * @param {?} item
     * @return {?}
     */
    function (index, item) {
        return item ? item.key : null;
    };
    PageViewerContainerComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ngs-page-viewer-container',
                    template: "<div *ngFor=\"let item of elements | mapValues; trackBy: trackElement\">\n  <ngs-question-viewer-container\n    class=\"w-100\"\n    [element]=\"item?.value\"\n    [surveyId]=\"page.surveyId\"\n  ></ngs-question-viewer-container>\n</div>\n",
                    styles: [""]
                }] }
    ];
    /** @nocollapse */
    PageViewerContainerComponent.ctorParameters = function () { return [
        { type: NgSurveyStore }
    ]; };
    PageViewerContainerComponent.propDecorators = {
        page: [{ type: Input }]
    };
    return PageViewerContainerComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ElementAndOptionAnswersModel = /** @class */ (function () {
    function ElementAndOptionAnswersModel(element, optionAnswers) {
        this.element = element;
        this.optionAnswers = optionAnswers;
    }
    return ElementAndOptionAnswersModel;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var QuestionBuilderContainerComponent = /** @class */ (function () {
    function QuestionBuilderContainerComponent(_ngSurveyStore, _elementsReducer, _optionAnswersReducer) {
        var _this = this;
        this._ngSurveyStore = _ngSurveyStore;
        this._elementsReducer = _elementsReducer;
        this._optionAnswersReducer = _optionAnswersReducer;
        this.isSavedEvent = new EventEmitter();
        this.builderOptionsSub = this._ngSurveyStore.builderOptions.subscribe(function (res) {
            _this.builderOptions = res;
            _this.elementButtons = _this.builderOptions.elementButtons;
            _this.importElementButton = _this.builderOptions.importElement;
        });
    }
    /**
     * @return {?}
     */
    QuestionBuilderContainerComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        var _this = this;
        if (this.element.type === 'question') {
            this.questionType = this.element.question.type;
            this.prevQuestionType = this.questionType;
        }
        setTimeout(function () {
            if (!!_this.questionType) {
                _this.isSavedEvent.emit({ key: _this.element.id, isSaved: _this.element.isSaved });
            }
        }, 100);
    };
    /**
     * @param {?} cb
     * @param {?} currentElement
     * @return {?}
     */
    QuestionBuilderContainerComponent.prototype.importElement = /**
     * @param {?} cb
     * @param {?} currentElement
     * @return {?}
     */
    function (cb, currentElement) {
        var _this = this;
        cb().subscribe(function (_a) {
            var element = _a.element, optionAnswers = _a.optionAnswers;
            _this._elementsReducer.elementsReducer({
                type: ElementsActionTypes.IMPORT_ELEMENT,
                payload: { element: element, optionAnswers: optionAnswers, pageId: _this.pageId, currentElement: currentElement }
            });
        });
    };
    /**
     * @param {?} element
     * @param {?} cb
     * @return {?}
     */
    QuestionBuilderContainerComponent.prototype.handleCustomElementButton = /**
     * @param {?} element
     * @param {?} cb
     * @return {?}
     */
    function (element, cb) {
        this._ngSurveyStore.optionAnswers.pipe(map(function (res) {
            /** @type {?} */
            var optionAnswers = res.get(element.id);
            /** @type {?} */
            var elementAndOptionAnswers = new ElementAndOptionAnswersModel(element, optionAnswers);
            cb({ elementAndOptionAnswers: elementAndOptionAnswers });
        }));
    };
    /**
     * @param {?} type
     * @param {?} elementId
     * @return {?}
     */
    QuestionBuilderContainerComponent.prototype.onQuestionTypeSelect = /**
     * @param {?} type
     * @param {?} elementId
     * @return {?}
     */
    function (type, elementId) {
        this.questionType = type;
        if (this.prevQuestionType === 'checkboxes' || this.prevQuestionType === 'radio' || this.prevQuestionType === 'select') {
            this._optionAnswersReducer.optionAnswersReducer({
                type: OptionAnswersActionTypes.REMOVE_OPTION_ANSWERS_MAP_ACTION,
                payload: { elementId: this.element.id },
            });
        }
        this._elementsReducer.elementsReducer({
            type: ElementsActionTypes.QUESTION_ADD_TYPE_ACTION,
            payload: {
                pageId: this.pageId,
                elementId: elementId,
                type: type,
            }
        });
        this._elementsReducer.elementsReducer({
            type: ElementsActionTypes.TOGGLE_IS_ACTIVE_ELEMENT_ACTION,
            payload: { pageId: this.pageId, elementId: elementId, isSaved: false }
        });
        this.prevQuestionType = type;
    };
    /**
     * @param {?} elementId
     * @return {?}
     */
    QuestionBuilderContainerComponent.prototype.saveQuestion = /**
     * @param {?} elementId
     * @return {?}
     */
    function (elementId) {
        this._elementsReducer.elementsReducer({
            type: ElementsActionTypes.TOGGLE_IS_ACTIVE_ELEMENT_ACTION,
            payload: { pageId: this.pageId, elementId: elementId, isSaved: true }
        });
        this.isSavedEvent.emit({ key: this.element.id, isSaved: true });
    };
    /**
     * @param {?} elementId
     * @return {?}
     */
    QuestionBuilderContainerComponent.prototype.editQuestion = /**
     * @param {?} elementId
     * @return {?}
     */
    function (elementId) {
        this._elementsReducer.elementsReducer({
            type: ElementsActionTypes.TOGGLE_IS_ACTIVE_ELEMENT_ACTION,
            payload: { pageId: this.pageId, elementId: elementId, isSaved: false }
        });
        this.isSavedEvent.emit({ key: this.element.id, isSaved: false });
    };
    /**
     * @param {?} elementId
     * @return {?}
     */
    QuestionBuilderContainerComponent.prototype.cloneElement = /**
     * @param {?} elementId
     * @return {?}
     */
    function (elementId) {
        this._elementsReducer.elementsReducer({
            type: ElementsActionTypes.CLONE_ELEMENT_ACTION,
            payload: { pageId: this.pageId, elementId: elementId }
        });
    };
    /**
     * @param {?} elementId
     * @return {?}
     */
    QuestionBuilderContainerComponent.prototype.removeElement = /**
     * @param {?} elementId
     * @return {?}
     */
    function (elementId) {
        this._elementsReducer.elementsReducer({
            type: ElementsActionTypes.REMOVE_ELEMENT_ACTION,
            payload: { pageId: this.pageId, elementId: elementId }
        });
    };
    /**
     * @param {?} elementId
     * @return {?}
     */
    QuestionBuilderContainerComponent.prototype.moveElementDown = /**
     * @param {?} elementId
     * @return {?}
     */
    function (elementId) {
        this._elementsReducer.elementsReducer({
            type: ElementsActionTypes.MOVE_ELEMENT_DOWN_ACTION,
            payload: { pageId: this.pageId, elementId: elementId }
        });
    };
    /**
     * @param {?} elementId
     * @return {?}
     */
    QuestionBuilderContainerComponent.prototype.moveElementUp = /**
     * @param {?} elementId
     * @return {?}
     */
    function (elementId) {
        this._elementsReducer.elementsReducer({
            type: ElementsActionTypes.MOVE_ELEMENT_UP_ACTION,
            payload: { pageId: this.pageId, elementId: elementId }
        });
    };
    /**
     * @param {?} index
     * @param {?} item
     * @return {?}
     */
    QuestionBuilderContainerComponent.prototype.trackElement = /**
     * @param {?} index
     * @param {?} item
     * @return {?}
     */
    function (index, item) {
        return item ? item.key : null;
    };
    QuestionBuilderContainerComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ngs-question-builder-container',
                    template: "<div>\n  <!-- Header -->\n  <div class=\"d-flex justify-content-end ml-3\">\n    <!-- Element Button Group -->\n    <div class=\"btn-group\" role=\"group\">\n      <!-- Remove Element -->\n      <button\n        *ngIf=\"!element?.isSaved\"\n        type=\"button\"\n        class=\"btn btn-outline-primary\"\n        tooltip=\"Remove Element\"\n        (click)=\"removeElement(element?.id)\">\n        <i class=\"fas fa-trash-alt\"></i>\n      </button>\n      <!-- #/Remove Element -->\n\n      <!-- Move Element Down -->\n      <button\n        *ngIf=\"!element?.isSaved\"\n        type=\"button\"\n        class=\"btn btn-outline-primary\"\n        tooltip=\"Move Down\"\n        (click)=\"moveElementDown(element?.id)\"\n        [disabled]=\"element?.orderNo === elementsSize\">\n        <i class=\"fas fa-chevron-down\"></i>\n      </button>\n      <!-- #/Move Element Down -->\n\n      <!-- Move Element Up -->\n      <button\n        *ngIf=\"!element?.isSaved\"\n        type=\"button\"\n        class=\"btn btn-outline-primary\"\n        tooltip=\"Move Up\"\n        (click)=\"moveElementUp(element?.id)\"\n        [disabled]=\"element?.orderNo === 1\">\n        <i class=\"fas fa-chevron-up\"></i>\n      </button>\n      <!-- Move Element Up -->\n\n      <!-- Clone Element -->\n      <button\n        *ngIf=\"element?.isSaved\"\n        type=\"button\"\n        class=\"btn btn-outline-primary\"\n        tooltip=\"Clone Element\"\n        (click)=\"cloneElement(element?.id)\"\n      >\n        <i class=\"fas fa-clone\"></i>\n      </button>\n      <!-- #/Clone Element -->\n\n      <!-- Edit Question -->\n      <button\n        [id]=\"'edit-question-button-' + element?.id\"\n        *ngIf=\"element?.isSaved && element.type === 'question'\"\n        type=\"button\"\n        class=\"btn btn-outline-primary\"\n        tooltip=\"Edit Element\"\n        (click)=\"editQuestion(element?.id)\">\n        <i class=\"fas fa-edit\"></i>\n      </button>\n      <!-- #/Edit Question -->\n\n      <!-- Import Element -->\n      <button\n        id=\"import-element\"\n        *ngIf=\"!!importElementButton && element.type === 'question'\"\n        type=\"button\"\n        class=\"btn btn-outline-primary\"\n        [tooltip]=\"importElementButton?.title ? importElementButton?.title : 'Import Element'\"\n        (click)=\"importElement(importElementButton.callback, element)\"\n      >\n        <i [class]=\"importElementButton?.icon ? importElementButton?.icon : 'fas fa-file-import'\"></i>\n      </button>\n      <!-- #/Import Element -->\n\n      <!-- Custom Element Buttons -->\n      <span *ngIf=\"!!elementButtons && elementButtons?.length > 0 && element.type === 'question'\">\n        <button\n          *ngFor=\"let button of elementButtons\"\n          [id]=\"'custom-element-button' + button?.title\"\n          type=\"button\"\n          class=\"btn btn-outline-primary bl-none\"\n          [tooltip]=\"button?.title\"\n          (click)=\"handleCustomElementButton(element, button?.callback)\"\n        >\n          <i [class]=\"button?.icon\"></i>\n        </button>\n        <!-- #/Custom Element Buttons -->\n      </span>\n    </div>\n    <!-- #/Element Button Group -->\n  </div>\n  <!-- #/Header -->\n\n  <!-- Question Builder -->\n  <div *ngIf=\"element.type === 'question'\" class=\"mt-4\">\n    <!-- Question Form Builder -->\n    <form name=\"questionForm\" #questionForm=\"ngForm\">\n\n      <!-- Question Value Input -->\n      <ngs-question-input\n        [elementId]=\"element?.id\"\n        [elementValue]=\"element?.question.text\"\n        [pageId]=\"pageId\"\n        [isElementSaved]=\"element?.isSaved\"\n      ></ngs-question-input>\n      <!-- #/Question Value Input -->\n\n      <!-- Question Type Selector -->\n      <div class=\"form-group\">\n        <label for=\"questionType\">Question Type</label>\n        <select\n          id=\"questionType\"\n          name=\"questionType\"\n          class=\"form-control\"\n          [(ngModel)]=\"element?.question.type\"\n          (ngModelChange)=\"onQuestionTypeSelect($event, element?.id)\"\n          [disabled]=\"element?.isSaved\"\n        >\n          <option selected></option>\n          <option value=\"shortText\">Short Text</option>\n          <option value=\"longText\">Long Text</option>\n          <option value=\"radio\">Radio</option>\n          <option value=\"checkboxes\">Checkboxes</option>\n          <option value=\"select\">Select</option>\n          <option value=\"date\">Date</option>\n          <option value=\"range\">Range</option>\n        </select>\n      </div>\n      <!-- #/Question Type Selector -->\n    </form>\n    <!-- #/Question Form Builder -->\n\n    <!-- Question Builder Element -->\n    <ngs-question-builder-component\n      [questionType]=\"element?.question.type\"\n      [element]=\"element\"\n      [surveyId]=\"surveyId\"\n      [isView]=\"false\"\n    ></ngs-question-builder-component>\n    <!-- #/Question Builder Element -->\n\n    <!-- Save Button -->\n    <button [id]=\"'save-question-button-' + element?.id\" *ngIf=\"!element?.isSaved\" type=\"button\" class=\"btn btn-outline-primary mt-4\" (click)=\"saveQuestion(element?.id)\" [disabled]=\"!questionType\">Save Question</button>\n    <!-- #/Save Button -->\n  </div>\n  <!-- #/Question Builder -->\n\n  <!-- Paragraph Builder -->\n  <div *ngIf=\"element.type === 'paragraph'\" class=\"mt-4\">\n    <ngs-paragraph\n      [element]=\"element\"\n    ></ngs-paragraph>\n  </div>\n  <!-- #/Paragraph Builder -->\n</div>\n\n",
                    styles: ["#question-builder-container{padding:1% 2.5%}.bl-none{border-top-left-radius:0!important;border-left:0!important;border-bottom-left-radius:0!important}"]
                }] }
    ];
    /** @nocollapse */
    QuestionBuilderContainerComponent.ctorParameters = function () { return [
        { type: NgSurveyStore },
        { type: ElementsReducer },
        { type: OptionAnswersReducer }
    ]; };
    QuestionBuilderContainerComponent.propDecorators = {
        surveyId: [{ type: Input }],
        pageId: [{ type: Input }],
        element: [{ type: Input }],
        elementsSize: [{ type: Input }],
        isSavedEvent: [{ type: Output }]
    };
    return QuestionBuilderContainerComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var QuestionInputComponent = /** @class */ (function () {
    function QuestionInputComponent(_elementsReducer) {
        this._elementsReducer = _elementsReducer;
    }
    /**
     * @return {?}
     */
    QuestionInputComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        var _this = this;
        setTimeout(function () {
            _this.handleQuestionNameChange();
        }, 300);
    };
    /**
     * @return {?}
     */
    QuestionInputComponent.prototype.handleQuestionNameChange = /**
     * @return {?}
     */
    function () {
        var _this = this;
        /** @type {?} */
        var $questionText = document.getElementById("questionText-" + this.elementId);
        fromEvent($questionText, 'input').pipe(map(function (event) { return event.target.value; }), distinctUntilChanged(), debounceTime(1000), map(function (text) { return text; })).subscribe(function (text) { return _this._elementsReducer.elementsReducer({
            type: ElementsActionTypes.QUESTION_ADD_TEXT_ACTION,
            payload: {
                pageId: _this.pageId,
                elementId: _this.elementId,
                text: text,
            }
        }); });
    };
    QuestionInputComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ngs-question-input',
                    template: "<!-- Question Value Input -->\n<div class=\"form-group\">\n  <label [for]=\"'questionText-' + elementId\">Question Text</label>\n  <input\n    [id]=\"'questionText-' + elementId\"\n    name=\"questionText\"\n    type=\"text\"\n    class=\"form-control\"\n    [ngModel]=\"elementValue\"\n    placeholder=\"Question Text\"\n    [disabled]=\"isElementSaved\"\n    required>\n</div>\n<!-- #/Question Value Input -->\n",
                    styles: [""]
                }] }
    ];
    /** @nocollapse */
    QuestionInputComponent.ctorParameters = function () { return [
        { type: ElementsReducer }
    ]; };
    QuestionInputComponent.propDecorators = {
        elementValue: [{ type: Input }],
        elementId: [{ type: Input }],
        pageId: [{ type: Input }],
        isElementSaved: [{ type: Input }]
    };
    return QuestionInputComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var QuestionViewerContainerComponent = /** @class */ (function () {
    function QuestionViewerContainerComponent() {
    }
    /**
     * @return {?}
     */
    QuestionViewerContainerComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
    };
    QuestionViewerContainerComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ngs-question-viewer-container',
                    template: "<!-- Question Builder Element -->\n<div *ngIf=\"element?.type === 'question'\" class=\"mt-4\">\n  <ngs-question-builder-component\n    [questionType]=\"element?.question.type\"\n    [element]=\"element\"\n    [surveyId]=\"surveyId\"\n    [isView]=\"true\"\n  ></ngs-question-builder-component>\n</div>\n<!-- #/Question Builder Element -->\n\n<!-- Paragraph Builder Element-->\n<div *ngIf=\"element?.type === 'paragraph'\" class=\"mt-4\">\n  <ngs-paragraph-summary-viewer\n    [html]=\"element.paragraph.html\"\n  ></ngs-paragraph-summary-viewer>\n</div>\n<!-- #/Paragraph Builder Element-->\n",
                    styles: [""]
                }] }
    ];
    /** @nocollapse */
    QuestionViewerContainerComponent.ctorParameters = function () { return []; };
    QuestionViewerContainerComponent.propDecorators = {
        element: [{ type: Input }],
        surveyId: [{ type: Input }]
    };
    return QuestionViewerContainerComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var SummaryContainerComponent = /** @class */ (function () {
    function SummaryContainerComponent(_ngSurveyStore, _surveyReducer) {
        var _this = this;
        this._ngSurveyStore = _ngSurveyStore;
        this._surveyReducer = _surveyReducer;
        this.surveySub = this._ngSurveyStore.survey.subscribe(function (res) {
            _this.survey = res;
        });
    }
    /**
     * @return {?}
     */
    SummaryContainerComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () { };
    /**
     * @param {?} summary
     * @return {?}
     */
    SummaryContainerComponent.prototype.handleEditorEvent = /**
     * @param {?} summary
     * @return {?}
     */
    function (summary) {
        this._surveyReducer.surveyReducer({
            type: SurveyActionTypes.SURVEY_SUMMARY_CHANGED_ACTION,
            payload: { summary: summary },
        });
    };
    /**
     * @return {?}
     */
    SummaryContainerComponent.prototype.ngOnDestroy = /**
     * @return {?}
     */
    function () {
        this.surveySub.unsubscribe();
    };
    SummaryContainerComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ngs-summary-container',
                    template: "<div class=\"card mt-5\">\n  <!-- Card Header -->\n  <div class=\"card-header d-flex w-100\">\n    <div class=\"mr-auto\">\n      <span>Summary Page</span>\n    </div>\n  </div>\n  <!-- #/Card Header -->\n\n  <!-- Card Body -->\n  <div class=\"card-body bg-white\">\n    <ngs-editor\n      [editorData]=\"survey.summary\"\n      (editorDataEvent)=\"handleEditorEvent($event)\"\n    ></ngs-editor>\n  </div>\n  <!-- #/Card Body -->\n\n  <!-- Card Footer -->\n  <div class=\"card-footer d-flex w-100\">\n    <div class=\"mr-auto\"></div>\n  </div>\n  <!-- #/Card Footer -->\n</div>\n",
                    styles: [":host ::ng-deep .ck-editor__editable{min-height:250px}.card-body{border-left:1px solid rgba(0,0,0,.125)!important}"]
                }] }
    ];
    /** @nocollapse */
    SummaryContainerComponent.ctorParameters = function () { return [
        { type: NgSurveyStore },
        { type: SurveyReducer }
    ]; };
    return SummaryContainerComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var SurveyTemplateFormComponent = /** @class */ (function () {
    function SurveyTemplateFormComponent(_surveyReducer) {
        this._surveyReducer = _surveyReducer;
    }
    /**
     * @return {?}
     */
    SurveyTemplateFormComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        var _this = this;
        setTimeout(function () {
            if (!_this.survey.isLoading) {
                _this.handleSurveyNameChange();
                _this.handleSurveyDescriptionChange();
            }
        }, 300);
    };
    /**
     * @return {?}
     */
    SurveyTemplateFormComponent.prototype.ngOnDestroy = /**
     * @return {?}
     */
    function () {
        this.surveyNameSub$.unsubscribe();
        this.surveyNameSub$.unsubscribe();
    };
    /**
     * @return {?}
     */
    SurveyTemplateFormComponent.prototype.handleSurveyNameChange = /**
     * @return {?}
     */
    function () {
        var _this = this;
        /** @type {?} */
        var $surveyName = document.getElementById('surveyName');
        this.surveyNameSub$ = fromEvent($surveyName, 'input').pipe(map(function (event) { return event.target.value; }), distinctUntilChanged$1(), debounceTime$1(1000)).subscribe(function (name) {
            _this._surveyReducer.surveyReducer({
                type: SurveyActionTypes.SURVEY_NAME_CHANGED_ACTION,
                payload: { name: name },
            });
        });
    };
    /**
     * @return {?}
     */
    SurveyTemplateFormComponent.prototype.handleSurveyDescriptionChange = /**
     * @return {?}
     */
    function () {
        var _this = this;
        /** @type {?} */
        var $surveyDescription = document.getElementById('surveyDescription');
        this.surveyDescriptionSub$ = fromEvent($surveyDescription, 'input').pipe(map(function (event) { return event.target.value; }), distinctUntilChanged$1(), debounceTime$1(1000)).subscribe(function (description) {
            _this._surveyReducer.surveyReducer({
                type: SurveyActionTypes.SURVEY_DESCRIPTION_CHANGED_ACTION,
                payload: { description: description },
            });
        });
    };
    SurveyTemplateFormComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ngs-survey-template-form',
                    template: "<form>\n  <div class=\"form-group\">\n    <label for=\"surveyName\">Survey Name</label>\n    <input\n      id=\"surveyName\"\n      name=\"surveyName\"\n      type=\"text\"\n      class=\"form-control\"\n      placeholder=\"Name\"\n      [ngModel]=\"survey.name\"\n      required\n    >\n  </div>\n  <div class=\"form-group\">\n    <label for=\"surveyDescription\">Survey Description</label>\n    <textarea\n      id=\"surveyDescription\"\n      class=\"form-control\"\n      name=\"surveyDescription\"\n      rows=\"3\"\n      placeholder=\"Description\"\n      [ngModel]=\"survey.description\"\n    ></textarea>\n  </div>\n</form>\n",
                    styles: [""]
                }] }
    ];
    /** @nocollapse */
    SurveyTemplateFormComponent.ctorParameters = function () { return [
        { type: SurveyReducer }
    ]; };
    SurveyTemplateFormComponent.propDecorators = {
        survey: [{ type: Input }]
    };
    return SurveyTemplateFormComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var SurveyParagraphViewerComponent = /** @class */ (function () {
    function SurveyParagraphViewerComponent() {
    }
    /**
     * @return {?}
     */
    SurveyParagraphViewerComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
    };
    SurveyParagraphViewerComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ngs-paragraph-summary-viewer',
                    template: "<div [innerHTML]=\"html\"></div>\n",
                    styles: [""]
                }] }
    ];
    /** @nocollapse */
    SurveyParagraphViewerComponent.ctorParameters = function () { return []; };
    SurveyParagraphViewerComponent.propDecorators = {
        html: [{ type: Input }]
    };
    return SurveyParagraphViewerComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ParagraphComponent = /** @class */ (function () {
    function ParagraphComponent(_elementsReducer) {
        this._elementsReducer = _elementsReducer;
    }
    /**
     * @return {?}
     */
    ParagraphComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
    };
    /**
     * @param {?} html
     * @return {?}
     */
    ParagraphComponent.prototype.handleEditorEvent = /**
     * @param {?} html
     * @return {?}
     */
    function (html) {
        this._elementsReducer.elementsReducer({
            type: ElementsActionTypes.PARAGRAPH_UPDATE_HTML_ACTION,
            payload: { pageId: this.element.pageId, elementId: this.element.id, html: html }
        });
    };
    ParagraphComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ngs-paragraph',
                    template: "<ngs-editor\n  [editorData]=\"element.paragraph.html\"\n  (editorDataEvent)=\"handleEditorEvent($event)\"\n></ngs-editor>\n",
                    styles: [":host ::ng-deep .ck-editor__editable{min-height:150px}"]
                }] }
    ];
    /** @nocollapse */
    ParagraphComponent.ctorParameters = function () { return [
        { type: ElementsReducer }
    ]; };
    ParagraphComponent.propDecorators = {
        element: [{ type: Input }]
    };
    return ParagraphComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var EditorComponent = /** @class */ (function () {
    function EditorComponent() {
        this.editorDataEvent = new EventEmitter();
        this.Editor = ClassicEditor;
        this.surveyDataSubject = new Subject();
    }
    /**
     * @return {?}
     */
    EditorComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this.surveyDataSubject.pipe(map$1(function (res) { return res; }), distinctUntilChanged(), debounceTime(1000)).subscribe(function (editorData) {
            _this.editorDataEvent.emit(editorData);
        });
    };
    /**
     * @param {?} __0
     * @return {?}
     */
    EditorComponent.prototype.onEditorChange = /**
     * @param {?} __0
     * @return {?}
     */
    function (_a) {
        var editor = _a.editor;
        /** @type {?} */
        var data = editor.getData();
        this.surveyDataSubject.next(data);
    };
    EditorComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ngs-editor',
                    template: "<ckeditor\n  id=\"summaryInput\"\n  [(ngModel)]=\"editorData\"\n  [editor]=\"Editor\"\n  (change)=\"onEditorChange($event)\"\n>\n</ckeditor>\n",
                    styles: [""]
                }] }
    ];
    /** @nocollapse */
    EditorComponent.ctorParameters = function () { return []; };
    EditorComponent.propDecorators = {
        editorData: [{ type: Input }],
        editorDataEvent: [{ type: Output }]
    };
    return EditorComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var BuilderModule = /** @class */ (function () {
    function BuilderModule() {
    }
    BuilderModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        CommonModule,
                        FormsModule,
                        BrowserAnimationsModule,
                        DragDropModule,
                        SharedCommonModule,
                        ReactiveFormsModule,
                        CKEditorModule,
                        TooltipModule.forRoot(),
                        BsDropdownModule.forRoot(),
                    ],
                    providers: [
                        QuestionBuilderService
                    ],
                    declarations: [
                        ShortTextComponent,
                        LongTextComponent,
                        DateComponent,
                        RangeComponent,
                        QuestionBuilderDirective,
                        QuestionBuilderComponent,
                        OptionTemplateComponent,
                        RadioCheckboxSelectComponent,
                        SelectComponent,
                        CheckboxComponent,
                        RadioComponent,
                        PageBuilderContainerComponent,
                        PageViewerContainerComponent,
                        QuestionBuilderContainerComponent,
                        QuestionInputComponent,
                        QuestionViewerContainerComponent,
                        SummaryContainerComponent,
                        SurveyTemplateFormComponent,
                        SurveyParagraphViewerComponent,
                        ParagraphComponent,
                        EditorComponent,
                    ],
                    entryComponents: [
                        ShortTextComponent,
                        LongTextComponent,
                        DateComponent,
                        RangeComponent,
                        RadioCheckboxSelectComponent,
                        SelectComponent,
                        CheckboxComponent,
                        RadioComponent,
                    ],
                    exports: [
                        ShortTextComponent,
                        LongTextComponent,
                        QuestionBuilderDirective,
                        QuestionBuilderComponent,
                        DateComponent,
                        RangeComponent,
                        OptionTemplateComponent,
                        RadioCheckboxSelectComponent,
                        SelectComponent,
                        CheckboxComponent,
                        RadioComponent,
                        PageBuilderContainerComponent,
                        PageViewerContainerComponent,
                        QuestionBuilderContainerComponent,
                        QuestionInputComponent,
                        QuestionViewerContainerComponent,
                        SummaryContainerComponent,
                        SurveyTemplateFormComponent,
                        SurveyParagraphViewerComponent,
                        ParagraphComponent,
                        EditorComponent,
                    ]
                },] }
    ];
    return BuilderModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgBuilderViewerModule = /** @class */ (function () {
    function NgBuilderViewerModule() {
    }
    NgBuilderViewerModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        CommonModule,
                        FormsModule,
                        TooltipModule$1.forRoot(),
                        SharedCommonModule,
                        BuilderModule,
                    ],
                    declarations: [NgBuilderViewerComponent],
                    exports: [NgBuilderViewerComponent]
                },] }
    ];
    return NgBuilderViewerModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var PageLinkedListNode = /** @class */ (function () {
    function PageLinkedListNode(page, next, previous) {
        this.page = page;
        this.next = next;
        this.previous = previous;
        this.page = page;
        this.next = next;
        this.previous = previous;
    }
    return PageLinkedListNode;
}());
var PageLinkedList = /** @class */ (function () {
    function PageLinkedList() {
        this.head = null;
        this.tail = null;
    }
    /**
     * @param {?} page
     * @return {?}
     */
    PageLinkedList.prototype.prepend = /**
     * @param {?} page
     * @return {?}
     */
    function (page) {
        // Make new node to be a head.
        /** @type {?} */
        var newNode = new PageLinkedListNode(page, this.head);
        // If there is head, then it won't be head anymore.
        // Therefore, make its previous reference to be new node (new head).
        // Then mark the new node as head.
        if (this.head) {
            this.head.previous = newNode;
        }
        this.head = newNode;
        // If there is no tail yet let's make new node a tail.
        if (!this.tail) {
            this.tail = newNode;
        }
        return this;
    };
    /**
     * @param {?} page
     * @return {?}
     */
    PageLinkedList.prototype.append = /**
     * @param {?} page
     * @return {?}
     */
    function (page) {
        /** @type {?} */
        var newNode = new PageLinkedListNode(page);
        // If there is no head yet let's make new node a head.
        if (!this.head) {
            this.head = newNode;
            this.tail = newNode;
            return this;
        }
        // Attach new node to the end of linked list.
        this.tail.next = newNode;
        // Attach current tail to the new node's previous reference.
        newNode.previous = this.tail;
        // Set new node to be the tail of linked list.
        this.tail = newNode;
        return this;
    };
    /**
     * @param {?} page
     * @return {?}
     */
    PageLinkedList.prototype.delete = /**
     * @param {?} page
     * @return {?}
     */
    function (page) {
        if (!this.head) {
            return null;
        }
        /** @type {?} */
        var deletedNode = null;
        /** @type {?} */
        var currentNode = this.head;
        while (currentNode) {
            if (currentNode.page.id === page.id) {
                deletedNode = currentNode;
                if (deletedNode === this.head) {
                    // If HEAD is going to be deleted...
                    // Set head to second node, which will become new head.
                    this.head = deletedNode.next;
                    // Set new head's previous to null.
                    if (this.head) {
                        this.head.previous = null;
                    }
                    // If all the nodes in list has same value that is passed as argument
                    // then all nodes will get deleted, therefore tail needs to be updated.
                    if (deletedNode === this.tail) {
                        this.tail = null;
                    }
                }
                else if (deletedNode === this.tail) {
                    // If TAIL is going to be deleted...
                    // Set tail to second last node, which will become new tail.
                    this.tail = deletedNode.previous;
                    this.tail.next = null;
                }
                else {
                    // If MIDDLE node is going to be deleted...
                    /** @type {?} */
                    var previousNode = deletedNode.previous;
                    /** @type {?} */
                    var nextNode = deletedNode.next;
                    previousNode.next = nextNode;
                    nextNode.previous = previousNode;
                }
            }
            currentNode = currentNode.next;
        }
        return deletedNode;
    };
    /**
     * @param {?} page
     * @param {?=} callback
     * @return {?}
     */
    PageLinkedList.prototype.find = /**
     * @param {?} page
     * @param {?=} callback
     * @return {?}
     */
    function (page, callback) {
        if (!this.head) {
            return null;
        }
        /** @type {?} */
        var currentNode = this.head;
        while (currentNode) {
            // If callback is specified then try to find node by callback.
            if (callback && callback(currentNode.page)) {
                return currentNode;
            }
            // If value is specified then try to compare by value's ID
            if (page !== undefined && currentNode.page.id === page.id) {
                return currentNode;
            }
            currentNode = currentNode.next;
        }
        return null;
    };
    /**
     * @param {?} pageId
     * @return {?}
     */
    PageLinkedList.prototype.findByPageId = /**
     * @param {?} pageId
     * @return {?}
     */
    function (pageId) {
        if (!this.head) {
            return null;
        }
        /** @type {?} */
        var currentNode = this.head;
        while (currentNode) {
            if (pageId !== undefined && currentNode.page.id === pageId) {
                return currentNode;
            }
            currentNode = currentNode.next;
        }
        return null;
    };
    /**
     * @return {?}
     */
    PageLinkedList.prototype.deleteTail = /**
     * @return {?}
     */
    function () {
        /** @type {?} */
        var deletedTail;
        if (!this.tail) {
            // No tail to delete.
            return null;
        }
        if (this.head === this.tail) {
            // There is only one node in linked list.
            deletedTail = this.tail;
            this.head = null;
            this.tail = null;
            return deletedTail;
        }
        // If there are many nodes in linked list...
        deletedTail = this.tail;
        this.tail = this.tail.previous;
        this.tail.next = null;
        return deletedTail;
    };
    /**
     * @return {?}
     */
    PageLinkedList.prototype.deleteHead = /**
     * @return {?}
     */
    function () {
        if (!this.head) {
            return null;
        }
        /** @type {?} */
        var deletedHead = this.head;
        if (this.head.next) {
            this.head = this.head.next;
            this.head.previous = null;
        }
        else {
            this.head = null;
            this.tail = null;
        }
        return deletedHead;
    };
    /**
     * @return {?}
     */
    PageLinkedList.prototype.toArray = /**
     * @return {?}
     */
    function () {
        /** @type {?} */
        var nodes = [];
        /** @type {?} */
        var currentNode = this.head;
        while (currentNode) {
            nodes.push(currentNode);
            currentNode = currentNode.next;
        }
        return nodes;
    };
    /**
     * @param {?} values
     * @return {?}
     */
    PageLinkedList.prototype.fromArray = /**
     * @param {?} values
     * @return {?}
     */
    function (values) {
        var _this = this;
        values.forEach(function (value) { return _this.append(value.page); });
        return this;
    };
    /**
     * @return {?}
     */
    PageLinkedList.prototype.reverse = /**
     * @return {?}
     */
    function () {
        /** @type {?} */
        var currNode = this.head;
        /** @type {?} */
        var prevNode = null;
        /** @type {?} */
        var nextNode = null;
        while (currNode) {
            // Store next node.
            nextNode = currNode.next;
            prevNode = currNode.previous;
            // Change next node of the current node so it would link to previous node.
            currNode.next = prevNode;
            currNode.previous = nextNode;
            // Move prevNode and currNode nodes one step forward.
            prevNode = currNode;
            currNode = nextNode;
        }
        // Reset head and tail.
        this.tail = this.head;
        this.head = prevNode;
        return this;
    };
    return PageLinkedList;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgSurveyViewerNavigationService = /** @class */ (function () {
    function NgSurveyViewerNavigationService(_ngSurveyStore) {
        this._ngSurveyStore = _ngSurveyStore;
        this.pageLinkedList = new BehaviorSubject(new PageLinkedList());
        this.currentPageNode = new BehaviorSubject(new PageLinkedListNode());
        this.prevPageLinkedList = new BehaviorSubject(new PageLinkedList());
        this.page = new BehaviorSubject(null);
        this.initPageStack();
    }
    /**
     * @param {?} pageId
     * @return {?}
     */
    NgSurveyViewerNavigationService.prototype.setGoToPage = /**
     * @param {?} pageId
     * @return {?}
     */
    function (pageId) {
        /** @type {?} */
        var currentPage = this.currentPageNode.value;
        /** @type {?} */
        var nextPage = this.findByPageId(pageId);
        this.currentPageNode.next(nextPage);
        this.prevPageLinkedList.value.append(currentPage.page);
        this.prevPageLinkedList.next(this.prevPageLinkedList.value);
        return nextPage.page;
    };
    /**
     * @return {?}
     */
    NgSurveyViewerNavigationService.prototype.setNextPage = /**
     * @return {?}
     */
    function () {
        /** @type {?} */
        var currentPage = this.currentPageNode.value;
        /** @type {?} */
        var nextPage = currentPage.next;
        this.prevPageLinkedList.value.append(currentPage.page);
        this.prevPageLinkedList.next(this.prevPageLinkedList.value);
        if (!!nextPage) {
            this.currentPageNode.next(nextPage);
            return nextPage.page;
        }
        else {
            return { id: 'summary', surveyId: '' };
        }
    };
    /**
     * @return {?}
     */
    NgSurveyViewerNavigationService.prototype.setPrevPage = /**
     * @return {?}
     */
    function () {
        // Get last visited page
        /** @type {?} */
        var prevPage = this.prevPageLinkedList.value.tail;
        // Find last visited page in page linked list and assign it as current page
        /** @type {?} */
        var currentPageNode = this.pageLinkedList.value.find(prevPage.page);
        this.currentPageNode.next(currentPageNode);
        // Update prev page linked list by deleting new current page node
        this.prevPageLinkedList.value.delete(prevPage.page);
        this.prevPageLinkedList.next(this.prevPageLinkedList.value);
        return currentPageNode.page;
    };
    /**
     * @param {?} pageId
     * @return {?}
     */
    NgSurveyViewerNavigationService.prototype.findByPageId = /**
     * @param {?} pageId
     * @return {?}
     */
    function (pageId) {
        /** @type {?} */
        var pageNode = this.pageLinkedList.value.findByPageId(pageId);
        this.currentPageNode.next(pageNode);
        return pageNode;
    };
    /**
     * @private
     * @return {?}
     */
    NgSurveyViewerNavigationService.prototype.initPageStack = /**
     * @private
     * @return {?}
     */
    function () {
        var _this = this;
        this._ngSurveyStore.pages.subscribe(function (res) {
            _this.pages = res;
            /** @type {?} */
            var pageLinkedList = new PageLinkedList();
            _this.pages.forEach(function (el) {
                pageLinkedList.append(el);
            });
            _this.pageLinkedList.next(pageLinkedList);
            // Assign head as current page
            _this.currentPageNode.next(_this.pageLinkedList.value.head);
        });
        // Get Elements
        this._ngSurveyStore.elements.subscribe(function (res) {
            _this.elements = res;
        });
    };
    /**
     * @return {?}
     */
    NgSurveyViewerNavigationService.prototype.checkSurveyEmpty = /**
     * @return {?}
     */
    function () {
        if (this.elements.size === 1) {
            if (this.page.value) {
                /** @type {?} */
                var elements = this.elements.get(this.page.value.id);
                if (elements.size === 1) {
                    /** @type {?} */
                    var element = elements.values().next().value;
                    if (element.question.type === '' || element.question.type === null) {
                        return true;
                    }
                }
            }
            else {
                return true;
            }
        }
        return false;
    };
    NgSurveyViewerNavigationService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    NgSurveyViewerNavigationService.ctorParameters = function () { return [
        { type: NgSurveyStore }
    ]; };
    /** @nocollapse */ NgSurveyViewerNavigationService.ngInjectableDef = defineInjectable({ factory: function NgSurveyViewerNavigationService_Factory() { return new NgSurveyViewerNavigationService(inject(NgSurveyStore)); }, token: NgSurveyViewerNavigationService, providedIn: "root" });
    return NgSurveyViewerNavigationService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgSurveyViewerComponent = /** @class */ (function () {
    function NgSurveyViewerComponent(_ngSurveyStore, router, surveyViewerNavigation$) {
        var _this = this;
        this._ngSurveyStore = _ngSurveyStore;
        this.router = router;
        this.surveyViewerNavigation$ = surveyViewerNavigation$;
        this.surveySub = this._ngSurveyStore.survey.subscribe(function (res) {
            _this.survey = res;
            _this.surveyId = res.id;
        });
        this._ngSurveyStore.pages.subscribe(function (res) {
            _this.pages = res;
            if (res) {
                _this.pageSize = res.size;
            }
        });
        this.elementsSub = this._ngSurveyStore.elements.subscribe(function (res) {
            _this.elements = res;
        });
        this.optionAnswersSub = this._ngSurveyStore.optionAnswers.subscribe(function (res) {
            _this.optionAnswers = res;
        });
        this.initNavigation();
        router.events.subscribe(function (event) {
            if (event instanceof NavigationStart) {
                _this.isPrevPageEmpty = false;
                _this.isNextPageEmpty = false;
                _this.isLoading = true;
            }
            if (event instanceof NavigationEnd) {
                setTimeout(function () {
                    _this.initNavigation();
                    _this.isLoading = false;
                }, 10);
            }
            if (event instanceof NavigationError) {
                setTimeout(function () {
                    _this.isLoading = false;
                }, 10);
                throw event.error;
            }
        });
    }
    /**
     * @return {?}
     */
    NgSurveyViewerComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        this.isSurveyEmpty = this.checkSurveyEmpty();
    };
    /**
     * @return {?}
     */
    NgSurveyViewerComponent.prototype.ngOnDestroy = /**
     * @return {?}
     */
    function () {
        this.surveySub.unsubscribe();
    };
    /**
     * @return {?}
     */
    NgSurveyViewerComponent.prototype.initNavigation = /**
     * @return {?}
     */
    function () {
        /** @type {?} */
        var currentPageNode = this.surveyViewerNavigation$.currentPageNode.value;
        /** @type {?} */
        var pageUrlId = this.getCurrentPageUrlId();
        this.showSummary = false;
        this.page = currentPageNode.page;
        this.isPrevPageEmpty = isNil$$1(currentPageNode.previous);
        this.isNextPageEmpty = isNil$$1(currentPageNode.next) && isNil$$1(this.survey.summary);
        if (pageUrlId === 'summary') {
            this.showSummary = true;
            this.isNextPageEmpty = true;
        }
    };
    /**
     * @return {?}
     */
    NgSurveyViewerComponent.prototype.nextPage = /**
     * @return {?}
     */
    function () {
        /** @type {?} */
        var elementPageFlowModifier = this.getElementPageFlowModifier();
        if (!!elementPageFlowModifier) {
            this.pageNext = this.surveyViewerNavigation$.setGoToPage(elementPageFlowModifier.pageId);
        }
        else if (this.page.pageFlow.label === 'pageFlow.goToPage') {
            this.pageNext = this.surveyViewerNavigation$.setGoToPage(this.page.pageFlow.pageId);
        }
        else {
            this.pageNext = this.surveyViewerNavigation$.setNextPage();
        }
        this.router.navigate(["/viewer/" + this.pageNext.id]);
    };
    /**
     * @return {?}
     */
    NgSurveyViewerComponent.prototype.prevPage = /**
     * @return {?}
     */
    function () {
        this.pagePrev = this.surveyViewerNavigation$.setPrevPage();
        this.router.navigate(["/viewer/" + this.pagePrev.id]);
    };
    /**
     * @return {?}
     */
    NgSurveyViewerComponent.prototype.getElementPageFlowModifier = /**
     * @return {?}
     */
    function () {
        /** @type {?} */
        var pageElements = this.elements.get(this.page.id);
        /** @type {?} */
        var isElementPageFlowModifier = false;
        /** @type {?} */
        var elementPageFlowModifier;
        pageElements.forEach(function (element, key) {
            if (element.question.pageFlowModifier) {
                isElementPageFlowModifier = true;
                elementPageFlowModifier = element;
            }
        });
        if (isElementPageFlowModifier && !!elementPageFlowModifier) {
            /** @type {?} */
            var elementOptionAnswers = this.optionAnswers.get(elementPageFlowModifier.id);
            /** @type {?} */
            var isPageFlowModifier_1 = false;
            /** @type {?} */
            var optionAnswersPageFlowModifier_1;
            elementOptionAnswers.forEach(function (optionAnswer, key) {
                if (elementPageFlowModifier.question.answer === optionAnswer.value && optionAnswer.pageFlow.label === 'pageFlow.goToPage') {
                    isPageFlowModifier_1 = true;
                    optionAnswersPageFlowModifier_1 = optionAnswer.pageFlow;
                }
            });
            if (isPageFlowModifier_1 && !!optionAnswersPageFlowModifier_1) {
                return optionAnswersPageFlowModifier_1;
            }
        }
        return null;
    };
    /**
     * @return {?}
     */
    NgSurveyViewerComponent.prototype.getCurrentPageUrlId = /**
     * @return {?}
     */
    function () {
        /** @type {?} */
        var pageUrlArray = this.router.url.split('/');
        return pageUrlArray.pop();
    };
    /**
     * @return {?}
     */
    NgSurveyViewerComponent.prototype.checkSurveyEmpty = /**
     * @return {?}
     */
    function () {
        if (this.elements.size === 1) {
            if (this.page) {
                /** @type {?} */
                var elements = this.elements.get(this.page.id);
                if (elements.size === 1) {
                    /** @type {?} */
                    var element = elements.values().next().value;
                    if (element.question.type === '' || element.question.type === null) {
                        return true;
                    }
                }
            }
            else {
                return true;
            }
        }
        return false;
    };
    NgSurveyViewerComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ngs-survey-viewer',
                    template: "<div *ngIf=\"isLoading\" class=\"h-100\">\n  <ngs-loader [isInherit]=\"true\"></ngs-loader>\n</div>\n\n<div *ngIf=\"!isLoading && !isSurveyEmpty\" class=\"card\">\n  <!-- Card Header -->\n  <div class=\"card-header d-flex w-100\">\n    <div class=\"mr-auto d-flex flex-row\">\n      <span *ngIf=\"!showSummary\">Page {{page?.orderNo}} of {{pageSize}}</span>\n      <span *ngIf=\"showSummary\">Survey Summary</span>\n    </div>\n  </div>\n  <!-- #/Card Header -->\n\n  <!-- Card Body -->\n  <div class=\"card-body\">\n    <div *ngIf=\"!showSummary\">\n      <ngs-page-viewer-container\n        [page]=\"page\"\n      ></ngs-page-viewer-container>\n    </div>\n    <div *ngIf=\"showSummary\">\n      <ngs-paragraph-summary-viewer\n        [html]=\"survey.summary\"\n      ></ngs-paragraph-summary-viewer>\n    </div>\n  </div>\n  <!-- #/Card Body -->\n\n  <!-- Card Footer -->\n  <div class=\"card-footer d-flex w-100\">\n    <div class=\"mr-auto\">\n      <button type=\"button\" class=\"btn btn-primary btn-lg\" [disabled]=\"isPrevPageEmpty\" (click)=\"prevPage()\">Back</button>\n    </div>\n    <div class=\"ml-auto\">\n      <!--[disabled]=\"!pageNext\"-->\n      <button type=\"button\" class=\"btn btn-primary btn-lg\" [disabled]=\"isNextPageEmpty\" (click)=\"nextPage()\">Next</button>\n    </div>\n  </div>\n  <!-- #/Card Footer -->\n</div>\n\n<div *ngIf=\"isSurveyEmpty\">\n  <h1>No Survey Data</h1>\n</div>\n",
                    styles: [""]
                }] }
    ];
    /** @nocollapse */
    NgSurveyViewerComponent.ctorParameters = function () { return [
        { type: NgSurveyStore },
        { type: Router },
        { type: NgSurveyViewerNavigationService }
    ]; };
    return NgSurveyViewerComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgSurveyViewerModule = /** @class */ (function () {
    function NgSurveyViewerModule() {
    }
    NgSurveyViewerModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        CommonModule,
                        RouterModule,
                        BrowserAnimationsModule,
                        SharedCommonModule,
                        BuilderModule
                    ],
                    declarations: [NgSurveyViewerComponent],
                    exports: [NgSurveyViewerComponent]
                },] }
    ];
    return NgSurveyViewerModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgModelViewerComponent = /** @class */ (function () {
    function NgModelViewerComponent(_ngSurveyStore) {
        this._ngSurveyStore = _ngSurveyStore;
    }
    /**
     * @return {?}
     */
    NgModelViewerComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        this.surveyModel$ = this._ngSurveyStore.ngSurveyState;
    };
    NgModelViewerComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ngs-model-viewer',
                    template: "<pre>{{surveyModel$ | async | json}}</pre>\n",
                    styles: [""]
                }] }
    ];
    /** @nocollapse */
    NgModelViewerComponent.ctorParameters = function () { return [
        { type: NgSurveyStore }
    ]; };
    return NgModelViewerComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgModelViewerModule = /** @class */ (function () {
    function NgModelViewerModule() {
    }
    NgModelViewerModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        CommonModule
                    ],
                    declarations: [NgModelViewerComponent],
                    exports: [NgModelViewerComponent]
                },] }
    ];
    return NgModelViewerModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgSurveysModule = /** @class */ (function () {
    function NgSurveysModule() {
    }
    NgSurveysModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        NgBuilderViewerModule,
                        NgSurveyViewerModule,
                        NgSurveyViewerModule,
                        NgModelViewerModule,
                    ],
                    declarations: [],
                    providers: [NgSurveyStore, SurveyReducer, PagesReducer, ElementsReducer, OptionAnswersReducer, BuilderOptionsReducer],
                    exports: [
                        NgBuilderViewerModule,
                        NgSurveyViewerModule,
                        NgModelViewerModule,
                    ]
                },] }
    ];
    return NgSurveysModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { NgBuilderViewerComponent, NgBuilderViewerModule, NgSurveyViewerComponent, NgSurveyViewerModule, NgModelViewerComponent, NgModelViewerModule, Page, Elements, OptionAnswers, PageFlow, Paragraph, Question, BuilderOptionsModel, NgSurveysService, NgSurveysModule, BuilderModule as ɵi, QuestionBuilderComponent as ɵp, QuestionBuilderDirective as ɵo, QuestionBuilderService as ɵj, CheckboxComponent as ɵt, DateComponent as ɵm, EditorComponent as ɵbf, LongTextComponent as ɵl, OptionTemplateComponent as ɵq, ParagraphComponent as ɵbe, RadioCheckboxSelectComponent as ɵr, RadioComponent as ɵu, RangeComponent as ɵn, SelectComponent as ɵs, ShortTextComponent as ɵk, PageBuilderContainerComponent as ɵv, PageViewerContainerComponent as ɵw, QuestionBuilderContainerComponent as ɵx, QuestionInputComponent as ɵy, QuestionViewerContainerComponent as ɵz, SummaryContainerComponent as ɵba, SurveyParagraphViewerComponent as ɵbd, SurveyTemplateFormComponent as ɵbc, LoaderComponent as ɵh, PageSelectComponent as ɵd, MapValuesPipe as ɵc, SharedCommonModule as ɵb, BuilderOptionsReducer as ɵbg, ElementsReducer as ɵf, NgSurveyStore as ɵa, OptionAnswersReducer as ɵg, PagesReducer as ɵe, SurveyReducer as ɵbb, NgSurveyViewerNavigationService as ɵbh };

//# sourceMappingURL=ng-surveys.js.map